/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.core.runtime.IStatus;
/*     */ import org.eclipse.core.runtime.Status;
/*     */ import org.eclipse.debug.core.DebugEvent;
/*     */ import org.eclipse.debug.core.DebugException;
/*     */ import org.eclipse.debug.core.DebugPlugin;
/*     */ import org.eclipse.debug.core.IDebugEventSetListener;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.model.RuntimeProcess;
/*     */ import org.eclipse.jface.resource.ImageDescriptor;
/*     */ import org.eclipse.swt.widgets.Display;
/*     */ import org.eclipse.ui.IPerspectiveDescriptor;
/*     */ import org.eclipse.ui.IWorkbench;
/*     */ import org.eclipse.ui.IWorkbenchPage;
/*     */ import org.eclipse.ui.IWorkbenchWindow;
/*     */ import org.eclipse.ui.PlatformUI;
/*     */ import org.eclipse.ui.WorkbenchException;
/*     */ import org.eclipse.ui.plugin.AbstractUIPlugin;
/*     */ import org.osgi.framework.BundleContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class Activator
/*     */   extends AbstractUIPlugin
/*     */ {
/*     */   public static final String PLUGIN_ID = "com.st.stm32cube.ide.mcu.debug.launch";
/*     */   private static Activator plugin;
/*     */   
/*     */   public class DebugEventListener
/*     */     implements IDebugEventSetListener
/*     */   {
/*     */     private boolean inDebug = false;
/*     */     
/*     */     public void handleDebugEvents(DebugEvent[] events) {
/*  47 */       if (events == null) {
/*     */         return;
/*     */       }
/*     */       
/*  51 */       for (int i = 0; i < events.length; i++) {
/*  52 */         DebugEvent event = events[i];
/*     */ 
/*     */         
/*  55 */         if (event.getKind() == 8) {
/*  56 */           Object eventSource = event.getSource();
/*     */           
/*  58 */           if (eventSource == null) {
/*     */             return;
/*     */           }
/*     */           
/*  62 */           if (eventSource instanceof org.eclipse.cdt.dsf.gdb.launching.GDBProcess) {
/*     */             
/*  64 */             ILaunch launch = ((RuntimeProcess)eventSource).getLaunch();
/*     */             
/*  66 */             if (launch == null) {
/*     */               return;
/*     */             }
/*     */             
/*  70 */             if (launch instanceof GdbLaunch) {
/*  71 */               GdbLaunch cTarget = (GdbLaunch)launch;
/*  72 */               if (cTarget.canTerminate()) {
/*     */                 try {
/*  74 */                   cTarget.terminate();
/*     */                 }
/*  76 */                 catch (DebugException e) {
/*  77 */                   e.printStackTrace();
/*  78 */                   Activator.getDefault().getLog().log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to terminate launch: " + cTarget, (Throwable)e));
/*     */                 } 
/*     */               }
/*     */             } 
/*     */           } 
/*     */ 
/*     */           
/*  85 */           if (inDebugPerspective() && noActiveSessions())
/*     */           {
/*  87 */             Display.getDefault().asyncExec(new Runnable()
/*     */                 {
/*     */                   public void run() {
/*     */                     try {
/*  91 */                       IWorkbench workbench = PlatformUI.getWorkbench();
/*  92 */                       if (workbench != null) {
/*  93 */                         IWorkbenchWindow activeWorkbenchWindow = workbench.getActiveWorkbenchWindow();
/*  94 */                         if (activeWorkbenchWindow != null) {
/*  95 */                           workbench.showPerspective("org.eclipse.cdt.ui.CPerspective", activeWorkbenchWindow);
/*     */                         }
/*     */                       } 
/*  98 */                     } catch (WorkbenchException e) {
/*  99 */                       Activator.getDefault().getLog().log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to switch to the C/C++ perspective", (Throwable)e));
/*     */                     } 
/*     */                   }
/*     */                 });
/*     */           }
/*     */         } 
/*     */       } 
/*     */     }
/*     */ 
/*     */     
/*     */     private boolean noActiveSessions() {
/* 110 */       ILaunch[] launches = DebugPlugin.getDefault().getLaunchManager().getLaunches();
/*     */       
/* 112 */       if (launches == null) {
/* 113 */         return true;
/*     */       }
/*     */       
/* 116 */       for (int i = 0; i < launches.length; i++) {
/* 117 */         if (!launches[i].isTerminated()) {
/* 118 */           return false;
/*     */         }
/*     */       } 
/* 121 */       return true;
/*     */     }
/*     */ 
/*     */ 
/*     */     
/*     */     private boolean inDebugPerspective() {
/* 127 */       Runnable checkDebug = new Runnable()
/*     */         {
/*     */           public void run() {
/* 130 */             IWorkbench workbench = PlatformUI.getWorkbench();
/* 131 */             if (workbench != null) {
/* 132 */               IWorkbenchWindow activeWorkbenchWindow = workbench.getActiveWorkbenchWindow();
/* 133 */               if (activeWorkbenchWindow != null) {
/* 134 */                 IWorkbenchPage activePage = activeWorkbenchWindow.getActivePage();
/* 135 */                 if (activePage != null) {
/* 136 */                   IPerspectiveDescriptor perspective = activePage.getPerspective();
/* 137 */                   if (perspective != null) {
/* 138 */                     String id = perspective.getId();
/* 139 */                     if (id != null) {
/* 140 */                       Activator.DebugEventListener.this.inDebug = id.equals("org.eclipse.debug.ui.DebugPerspective");
/*     */                     }
/*     */                   } 
/*     */                 } 
/*     */               } 
/*     */             } 
/*     */           }
/*     */         };
/*     */       
/* 149 */       Display.getDefault().syncExec(checkDebug);
/*     */ 
/*     */ 
/*     */       
/* 153 */       return this.inDebug;
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Activator() {
/* 168 */     DebugPlugin dp = DebugPlugin.getDefault();
/*     */     
/* 170 */     dp.addDebugEventListener(new DebugEventListener());
/*     */   }
/*     */ 
/*     */   
/*     */   public void start(BundleContext context) throws Exception {
/* 175 */     super.start(context);
/* 176 */     plugin = this;
/*     */   }
/*     */ 
/*     */   
/*     */   public void stop(BundleContext context) throws Exception {
/* 181 */     plugin = null;
/* 182 */     super.stop(context);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Activator getDefault() {
/* 191 */     return plugin;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static String getUniqueIdentifier() {
/* 198 */     return "com.st.stm32cube.ide.mcu.debug.launch";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static void log(IStatus status) {
/* 207 */     getDefault().getLog().log(status);
/*     */   }
/*     */   
/*     */   public static BundleContext getBundleContext() {
/* 211 */     return getDefault().getBundle().getBundleContext();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static ImageDescriptor getImageDescriptor(String path) {
/* 222 */     return imageDescriptorFromPlugin("com.st.stm32cube.ide.mcu.debug.launch", path);
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\Activator.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */