/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.st.stm32cube.common.ecosystemintegration.core.MCUEcoSystemIntegrationHelper;
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.common.utils.ThreadHelper;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.export.HardwareDebugUtil;
/*     */ import com.st.stm32cube.ide.mcu.toolchain.ui.ToolChainHelper;
/*     */ import java.util.List;
/*     */ import java.util.concurrent.atomic.AtomicBoolean;
/*     */ import org.eclipse.cdt.dsf.concurrent.Sequence;
/*     */ import org.eclipse.cdt.dsf.debug.service.IDsfDebugServicesFactory;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunchDelegate;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.cdt.managedbuilder.core.IConfiguration;
/*     */ import org.eclipse.cdt.managedbuilder.core.IManagedBuildInfo;
/*     */ import org.eclipse.cdt.managedbuilder.core.IManagedProject;
/*     */ import org.eclipse.cdt.managedbuilder.core.ManagedBuildManager;
/*     */ import org.eclipse.core.resources.IMarker;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.resources.IResource;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IProgressMonitor;
/*     */ import org.eclipse.core.runtime.SubMonitor;
/*     */ import org.eclipse.debug.core.DebugPlugin;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.model.ISourceLocator;
/*     */ import org.eclipse.debug.ui.DebugUITools;
/*     */ import org.eclipse.jface.dialogs.MessageDialog;
/*     */ import org.eclipse.osgi.util.NLS;
/*     */ import org.eclipse.swt.widgets.Display;
/*     */ import org.eclipse.ui.PlatformUI;
/*     */ import org.eclipse.ui.WorkbenchException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DSFDelegate
/*     */   extends GdbLaunchDelegate
/*     */ {
/*     */   private boolean continueLaunch;
/*     */   
/*     */   protected GdbLaunch createGdbLaunch(ILaunchConfiguration configuration, String mode, ISourceLocator locator) throws CoreException {
/*  67 */     return new MCUGdbLaunch(configuration, mode, locator);
/*     */   }
/*     */ 
/*     */   
/*     */   protected String getCLILabel(GdbLaunch launch, ILaunchConfiguration config, String gdbVersion) throws CoreException {
/*  72 */     String label = super.getCLILabel(launch, config, gdbVersion);
/*     */ 
/*     */     
/*  75 */     label = label.replace("${TOOLCHAIN_PATH}/", "");
/*     */ 
/*     */     
/*  78 */     if (label.startsWith("arm-none-eabi-gdb")) {
/*  79 */       IConfiguration buildConfig = MCUDebugPlugin.getConfigFromDebugLaunch(config);
/*  80 */       label = label.replace("arm-none-eabi-gdb", ToolChainHelper.getPrefixedCommand(buildConfig, "gdb"));
/*     */     } 
/*     */     
/*  83 */     return label;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected IDsfDebugServicesFactory newServiceFactory(ILaunchConfiguration config, String version) {
/*  92 */     return (IDsfDebugServicesFactory)new HardwareDebugServiceFactory(version, config);
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean preLaunchCheck(ILaunchConfiguration configuration, String mode, IProgressMonitor monitor) throws CoreException {
/*  98 */     if (!ToolChainHelper.validateDebugLaunch(configuration, true, true)) {
/*  99 */       return false;
/*     */     }
/*     */ 
/*     */     
/* 103 */     boolean configSupported = HardwareDebugUtil.checkConfigSupported(configuration);
/* 104 */     if (!configSupported) {
/* 105 */       String msg = String.valueOf(Messages.DSFDelegate_MSG_debugConfigNotCompatible_part_1) + configuration.getName() + Messages.DSFDelegate_MSG_debugConfigNotCompatible_part_2;
/* 106 */       showInfo(Messages.DSFDelegate_stm32CortexMCCPPApplication, msg);
/* 107 */       return false;
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 117 */     if (DebugUITools.getPreferenceStore().getBoolean("org.eclipse.debug.ui.RelaunchAndTerminateLaunchAction")) {
/*     */       
/* 119 */       long time1 = System.currentTimeMillis();
/*     */       
/* 121 */       while (checkConfigRunning(configuration)) {
/* 122 */         if (System.currentTimeMillis() - time1 > 10000L) {
/* 123 */           showError(NLS.bind("Lauching {0}", configuration.getName()), "Termination of previous launch did not complete successfully.");
/* 124 */           return false;
/*     */         } 
/*     */         
/*     */         try {
/* 128 */           Thread.sleep(200L);
/* 129 */           if (!monitor.isCanceled()) {
/*     */             continue;
/*     */           }
/* 132 */         } catch (InterruptedException interruptedException) {}
/*     */ 
/*     */ 
/*     */         
/* 136 */         return false;
/*     */       } 
/*     */     } else {
/*     */       
/* 140 */       boolean configRunning = checkConfigRunning(configuration);
/* 141 */       if (configRunning) {
/* 142 */         String msg = String.valueOf(Messages.DSFDelegate_ERROR_debugConfigIsRunning_part_1) + configuration.getName() + Messages.DSFDelegate_ERROR_debugConfigIsRunning_part_2;
/* 143 */         showError(Messages.DSFDelegate_stm32CortexMCCPPApplication, msg);
/*     */ 
/*     */         
/* 146 */         ThreadHelper.runInUiThreadAsync(() -> {
/*     */               try {
/*     */                 PlatformUI.getWorkbench().showPerspective("org.eclipse.debug.ui.DebugPerspective", PlatformUI.getWorkbench().getActiveWorkbenchWindow());
/* 149 */               } catch (WorkbenchException e) {
/*     */                 MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to show debug perspective");
/*     */               } 
/*     */             });
/*     */         
/* 154 */         return false;
/*     */       } 
/*     */     } 
/*     */     
/* 158 */     IMxUGDBServer server = HardwareDebugUtil.getServer(configuration).orElse(null);
/* 159 */     if (server != null) {
/*     */       try {
/* 161 */         if (!server.preLaunchCheck(configuration)) {
/* 162 */           return false;
/*     */         }
/* 164 */       } catch (CoreException e) {
/* 165 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "GDB-server pre launch check failed");
/* 166 */         throw e;
/*     */       } 
/*     */     }
/*     */     
/* 170 */     IProject project = MCUDebugPlugin.getProject(configuration);
/*     */     
/* 172 */     if (MCUDebugPlugin.isDebugDeviceLessProject(configuration).booleanValue()) {
/* 173 */       MCULoggerPlugin.infoDialog(Activator.getUniqueIdentifier(), 
/* 174 */           String.format(Messages.DebugContextChecker_DebugDeviceLessUnSupportedDebugProcess_Dialog_Title, new Object[] {
/* 175 */               MCUDebugPlugin.getTargetFromConfig(configuration).getName()
/* 176 */             }), String.format(Messages.DebugContextChecker_DebugDeviceLessUnSupportedDebugProcess_Dialog_Txt, new Object[] { configuration.getName(), 
/* 177 */               MCUDebugPlugin.getTargetFromConfig(configuration).getName() }));
/* 178 */       return false;
/*     */     } 
/*     */ 
/*     */     
/* 182 */     if (project.hasNature("com.st.stm32cube.ide.mcu.MCUCubeProjectNature"))
/*     */     {
/*     */ 
/*     */       
/* 186 */       if (!MCUEcoSystemIntegrationHelper.getIocGenerator().isIocInSyncWithSourceCode(project)) {
/* 187 */         boolean doDebug = MCULoggerPlugin.openConfirmDialog(Activator.getUniqueIdentifier(), 
/* 188 */             String.format(Messages.DebugContextChecker_ConfirmDebug_Dialog_Title, new Object[] { project.getName()
/* 189 */               }), String.format(Messages.DebugContextChecker_UnSyncedIocFile_Dialog_Txt, new Object[] {
/* 190 */                 MCUEcoSystemIntegrationHelper.getIocGenerator().getIocHandle(project).getName()
/*     */               }));
/* 192 */         if (!doDebug)
/* 193 */           return false; 
/*     */       } 
/*     */     }
/*     */     byte b;
/*     */     int i;
/*     */     IPreLaunch[] arrayOfIPreLaunch;
/* 199 */     for (i = (arrayOfIPreLaunch = DebugLaunchRegistry.getInstance().getOrderedPreLaunches()).length, b = 0; b < i; ) { IPreLaunch c = arrayOfIPreLaunch[b];
/* 200 */       if (c.isLaunchConfigurationSupported(configuration) && !c.preLaunchCheck(configuration, mode, monitor)) {
/* 201 */         return false;
/*     */       }
/*     */       b++; }
/*     */     
/* 205 */     return super.preLaunchCheck(configuration, mode, monitor);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean buildForLaunch(ILaunchConfiguration configuration, String mode, IProgressMonitor monitor) throws CoreException {
/* 214 */     this.continueLaunch = true;
/*     */     
/* 216 */     LoadListInfo info = LoadListInfo.parseLoadListInfo(configuration.getAttributes()).orElse(null);
/* 217 */     if (info != null) {
/* 218 */       boolean retVal = false;
/* 219 */       List<LoadListInfo.LoadListItem> items = info.getInternalItems();
/* 220 */       int numToBuild = (int)items.stream().filter(i -> i.shouldPerformBuild().booleanValue()).count();
/* 221 */       SubMonitor submon = SubMonitor.convert(monitor, "", numToBuild);
/*     */       
/* 223 */       for (LoadListInfo.LoadListItem item : items) {
/* 224 */         if (item.isFromMainTab().booleanValue()) {
/* 225 */           retVal = super.buildForLaunch(configuration, mode, (IProgressMonitor)submon);
/* 226 */           this.continueLaunch = super.finalLaunchCheck(configuration, mode, (IProgressMonitor)submon);
/* 227 */         } else if (item.shouldPerformBuild().booleanValue()) {
/* 228 */           String projectName = item.getProjectName();
/* 229 */           String buildConfigId = item.getBuildConfigId();
/* 230 */           if (projectName != null && !projectName.isEmpty() && buildConfigId != null && !buildConfigId.isEmpty()) {
/* 231 */             IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject(projectName);
/* 232 */             if (project != null && project.exists()) {
/* 233 */               buildProject(project, buildConfigId, (IProgressMonitor)submon);
/* 234 */               this.continueLaunch = finalLaunchCheck(project, buildConfigId);
/*     */             } else {
/* 236 */               MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "Bad load list item, marked as should perform build, but no valid project exists for project name " + projectName);
/*     */             } 
/*     */           } else {
/* 239 */             MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "Bad load list item, marked as should perform build, but missing either project name: " + projectName + " or build config id: " + buildConfigId);
/*     */           } 
/*     */         } 
/*     */         
/* 243 */         if (!this.continueLaunch) {
/*     */           break;
/*     */         }
/*     */       } 
/*     */       
/* 248 */       return retVal;
/*     */     } 
/* 250 */     return super.buildForLaunch(configuration, mode, monitor);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean finalLaunchCheck(IProject project, String buildConfigId) throws CoreException {
/* 263 */     boolean ret = true;
/*     */     
/* 265 */     if (existsProblems(project)) {
/*     */       
/* 267 */       String failedBuildCfgName = "Unknown";
/*     */ 
/*     */       
/* 270 */       IManagedBuildInfo failedBuildInfo = ManagedBuildManager.getBuildInfo((IResource)project);
/* 271 */       if (failedBuildInfo != null) {
/* 272 */         IManagedProject manProj = failedBuildInfo.getManagedProject();
/* 273 */         if (manProj != null) {
/* 274 */           IConfiguration bCfg = manProj.getConfiguration(buildConfigId);
/* 275 */           if (bCfg != null) {
/* 276 */             failedBuildCfgName = bCfg.getName();
/*     */           }
/*     */         } 
/*     */       } 
/*     */ 
/*     */       
/* 282 */       String finalFailedBuildCfgName = failedBuildCfgName;
/* 283 */       AtomicBoolean proceedQuestion = new AtomicBoolean(false);
/* 284 */       ThreadHelper.runInUiThreadSync(() -> paramAtomicBoolean.set((MessageDialog.open(3, Display.getDefault().getActiveShell(), "Errors in Workspace", "Errors exists in configuration " + paramString + " of project " + paramIProject.getName() + ". Proceed with launch?", 0, new String[] { "Proceed", "Cancel" }) == 0)));
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 293 */       ret = proceedQuestion.get();
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 300 */     return ret;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean finalLaunchCheck(ILaunchConfiguration configuration, String mode, IProgressMonitor monitor) throws CoreException {
/* 309 */     return this.continueLaunch;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void showInfo(String title, String msg) {
/* 318 */     ThreadHelper.runInUiThreadSync(() -> MessageDialog.openInformation(Display.getDefault().getActiveShell(), paramString1, paramString2));
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public void launch(ILaunchConfiguration config, String mode, ILaunch launch, IProgressMonitor monitor) throws CoreException {
/* 324 */     if (mode.equals("run")) {
/*     */       
/* 326 */       super.launch(config, "debug", launch, monitor);
/*     */     } else {
/* 328 */       super.launch(config, mode, launch, monitor);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void showError(String title, String msg) {
/* 338 */     ThreadHelper.runInUiThreadSync(() -> MessageDialog.openError(Display.getDefault().getActiveShell(), paramString1, paramString2));
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean checkConfigRunning(ILaunchConfiguration config) {
/*     */     try {
/* 348 */       ILaunch[] launches = DebugPlugin.getDefault().getLaunchManager().getLaunches();
/*     */ 
/*     */ 
/*     */ 
/*     */       
/* 353 */       int count = 0; byte b; int i;
/*     */       ILaunch[] arrayOfILaunch1;
/* 355 */       for (i = (arrayOfILaunch1 = launches).length, b = 0; b < i; ) { ILaunch launch = arrayOfILaunch1[b];
/*     */         
/* 357 */         count++;
/* 358 */         if (!launch.isTerminated() && launch.getLaunchConfiguration().getName().equals(config.getName()) && count > 1) {
/* 359 */           return true;
/*     */         }
/*     */         b++; }
/*     */     
/* 363 */     } catch (NullPointerException e) {
/* 364 */       return false;
/*     */     } 
/* 366 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected boolean existsProblems(IProject proj) throws CoreException {
/* 375 */     IMarker[] markers = proj.findMarkers("org.eclipse.cdt.core.problem", true, 2);
/*     */     
/* 377 */     if (markers.length > 0) {
/* 378 */       byte b; int i; IMarker[] arrayOfIMarker; for (i = (arrayOfIMarker = markers).length, b = 0; b < i; ) { IMarker marker = arrayOfIMarker[b];
/* 379 */         Integer severity = (Integer)marker.getAttribute("severity");
/* 380 */         if (severity != null && 
/* 381 */           severity.intValue() >= 2) {
/* 382 */           return true;
/*     */         }
/*     */         b++; }
/*     */     
/*     */     } 
/* 387 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected Sequence getServicesSequence(DsfSession session, ILaunch launch, IProgressMonitor rm) {
/* 398 */     if (launch instanceof GdbLaunch) {
/* 399 */       return (Sequence)new DSFServicesLaunchSequence(session, (GdbLaunch)launch, rm);
/*     */     }
/* 401 */     return super.getServicesSequence(session, launch, rm);
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\DSFDelegate.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */