/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import java.util.Map;
/*     */ import java.util.concurrent.Executor;
/*     */ import org.eclipse.cdt.debug.gdbjtag.core.GDBJtagDSFFinalLaunchSequence_7_12;
/*     */ import org.eclipse.cdt.dsf.concurrent.ReflectionSequence.Execute;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitorWithProgress;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class GDBExtendedJtagDSFFinalLaunchSequence_7_12
/*     */   extends GDBJtagDSFFinalLaunchSequence_7_12
/*     */ {
/*     */   private final GdbLaunch fLaunch;
/*     */   
/*     */   public GDBExtendedJtagDSFFinalLaunchSequence_7_12(DsfSession session, Map<String, Object> attributes, RequestMonitorWithProgress rm) {
/*  24 */     super(session, attributes, rm);
/*  25 */     this.fLaunch = (GdbLaunch)getSession().getModelAdapter(ILaunch.class);
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   protected String[] getExecutionOrder(String group) {
/*  31 */     if ("GROUP_JTAG".equals(group)) {
/*  32 */       LaunchSequenceStepList seq = new LaunchSequenceStepList(super.getExecutionOrder(group));
/*     */       
/*  34 */       seq.addAfter("stepResetBoard", new String[] { "stepRestartInit" });
/*  35 */       seq.addAfter("stepUserInitCommands", new String[] { "stepStartSwvSession" });
/*  36 */       seq.addBefore("stepUserInitCommands", new String[] { "stepPreInitCommands" });
/*  37 */       seq.addBefore("stepUserDebugCommands", new String[] { "stepPreDebugCommands" });
/*  38 */       seq.addAfter("stepConnectToTarget", new String[] { "stepValidateJEP", "stepConnectToSecondaryGDB" });
/*     */       
/*  40 */       seq.addAfter("stepLoadSymbols", new String[] { "stepLoadSecondaryGDBSymbols" });
/*  41 */       seq.addAfter("stepStartTrackingBreakpoints", new String[] { "stepSetupExceptions" });
/*  42 */       seq.addAfter("stepLoadImage", new String[] { "stepConfigureSwv" });
/*     */       
/*  44 */       if (this.fLaunch.getLaunchMode().equals("run")) {
/*  45 */         seq.truncateAfter("stepLoadImage");
/*  46 */         seq.addLast(new String[] { "stepSetProgramCounter", "stepHandleRunMode" });
/*     */       } 
/*     */       
/*  49 */       return seq.toArray();
/*  50 */     }  if ("GROUP_TOP_LEVEL".equals(group)) {
/*  51 */       LaunchSequenceStepList seq = new LaunchSequenceStepList(super.getExecutionOrder(group));
/*     */       
/*  53 */       seq.addAfter("stepSourceGDBInitFile", new String[] { "stepSecondarySourceGDBInitFile" });
/*  54 */       seq.addAfter("stepInitializeFinalLaunchSequence", new String[] { "stepPreLaunch", "stepGenerateGDBServerStartFiles", "stepStartGDBServer" });
/*  55 */       seq.addAfter("stepStartGDBServer", new String[] { "stepStartGDBProxy" });
/*  56 */       return seq.toArray();
/*     */     } 
/*     */     
/*  59 */     return super.getExecutionOrder(group);
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepLoadSymbols(RequestMonitor rm) {
/*  65 */     LaunchSequenceUtil.stepLoadSymbols(rm, this.fLaunch, getExecutor(), getAttributes(), this::access$0);
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepLoadImage(RequestMonitor rm) {
/*  71 */     LaunchSequenceUtil.stepLoadImage(rm, this.fLaunch, getExecutor(), getAttributes(), this::access$1);
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepSetProgramCounter(RequestMonitor rm) {
/*  77 */     LaunchSequenceUtil.stepSetProgramCounter(rm, this.fLaunch, getExecutor(), this::access$2);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepConfigureSwv(RequestMonitor rm) {
/*  82 */     LaunchSequenceUtil.stepConfigureSwv(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepHandleRunMode(RequestMonitor rm) {
/*  87 */     LaunchSequenceUtil.stepHandleRunMode(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepPreLaunch(RequestMonitor rm) {
/*  92 */     LaunchSequenceUtil.stepPreLaunch(rm, this.fLaunch);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepGenerateGDBServerStartFiles(RequestMonitor rm) {
/*  97 */     LaunchSequenceUtil.stepGenerateGDBServerStartFiles(rm, this.fLaunch);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepStartGDBServer(RequestMonitor rm) {
/* 102 */     LaunchSequenceUtil.stepStartGDBServer(rm, this.fLaunch);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepStartGDBProxy(RequestMonitor rm) {
/* 107 */     LaunchSequenceUtil.stepStartGdbProxy(rm, this.fLaunch, getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepValidateJEP(RequestMonitor rm) {
/* 112 */     LaunchSequenceUtil.stepValidateJEP(rm, this.fLaunch, (Executor)getExecutor());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepLoadSecondaryGDBSymbols(RequestMonitor rm) {
/* 117 */     LaunchSequenceUtil.stepLoadSecondaryGDBSymbols(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepConnectToTarget(RequestMonitor rm) {
/* 123 */     LaunchSequenceUtil.stepConnectToTarget(rm, this.fLaunch, getExecutor(), getAttributes(), this::access$3);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepConnectToSecondaryGDB(RequestMonitor rm) {
/* 128 */     LaunchSequenceUtil.stepConnectToSecondaryGDB(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepStartSwvSession(RequestMonitor rm) {
/* 133 */     LaunchSequenceUtil.stepStartSwvSession(rm, this.fLaunch);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepSetupExceptions(RequestMonitor rm) {
/* 138 */     LaunchSequenceUtil.stepSetupExceptions(rm, this.fLaunch, getExecutor());
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepResetBoard(RequestMonitor rm) {
/* 144 */     LaunchSequenceUtil.stepResetBoard(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepRestartInit(RequestMonitor rm) {
/* 149 */     LaunchSequenceUtil.stepRestartInit(rm, this.fLaunch);
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepPreInitCommands(RequestMonitor rm) {
/* 154 */     LaunchSequenceUtil.stepPreInitCommands(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepPreDebugCommands(RequestMonitor rm) {
/* 159 */     LaunchSequenceUtil.stepPreDebugCommands(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepSecondarySourceGDBInitFile(RequestMonitor rm) {
/* 164 */     LaunchSequenceUtil.stepSecondarySourceGDBInitFile(rm, this.fLaunch, getExecutor(), getAttributes());
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\GDBExtendedJtagDSFFinalLaunchSequence_7_12.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */