/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.dsf.mi.commands.HardwareDebugCommandFactory;
/*     */ import com.st.stm32cube.ide.mcu.debug.dsf.mi.commands.HardwareDebugCommandFactory_6_8;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.IPrimaryGDBLiveDataService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryCommandControl;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryGDBBackend;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryGDBLiveDataService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.PrimaryGDBLiveDataService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryGDBBackend;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryGDBBackend_7_12;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryGDBLiveDataService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl_7_0;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl_7_12;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl_7_2;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl_7_4;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.SecondaryHardwareDebugGDBControl_7_7;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.IRestartConfigurationsService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.IRestartService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.RestartConfigurationsService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.RestartService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.secureState.ISecureStateService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.secureState.SecureStateService;
/*     */ import org.eclipse.cdt.dsf.debug.service.command.ICommandControl;
/*     */ import org.eclipse.cdt.dsf.gdb.service.GdbDebugServicesFactory;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.CommandFactory;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class HardwareDebugServiceFactory
/*     */   extends GdbDebugServicesFactory
/*     */ {
/*     */   public HardwareDebugServiceFactory(String version, ILaunchConfiguration config) {
/*  42 */     super(version, config);
/*     */   }
/*     */ 
/*     */   
/*     */   protected ICommandControl createCommandControl(DsfSession session, ILaunchConfiguration config) {
/*  47 */     if (compareVersionWith("7.12") >= 0)
/*  48 */       return (ICommandControl)new HardwareDebugGDBControl_7_12(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/*  49 */     if (compareVersionWith("7.7") >= 0)
/*  50 */       return (ICommandControl)new HardwareDebugGDBControl_7_7(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/*  51 */     if (compareVersionWith("7.4") >= 0)
/*  52 */       return (ICommandControl)new HardwareDebugGDBControl_7_4(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/*  53 */     if (compareVersionWith("7.2") >= 0)
/*  54 */       return (ICommandControl)new HardwareDebugGDBControl_7_2(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/*  55 */     if (compareVersionWith("7.0") >= 0)
/*  56 */       return (ICommandControl)new HardwareDebugGDBControl_7_0(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/*  57 */     if (compareVersionWith("6.8") >= 0) {
/*  58 */       return (ICommandControl)new HardwareDebugGDBControl(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8());
/*     */     }
/*  60 */     return (ICommandControl)new HardwareDebugGDBControl(session, config, (CommandFactory)new HardwareDebugCommandFactory());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public <V> V createService(Class<V> clazz, DsfSession session, Object... optionalArguments) {
/*  67 */     if (IRestartService.class.isAssignableFrom(clazz)) {
/*  68 */       return (V)createRestartService(session);
/*     */     }
/*  70 */     if (IRestartConfigurationsService.class.isAssignableFrom(clazz)) {
/*  71 */       return (V)createRestartConfigurationsService(session);
/*     */     }
/*  73 */     if (ISecureStateService.class.isAssignableFrom(clazz)) {
/*  74 */       return (V)createSecureStateService(session);
/*     */     }
/*  76 */     if (ISecondaryGDBBackend.class.isAssignableFrom(clazz)) {
/*  77 */       byte b; int i; Object[] arrayOfObject; for (i = (arrayOfObject = optionalArguments).length, b = 0; b < i; ) { Object arg = arrayOfObject[b];
/*  78 */         if (arg instanceof ILaunchConfiguration) {
/*  79 */           return (V)createSecondaryGDBBackendService(session, (ILaunchConfiguration)arg);
/*     */         }
/*     */         b++; }
/*     */     
/*  83 */     } else if (ISecondaryCommandControl.class.isAssignableFrom(clazz)) {
/*  84 */       byte b; int i; Object[] arrayOfObject; for (i = (arrayOfObject = optionalArguments).length, b = 0; b < i; ) { Object arg = arrayOfObject[b];
/*  85 */         if (arg instanceof ILaunchConfiguration) {
/*  86 */           return (V)createSecondaryGDBCommandControlService(session, (ILaunchConfiguration)arg);
/*     */         }
/*     */         b++; }
/*     */     
/*  90 */     } else if (IPrimaryGDBLiveDataService.class.isAssignableFrom(clazz)) {
/*  91 */       byte b; int i; Object[] arrayOfObject; for (i = (arrayOfObject = optionalArguments).length, b = 0; b < i; ) { Object arg = arrayOfObject[b];
/*  92 */         if (arg instanceof ILaunchConfiguration) {
/*  93 */           return (V)createPrimaryGDBLiveDataService(session, (ILaunchConfiguration)arg);
/*     */         }
/*     */         b++; }
/*     */     
/*  97 */     } else if (ISecondaryGDBLiveDataService.class.isAssignableFrom(clazz)) {
/*  98 */       byte b; int i; Object[] arrayOfObject; for (i = (arrayOfObject = optionalArguments).length, b = 0; b < i; ) { Object arg = arrayOfObject[b];
/*  99 */         if (arg instanceof ILaunchConfiguration) {
/* 100 */           return (V)createSecondaryGDBLiveDataService(session, (ILaunchConfiguration)arg);
/*     */         }
/*     */         b++; }
/*     */     
/*     */     } 
/* 105 */     return (V)super.createService(clazz, session, optionalArguments);
/*     */   }
/*     */   
/*     */   private IPrimaryGDBLiveDataService createPrimaryGDBLiveDataService(DsfSession session, ILaunchConfiguration config) {
/* 109 */     return (IPrimaryGDBLiveDataService)new PrimaryGDBLiveDataService(session, config);
/*     */   }
/*     */   
/*     */   private ISecondaryGDBLiveDataService createSecondaryGDBLiveDataService(DsfSession session, ILaunchConfiguration config) {
/* 113 */     return (ISecondaryGDBLiveDataService)new SecondaryGDBLiveDataService(session, config);
/*     */   }
/*     */   
/*     */   private ISecondaryCommandControl createSecondaryGDBCommandControlService(DsfSession session, ILaunchConfiguration config) {
/* 117 */     if (compareVersionWith("7.12") >= 0)
/* 118 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl_7_12(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/* 119 */     if (compareVersionWith("7.7") >= 0)
/* 120 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl_7_7(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/* 121 */     if (compareVersionWith("7.4") >= 0)
/* 122 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl_7_4(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/* 123 */     if (compareVersionWith("7.2") >= 0)
/* 124 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl_7_2(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/* 125 */     if (compareVersionWith("7.0") >= 0)
/* 126 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl_7_0(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8()); 
/* 127 */     if (compareVersionWith("6.8") >= 0) {
/* 128 */       return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl(session, config, (CommandFactory)new HardwareDebugCommandFactory_6_8());
/*     */     }
/* 130 */     return (ISecondaryCommandControl)new SecondaryHardwareDebugGDBControl(session, config, (CommandFactory)new HardwareDebugCommandFactory());
/*     */   }
/*     */ 
/*     */   
/*     */   private ISecondaryGDBBackend createSecondaryGDBBackendService(DsfSession session, ILaunchConfiguration config) {
/* 135 */     if (compareVersionWith("7.12") >= 0) {
/* 136 */       return (ISecondaryGDBBackend)new SecondaryGDBBackend_7_12(session, config);
/*     */     }
/* 138 */     return (ISecondaryGDBBackend)new SecondaryGDBBackend(session, config);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private IRestartService createRestartService(DsfSession session) {
/* 148 */     return (IRestartService)new RestartService(session);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private IRestartConfigurationsService createRestartConfigurationsService(DsfSession session) {
/* 157 */     return (IRestartConfigurationsService)new RestartConfigurationsService(session);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private ISecureStateService createSecureStateService(DsfSession session) {
/* 166 */     return (ISecureStateService)new SecureStateService(session);
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\HardwareDebugServiceFactory.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */