/*      */ package com.st.stm32cube.ide.mcu.debug.launch;
/*      */ 
/*      */ import com.st.stm32cube.common.ecosystemintegration.core.CpuCoreEnum;
/*      */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*      */ import com.st.stm32cube.ide.common.utils.ThreadHelper;
/*      */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.device.GDBServerContributionFactory;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.export.HardwareDebugUtil;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryCommandControl;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryGDBBackend;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.proxycontribution.GdbProxyRegistry;
/*      */ import com.st.stm32cube.ide.mcu.debug.launch.proxycontribution.IGdbProxyContribution;
/*      */ import com.st.stm32cube.ide.mcu.debug.swv.core.SWVClient;
/*      */ import com.st.stm32cube.ide.mcu.debug.swv.core.SWVPlugin;
/*      */ import java.io.IOException;
/*      */ import java.net.URI;
/*      */ import java.net.URISyntaxException;
/*      */ import java.util.ArrayList;
/*      */ import java.util.List;
/*      */ import java.util.Map;
/*      */ import java.util.Optional;
/*      */ import java.util.concurrent.Executor;
/*      */ import java.util.stream.Collectors;
/*      */ import org.eclipse.cdt.debug.core.CDebugUtils;
/*      */ import org.eclipse.cdt.debug.gdbjtag.core.IGDBJtagConnection;
/*      */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.GDBJtagDeviceContribution;
/*      */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.IGDBJtagDevice;
/*      */ import org.eclipse.cdt.dsf.concurrent.CountingRequestMonitor;
/*      */ import org.eclipse.cdt.dsf.concurrent.DataRequestMonitor;
/*      */ import org.eclipse.cdt.dsf.concurrent.DsfExecutor;
/*      */ import org.eclipse.cdt.dsf.concurrent.ReflectionSequence.Execute;
/*      */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*      */ import org.eclipse.cdt.dsf.datamodel.IDMContext;
/*      */ import org.eclipse.cdt.dsf.debug.service.command.ICommand;
/*      */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*      */ import org.eclipse.cdt.dsf.gdb.service.IGDBBackend;
/*      */ import org.eclipse.cdt.dsf.gdb.service.command.IGDBControl;
/*      */ import org.eclipse.cdt.dsf.mi.service.IMICommandControl;
/*      */ import org.eclipse.cdt.dsf.mi.service.command.commands.CLICommand;
/*      */ import org.eclipse.cdt.dsf.mi.service.command.output.MIDataReadMemoryBytesInfo;
/*      */ import org.eclipse.cdt.dsf.mi.service.command.output.MIInfo;
/*      */ import org.eclipse.cdt.dsf.mi.service.command.output.MIOOBRecord;
/*      */ import org.eclipse.cdt.dsf.mi.service.command.output.MITargetStreamOutput;
/*      */ import org.eclipse.cdt.dsf.service.DsfServicesTracker;
/*      */ import org.eclipse.cdt.dsf.service.DsfSession;
/*      */ import org.eclipse.core.runtime.CoreException;
/*      */ import org.eclipse.core.runtime.IPath;
/*      */ import org.eclipse.core.runtime.IStatus;
/*      */ import org.eclipse.core.runtime.Status;
/*      */ import org.eclipse.core.variables.VariablesPlugin;
/*      */ import org.eclipse.debug.core.DebugException;
/*      */ import org.eclipse.debug.core.DebugPlugin;
/*      */ import org.eclipse.debug.core.ILaunch;
/*      */ import org.eclipse.debug.core.ILaunchConfiguration;
/*      */ import org.eclipse.debug.core.model.MemoryByte;
/*      */ import org.eclipse.jface.dialogs.MessageDialog;
/*      */ import org.eclipse.osgi.util.NLS;
/*      */ import org.eclipse.swt.widgets.Display;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ public class LaunchSequenceUtil
/*      */ {
/*      */   private static final String EMPTY_STRING = "";
/*      */   private static final String DEVICEVALIDATION_VERIFY_FAILURE_MSG = "Could not verify ST device! Please verify that the latest version of the GDB-server is used for the connection.";
/*      */   
/*      */   @Execute
/*      */   public static void stepPreLaunch(RequestMonitor rm, GdbLaunch launch) {
/*      */     try {
/*   84 */       ILaunchConfiguration config = launch.getLaunchConfiguration(); byte b; int i; IPreLaunch[] arrayOfIPreLaunch;
/*   85 */       for (i = (arrayOfIPreLaunch = DebugLaunchRegistry.getInstance().getOrderedPreLaunches()).length, b = 0; b < i; ) { IPreLaunch preLaunch = arrayOfIPreLaunch[b];
/*      */         try {
/*   87 */           if (preLaunch.isLaunchConfigurationSupported(config)) {
/*   88 */             preLaunch.execute(config);
/*      */           }
/*   90 */         } catch (Exception e) {
/*   91 */           rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed pre launch", e));
/*      */         }  b++; }
/*      */     
/*      */     } finally {
/*   95 */       rm.done();
/*      */     } 
/*      */   }
/*      */   
/*      */   @Execute
/*      */   public static void stepGenerateGDBServerStartFiles(RequestMonitor rm, GdbLaunch launch) {
/*      */     try {
/*  102 */       ILaunchConfiguration config = launch.getLaunchConfiguration();
/*  103 */       IMxUGDBServer server = HardwareDebugUtil.getServer(config).orElse(null);
/*  104 */       if (server != null && 
/*  105 */         !server.generateServerStartFiles(config)) {
/*  106 */         rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to generate GDB server start files"));
/*      */       }
/*      */     } finally {
/*      */       
/*  110 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepSetupExceptions(RequestMonitor rm, GdbLaunch launch, DsfExecutor executor) {
/*  120 */     Map<String, Object> attributes = null;
/*  121 */     DsfSession session = launch.getSession();
/*      */     try {
/*  123 */       GDBServerCommandGroup commandGroup = new GDBServerCommandGroup("Setup exceptions");
/*  124 */       DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), session.getId());
/*  125 */       IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  126 */       tracker.dispose();
/*  127 */       attributes = launch.getLaunchConfiguration().getAttributes();
/*      */       
/*  129 */       int bits = 0;
/*      */       
/*  131 */       if (((Boolean)CDebugUtils.getAttribute(attributes, "com.st.stm32cube.ide.mcu.debug.launch.startuptab.exception.divby0", Boolean.FALSE)).booleanValue())
/*      */       {
/*  133 */         bits |= 0x10;
/*      */       }
/*  135 */       if (((Boolean)CDebugUtils.getAttribute(attributes, "com.st.stm32cube.ide.mcu.debug.launch.startuptab.exception.unaligned", Boolean.FALSE)).booleanValue())
/*      */       {
/*  137 */         bits |= 0x8;
/*      */       }
/*  139 */       if (bits != 0) {
/*  140 */         commandGroup.addCommand(String.format("set *(int *)0xE000ED14=*(int *)0xE000ED14|0x%X", new Object[] { Integer.valueOf(bits) }));
/*      */       }
/*  142 */       boolean haltOnException = ((Boolean)CDebugUtils.getAttribute(attributes, "com.st.stm32cube.ide.mcu.debug.launch.startuptab.haltonexception", Boolean.FALSE)).booleanValue();
/*  143 */       if (haltOnException) {
/*  144 */         CpuCoreEnum coreEnum = MCUDebugPlugin.getCpuCoreFromConfig(launch.getLaunchConfiguration()).orElse(null);
/*  145 */         if (coreEnum != null) {
/*  146 */           int val = 0;
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */           
/*  158 */           switch (coreEnum) {
/*      */             case Cortex_M0:
/*      */             case Cortex_M0plus:
/*  161 */               val = 1024;
/*      */               break;
/*      */             case Cortex_M3:
/*      */             case Cortex_M4:
/*      */             case Cortex_M7:
/*  166 */               val = 2032;
/*      */               break;
/*      */             case Cortex_M23:
/*      */             case Cortex_M33:
/*  170 */               val = 4080;
/*      */               break;
/*      */             default:
/*  173 */               MCULoggerPlugin.logInfoMessage("com.st.stm32cube.ide.mcu.debug.launch", "Unknown core, when setting halt on exception: " + coreEnum);
/*      */               break;
/*      */           } 
/*  176 */           if (val != 0) {
/*  177 */             commandGroup.addCommand(String.format("set *(int *)0xE000EDFC=*(int *)0xE000EDFC|0x%X", new Object[] { Integer.valueOf(val) }));
/*      */           }
/*      */         } 
/*      */       } 
/*      */       
/*  182 */       executeCommandGroup(commandGroup, executor, commandControl, rm);
/*  183 */     } catch (CoreException e) {
/*  184 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to match core, when setting halt on exception\t");
/*      */     } 
/*      */   }
/*      */ 
/*      */   
/*      */   @Execute
/*      */   public static void stepStartGDBServer(RequestMonitor rm, GdbLaunch launch) {
/*      */     try {
/*  192 */       ILaunchConfiguration config = launch.getLaunchConfiguration();
/*  193 */       boolean startServer = config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.startServer", true);
/*      */       
/*  195 */       if (startServer) {
/*      */         try {
/*  197 */           HardwareDebugUtil.startServer(config, (ILaunch)launch);
/*  198 */         } catch (Exception e) {
/*      */           
/*  200 */           rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to start GDB server", e));
/*      */         } 
/*      */       }
/*  203 */     } catch (CoreException ex) {
/*  204 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", ex.getMessage()));
/*      */     } finally {
/*  206 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepStartGdbProxy(RequestMonitor rm, GdbLaunch launch, Map<String, Object> attributes) {
/*  217 */     IGdbProxyContribution proxy = GdbProxyRegistry.getInstance().getContribution(launch);
/*      */     
/*  219 */     if (proxy != null && proxy.isEnabled(launch)) {
/*  220 */       Process proxyProcess = proxy.run(launch);
/*  221 */       if (proxyProcess != null) {
/*      */         
/*  223 */         DebugPlugin.newProcess((ILaunch)launch, proxyProcess, proxy.getName());
/*      */       } else {
/*      */         
/*  226 */         rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failure starting GDB Proxy: " + proxy.getName()));
/*      */       } 
/*      */     } 
/*      */ 
/*      */ 
/*      */     
/*  232 */     rm.done();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   private static void stepValidateJEP_2(final RequestMonitor rm, IGDBControl control, Executor executor, final GdbLaunch launch, Long apBaseAddress, Long romTableBase) {
/*  246 */     long address = (romTableBase.longValue() & 0xFFFFFFFFFFFFF000L) + 4048L;
/*  247 */     final int numItems = 8;
/*  248 */     long flags = 0L;
/*  249 */     CLICommand<MIInfo> commandRead = new CLICommand((IDMContext)control.getContext(), String.format("monitor ReadMemAP 0x%X 0x%X 0x%X 0x%X", new Object[] { apBaseAddress, Long.valueOf(address), Integer.valueOf(numItems), Long.valueOf(flags) }));
/*      */     
/*  251 */     DataRequestMonitor<MIInfo> drm = new DataRequestMonitor<MIInfo>(executor, rm)
/*      */       {
/*      */         class RomTable
/*      */         {
/*      */           private static final long ST_JEP106_CON = 0L;
/*      */           
/*      */           private static final long ST_JEP106_ID = 32L;
/*      */           
/*      */           private static final int PID_OFFSET = 4048;
/*      */           
/*      */           private static final int ROM_PIDR4 = 0;
/*      */           
/*      */           private static final int ROM_PIDR0 = 16;
/*      */           
/*      */           private static final int ROM_PIDR1 = 20;
/*      */           
/*      */           private static final int ROM_PIDR2 = 24;
/*      */           
/*      */           private static final int ROM_PIDR3 = 28;
/*      */           
/*      */           private static final int ROM_CIDR0 = 32;
/*      */           private static final int ROM_CIDR1 = 36;
/*      */           private static final int ROM_CIDR2 = 40;
/*      */           private static final int ROM_CIDR3 = 44;
/*      */           private static final int END_TABLE = 44;
/*      */           public final long jedec;
/*      */           public final long jep106con;
/*      */           public final long jep106id;
/*      */           public final long partNum;
/*      */           
/*      */           private long extractBits(long val, int start, int end) {
/*  282 */             long mask = ((1 << end - start + 1) - 1);
/*  283 */             long tmp = val >> start;
/*  284 */             return tmp & mask;
/*      */           }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */           
/*      */           public boolean isGenuineSTDevice() {
/*      */             return (this.jedec == 1L && this.jep106con == 0L && this.jep106id == 32L) ? true : ((this.jedec == 1L && this.jep106con == 4L && this.jep106id == 59L && this.partNum == 1217L && LaunchSequenceUtil.null.this.getAP() == 1) ? true : ((this.jedec == 1L && this.jep106con == 4L && this.jep106id == 32L && this.partNum == 1175L && LaunchSequenceUtil.null.this.getAP() == 1) ? true : true));
/*      */           }
/*      */         }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */         
/*      */         protected void handleError() {
/*  303 */           LaunchSequenceUtil.terminateLaunch(launch, "Could not verify ST device! Please verify that the latest version of the GDB-server is used for the connection.");
/*  304 */           rm.done();
/*      */         }
/*      */         
/*      */         private Optional<RomTable> createRomTable() {
/*  308 */           MIInfo data = (MIInfo)getData();
/*  309 */           if (data != null) {
/*  310 */             MIOOBRecord[] oob = data.getMIOutput().getMIOOBRecords();
/*  311 */             if (oob != null) {
/*  312 */               byte b; int i; MIOOBRecord[] arrayOfMIOOBRecord; for (i = (arrayOfMIOOBRecord = oob).length, b = 0; b < i; ) { MIOOBRecord rec = arrayOfMIOOBRecord[b];
/*  313 */                 if (rec instanceof MITargetStreamOutput) {
/*  314 */                   String retString = ((MITargetStreamOutput)rec).getString();
/*  315 */                   if (retString.startsWith("O.K.:")) {
/*      */                     
/*  317 */                     String valueString = retString.substring("O.K.:".length())
/*  318 */                       .replaceAll("\\r", "").replaceAll("\\n", "").replaceAll(",", " ").trim();
/*      */                     
/*  320 */                     String[] values = valueString.split(" ");
/*  321 */                     if (values.length == numItems) {
/*      */                       
/*  323 */                       long[] buf = new long[numItems * 4];
/*      */                       try {
/*  325 */                         for (int itemIdx = 0, bufIdx = 0; itemIdx < numItems; itemIdx++, bufIdx += 4) {
/*  326 */                           long itemValue = Long.decode(values[itemIdx].trim()).longValue();
/*  327 */                           buf[bufIdx] = itemValue & 0xFFL;
/*  328 */                           buf[bufIdx + 1] = itemValue >> 8L & 0xFFL;
/*  329 */                           buf[bufIdx + 2] = itemValue >> 16L & 0xFFL;
/*  330 */                           buf[bufIdx + 3] = itemValue >> 24L & 0xFFL;
/*      */                         } 
/*  332 */                         return Optional.of(new RomTable(buf));
/*  333 */                       } catch (NumberFormatException numberFormatException) {}
/*      */                     } 
/*      */                   } 
/*      */                 } 
/*      */ 
/*      */ 
/*      */                 
/*      */                 b++; }
/*      */             
/*      */             } 
/*      */           } 
/*      */ 
/*      */           
/*  346 */           return Optional.empty();
/*      */         }
/*      */         
/*      */         private int getAP() {
/*      */           try {
/*  351 */             return Integer.valueOf(launch.getLaunchConfiguration().getAttribute("com.st.stm32cube.ide.mcu.debug.launch.access_port_id", "0")).intValue();
/*  352 */           } catch (CoreException|NumberFormatException e) {
/*  353 */             MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", e, "Unable to extract AP from configuration");
/*      */             
/*  355 */             return 0;
/*      */           } 
/*      */         }
/*      */         
/*      */         protected void handleSuccess() {
/*  360 */           RomTable table = createRomTable().orElse(null);
/*  361 */           if (table != null) {
/*  362 */             if (table.isGenuineSTDevice()) {
/*  363 */               rm.done();
/*      */               return;
/*      */             } 
/*  366 */             MCULoggerPlugin.logWarningMessage("com.st.stm32cube.ide.mcu.debug.launch", "Vendor: " + String.join("; ", new CharSequence[] { Long.toHexString(table.jedec), Long.toHexString(table.jep106con), Long.toHexString(table.jep106id), Long.toHexString(table.partNum) }));
/*      */           } 
/*  368 */           LaunchSequenceUtil.terminateLaunch(launch, "Could not verify ST device! Please verify that the latest version of the GDB-server is used for the connection.");
/*  369 */           rm.done();
/*      */         }
/*      */       };
/*  372 */     control.queueCommand((ICommand)commandRead, drm);
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepValidateJEP(final RequestMonitor rm, final GdbLaunch launch, final Executor executor) {
/*      */     final long apBaseAddress, regAddr;
/*  384 */     ILaunchConfiguration config = launch.getLaunchConfiguration();
/*  385 */     String serverId = HardwareDebugUtil.getServerId(config).orElse("");
/*      */     
/*  387 */     if (serverId.isEmpty()) {
/*  388 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "No debug probe selected"));
/*  389 */       rm.done();
/*      */       
/*      */       return;
/*      */     } 
/*  393 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/*  394 */     final IGDBControl control = (IGDBControl)tracker.getService(IGDBControl.class);
/*      */     
/*  396 */     tracker.dispose();
/*      */ 
/*      */ 
/*      */     
/*      */     try {
/*  401 */       int apId = Integer.valueOf(config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.access_port_id", "0")).intValue();
/*  402 */       apBaseAddress = (apId << 24);
/*  403 */       regAddr = 248L;
/*  404 */     } catch (CoreException|NumberFormatException e) {
/*  405 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Failed to select AP", e));
/*      */       
/*      */       return;
/*      */     } 
/*  409 */     control.queueCommand(
/*  410 */         (ICommand)new CLICommand((IDMContext)control.getContext(), String.format("monitor ReadAPEx 0x%X 0x%X", new Object[] { Long.valueOf(apBaseAddress), Long.valueOf(regAddr)
/*  411 */             })), new DataRequestMonitor<MIInfo>(executor, rm)
/*      */         {
/*      */           protected void handleError()
/*      */           {
/*  415 */             LaunchSequenceUtil.terminateLaunch(launch, "Could not verify ST device! Please verify that the latest version of the GDB-server is used for the connection.");
/*  416 */             rm.done();
/*      */           }
/*      */ 
/*      */           
/*      */           protected void handleSuccess() {
/*  421 */             MIInfo data = (MIInfo)getData();
/*  422 */             if (data != null) {
/*  423 */               MIOOBRecord[] oob = data.getMIOutput().getMIOOBRecords();
/*  424 */               if (oob != null) {
/*  425 */                 byte b; int i; MIOOBRecord[] arrayOfMIOOBRecord; for (i = (arrayOfMIOOBRecord = oob).length, b = 0; b < i; ) { MIOOBRecord rec = arrayOfMIOOBRecord[b];
/*  426 */                   if (rec instanceof MITargetStreamOutput) {
/*  427 */                     String retString = ((MITargetStreamOutput)rec).getString();
/*  428 */                     if (retString.startsWith("O.K.:0x")) {
/*  429 */                       String addressString = retString.substring("O.K.:0x".length())
/*  430 */                         .replaceAll("\\r", "").replaceAll("\\n", "").trim();
/*      */                       try {
/*  432 */                         long romTableBase = Long.parseLong(addressString, 16);
/*      */                         
/*  434 */                         if ((romTableBase & 0xFFFL) == 3L) {
/*      */                           
/*  436 */                           LaunchSequenceUtil.stepValidateJEP_2(rm, control, executor, launch, Long.valueOf(apBaseAddress), Long.valueOf(romTableBase));
/*      */                           
/*      */                           return;
/*      */                         } 
/*  440 */                         MCULoggerPlugin.logWarningMessage("com.st.stm32cube.ide.mcu.debug.launch", "Device validation. No ROM-table found: " + addressString);
/*      */                       }
/*  442 */                       catch (NumberFormatException e) {
/*  443 */                         MCULoggerPlugin.logWarningMessage("com.st.stm32cube.ide.mcu.debug.launch", "Device validation. Base invalid format: " + addressString);
/*      */                       } 
/*      */                     } 
/*      */                   } 
/*      */                   
/*      */                   b++; }
/*      */               
/*      */               } 
/*      */             } 
/*  452 */             LaunchSequenceUtil.terminateLaunch(launch, "Could not verify ST device! Please verify that the latest version of the GDB-server is used for the connection.");
/*  453 */             rm.done();
/*      */           }
/*      */         });
/*      */   }
/*      */   
/*      */   public static void stepStartSwvSession(RequestMonitor rm, GdbLaunch launch) {
/*      */     try {
/*  460 */       ILaunchConfiguration config = launch.getLaunchConfiguration();
/*  461 */       if (config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.enable_swv", false)) {
/*  462 */         IMxUGDBServer server = HardwareDebugUtil.getServer(config).orElse(null);
/*  463 */         if (server.isDebugFeatureSupported(DebugFeatureEnum.SWV)) {
/*  464 */           DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/*  465 */           IGDBControl control = (IGDBControl)tracker.getService(IGDBControl.class);
/*  466 */           tracker.dispose();
/*      */ 
/*      */           
/*  469 */           if (config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.swd_mode", false) || HardwareDebugUtil.isSwvSupported(MCUDebugPlugin.getCoreFromConfig(config).orElse(null))) {
/*  470 */             server.createSWVsession(config, control, launch.getSession(), rm);
/*      */           } else {
/*  472 */             rm.done();
/*      */           } 
/*      */         } else {
/*  475 */           rm.done();
/*      */         } 
/*      */       } else {
/*  478 */         rm.done();
/*      */       } 
/*  480 */     } catch (CoreException ex) {
/*  481 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, Messages.DSFFinalLaunchSequence_ERROR_failedToStartSwvSession, (Throwable)ex));
/*  482 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepConfigureSwv(final RequestMonitor rm, GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes) {
/*  494 */     SWVClient client = SWVPlugin.getDefault().getSessionManager().getClient(launch.getSession());
/*  495 */     if (client != null && ((Boolean)CDebugUtils.getAttribute(attributes, "com.st.stm32cube.ide.mcu.debug.launch.swv_config_enabled", Boolean.valueOf(false))).booleanValue()) {
/*      */ 
/*      */ 
/*      */       
/*  499 */       RequestMonitor privateRm = new RequestMonitor((Executor)executor, null)
/*      */         {
/*      */           protected void handleCompleted() {
/*  502 */             rm.done();
/*      */             
/*  504 */             if (!isSuccess()) {
/*  505 */               ThreadHelper.runInUiThreadAsync(() -> {
/*      */                     String msg = "Failed to enable SWV configuration.\n" + getStatus().getMessage();
/*      */                     MessageDialog.openWarning(Display.getCurrent().getActiveShell(), "Configure SWV", msg);
/*      */                   });
/*      */             }
/*      */           }
/*      */         };
/*  512 */       client.configure(true, privateRm);
/*      */     } else {
/*      */       
/*  515 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   private static boolean terminateLaunch(GdbLaunch launch, String uiReason) {
/*  525 */     if (launch == null) {
/*  526 */       return false;
/*      */     }
/*      */     
/*      */     try {
/*  530 */       launch.terminate();
/*  531 */       DebugException e = new DebugException((IStatus)new Status(2, "com.st.stm32cube.ide.mcu.debug.launch", uiReason));
/*  532 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Terminated debug launch because: " + uiReason);
/*  533 */       ThreadHelper.runInUiThreadAsync(() -> MessageDialog.openWarning(Display.getCurrent().getActiveShell(), "Launch terminated", paramString));
/*  534 */     } catch (DebugException e) {
/*  535 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to terminate debug launch");
/*  536 */       return false;
/*      */     } 
/*      */     
/*  539 */     return true;
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   private static String commandsToString(List<String> commands) {
/*  548 */     return String.join("", (Iterable)commands);
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   private static void stepLoadSecondaryGDBSymbolsPre1_1(RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes, IGDBJtagDevice device) {
/*      */     try {
/*  563 */       DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), fLaunch.getSession().getId());
/*  564 */       IMICommandControl commandControl = (IMICommandControl)tracker.getService(ISecondaryCommandControl.class);
/*  565 */       IGDBBackend gdbBackend = (IGDBBackend)tracker.getService(ISecondaryGDBBackend.class);
/*  566 */       tracker.dispose();
/*      */       
/*  568 */       if (commandControl != null && gdbBackend != null) {
/*  569 */         if (((Boolean)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.loadSymbols", Boolean.valueOf(true))).booleanValue()) {
/*  570 */           String symbolsFileName = null;
/*      */           
/*  572 */           if (attributes.containsKey("org.eclipse.cdt.debug.gdbjtag.core.useProjBinaryForSymbols") && ((Boolean)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.useProjBinaryForSymbols", Boolean.valueOf(true))).booleanValue()) {
/*  573 */             IPath programFile = gdbBackend.getProgramPath();
/*      */             
/*  575 */             if (programFile != null) {
/*  576 */               symbolsFileName = programFile.toOSString();
/*      */             }
/*      */           } else {
/*  579 */             symbolsFileName = (String)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.symbolsFileName", "");
/*  580 */             if (symbolsFileName.isEmpty()) {
/*  581 */               symbolsFileName = null;
/*      */             } else {
/*  583 */               symbolsFileName = VariablesPlugin.getDefault().getStringVariableManager().performStringSubstitution(symbolsFileName);
/*      */             } 
/*      */           } 
/*      */           
/*  587 */           if (symbolsFileName == null) {
/*      */             
/*  589 */             rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "", null));
/*  590 */             rm.done();
/*      */             
/*      */             return;
/*      */           } 
/*  594 */           symbolsFileName = symbolsFileName.replace("\\", "\\\\");
/*      */           
/*  596 */           String symbolsOffset = (String)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.symbolsOffset", "");
/*  597 */           if (symbolsOffset.length() > 0) {
/*  598 */             symbolsOffset = "0x" + symbolsOffset;
/*      */           }
/*      */           
/*  601 */           List<String> commands = new ArrayList<>();
/*  602 */           device.doLoadSymbol(symbolsFileName, symbolsOffset, commands);
/*      */           
/*  604 */           if (!commands.isEmpty()) {
/*  605 */             commandControl.queueCommand(
/*  606 */                 (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/*  607 */                 new DataRequestMonitor((Executor)executor, rm));
/*      */           } else {
/*  609 */             rm.done();
/*      */           } 
/*      */         } else {
/*      */           
/*  613 */           rm.done();
/*      */         } 
/*      */       } else {
/*      */         
/*  617 */         rm.done();
/*      */       } 
/*  619 */     } catch (CoreException e) {
/*  620 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Cannot load symbol", (Throwable)e));
/*  621 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepLoadSecondaryGDBSymbols(RequestMonitor rm, GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes) {
/*  634 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/*  635 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(ISecondaryCommandControl.class);
/*  636 */     tracker.dispose();
/*      */     
/*  638 */     if (commandControl != null) {
/*  639 */       IMxUGDBServer server = HardwareDebugUtil.getServer(launch.getLaunchConfiguration()).orElse(null);
/*  640 */       if (server instanceof IGDBJtagDevice) {
/*  641 */         LoadListInfo info = LoadListInfo.parseLoadListInfo(attributes).orElse(null);
/*  642 */         if (info != null) {
/*  643 */           List<String> commands = getLoadSymbolCommandsFromLoadList(launch, (IGDBJtagDevice)server, info);
/*      */           
/*  645 */           if (!commands.isEmpty()) {
/*  646 */             commandControl.queueCommand(
/*  647 */                 (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/*  648 */                 new DataRequestMonitor((Executor)executor, rm));
/*      */           } else {
/*      */             
/*  651 */             rm.done();
/*      */           } 
/*      */         } else {
/*      */           
/*  655 */           stepLoadSecondaryGDBSymbolsPre1_1(rm, launch, executor, attributes, (IGDBJtagDevice)server);
/*      */         } 
/*      */       } else {
/*      */         
/*  659 */         rm.done();
/*      */       } 
/*      */     } else {
/*      */       
/*  663 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepConnectToSecondaryGDB(final RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes) {
/*      */     try {
/*  677 */       DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), fLaunch.getSession().getId());
/*      */       
/*  679 */       IMICommandControl commandControl = (IMICommandControl)tracker.getService(ISecondaryCommandControl.class);
/*  680 */       tracker.dispose();
/*      */       
/*  682 */       if (commandControl != null) {
/*  683 */         if (((Boolean)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.useRemoteTarget", Boolean.valueOf(true))).booleanValue()) {
/*  684 */           List<String> commands = new ArrayList<>();
/*      */           
/*  686 */           IMxUGDBServer server = HardwareDebugUtil.getServer(fLaunch.getLaunchConfiguration()).orElse(null);
/*  687 */           if (server instanceof IGDBJtagConnection) {
/*  688 */             String connection = "unspecified-ip-address:unspecified-port-number";
/*  689 */             String connectionUri = (String)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.connection", 
/*  690 */                 "unspecified-ip-address:unspecified-port-number");
/*      */             
/*  692 */             if (!"unspecified-ip-address:unspecified-port-number".equals(connectionUri)) {
/*  693 */               connection = (new URI(connectionUri)).getSchemeSpecificPart();
/*      */             } else {
/*      */               
/*  696 */               String ipAddress = (String)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.ipAddress", 
/*  697 */                   "unspecified-ip-address");
/*  698 */               int portNumber = ((Integer)CDebugUtils.getAttribute(attributes, "org.eclipse.cdt.debug.gdbjtag.core.portNumber", 
/*  699 */                   Integer.valueOf(0))).intValue();
/*  700 */               if (!"unspecified-ip-address".equals(ipAddress)) {
/*  701 */                 connection = String.format("%s:%d", new Object[] { ipAddress, Integer.valueOf(portNumber) });
/*      */               }
/*      */             } 
/*      */             
/*  705 */             IGDBJtagConnection device = (IGDBJtagConnection)server;
/*  706 */             device.doRemote(connection, commands);
/*      */ 
/*      */             
/*  709 */             RequestMonitor privateRm = new RequestMonitor((Executor)executor, null)
/*      */               {
/*      */                 protected void handleCompleted() {
/*  712 */                   rm.done();
/*  713 */                   if (!isSuccess()) {
/*  714 */                     ThreadHelper.runInUiThreadAsync(() -> {
/*      */                           String msg = "Failed to enable Live Expressions.\nConnection failed.";
/*      */                           MessageDialog.openWarning(Display.getCurrent().getActiveShell(), "Live Expressions", msg);
/*      */                         });
/*      */                   }
/*      */                 }
/*      */               };
/*  721 */             commandControl.queueCommand(
/*  722 */                 (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/*  723 */                 new DataRequestMonitor((Executor)executor, privateRm));
/*      */           } else {
/*  725 */             rm.done();
/*      */           } 
/*      */         } else {
/*  728 */           rm.done();
/*      */         } 
/*      */       } else {
/*      */         
/*  732 */         rm.done();
/*      */       } 
/*  734 */     } catch (URISyntaxException e) {
/*  735 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Invalid remote target connection syntax", e));
/*  736 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepConnectToTarget(RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes, StepRunnable superImpl) {
/*  749 */     IGdbProxyContribution proxy = GdbProxyRegistry.getInstance().getContribution(fLaunch);
/*      */ 
/*      */     
/*  752 */     if (proxy == null || !proxy.isEnabled(fLaunch)) {
/*  753 */       superImpl.runStep(rm);
/*      */       
/*      */       return;
/*      */     } 
/*  757 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), fLaunch.getSession().getId());
/*  758 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  759 */     tracker.dispose();
/*      */     
/*  761 */     if (commandControl != null) {
/*  762 */       List<String> commands = new ArrayList<>();
/*  763 */       IMxUGDBServer server = HardwareDebugUtil.getServer(fLaunch.getLaunchConfiguration()).orElse(null);
/*  764 */       if (server instanceof IGDBJtagConnection) {
/*      */         
/*  766 */         String ipAddress = proxy.getHostName(fLaunch);
/*  767 */         int portNumber = proxy.getPortNumber(fLaunch);
/*  768 */         String connection = String.format("%s:%d", new Object[] { ipAddress, Integer.valueOf(portNumber) });
/*      */         
/*  770 */         IGDBJtagConnection device = (IGDBJtagConnection)server;
/*  771 */         device.doRemote(connection, commands);
/*      */         
/*  773 */         commandControl.queueCommand(
/*  774 */             (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/*  775 */             new DataRequestMonitor((Executor)executor, rm));
/*      */       } else {
/*  777 */         rm.done();
/*      */       } 
/*      */     } else {
/*  780 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepResetBoard(RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes) {
/*  793 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), fLaunch.getSession().getId());
/*      */     
/*  795 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  796 */     tracker.dispose();
/*      */     
/*  798 */     if (commandControl != null) {
/*  799 */       IMxUGDBServer server = HardwareDebugUtil.getServer(fLaunch.getLaunchConfiguration()).orElse(null);
/*  800 */       if (server != null) {
/*  801 */         List<String> commands = new ArrayList<>();
/*      */         
/*      */         try {
/*  804 */           server.doReset(fLaunch.getLaunchConfiguration(), commands);
/*      */           
/*  806 */           if (!commands.isEmpty()) {
/*  807 */             commandControl.queueCommand(
/*  808 */                 (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/*  809 */                 new DataRequestMonitor((Executor)executor, rm));
/*      */           } else {
/*  811 */             rm.done();
/*      */           } 
/*  813 */         } catch (CoreException e) {
/*  814 */           rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Fail resetting board", (Throwable)e));
/*  815 */           rm.done();
/*      */         } 
/*      */       } else {
/*  818 */         rm.done();
/*      */       } 
/*      */     } else {
/*  821 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepRestartInit(RequestMonitor rm, GdbLaunch launch) {
/*  832 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/*      */     
/*  834 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  835 */     tracker.dispose();
/*      */     
/*  837 */     if (commandControl != null) {
/*  838 */       IMxUGDBServer server = HardwareDebugUtil.getServer(launch.getLaunchConfiguration()).orElse(null);
/*  839 */       if (server != null) {
/*      */         try {
/*  841 */           server.doRestartInit(launch.getLaunchConfiguration());
/*  842 */         } catch (CoreException e) {
/*  843 */           rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Fail to initialize restart", (Throwable)e));
/*  844 */           rm.done();
/*      */         } 
/*      */       }
/*      */     } 
/*  848 */     rm.done();
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   private static void executeCommandGroup(final GDBServerCommandGroup commandGroup, DsfExecutor executor, IMICommandControl commandControl, RequestMonitor rm) {
/*  859 */     List<String> commands = (List<String>)commandGroup.getCommands().stream()
/*  860 */       .filter(line -> (!line.trim().isEmpty() && !line.trim().startsWith("#")))
/*  861 */       .collect(Collectors.toList());
/*  862 */     if (!commands.isEmpty()) {
/*  863 */       commandControl.queueCommand((ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), new DataRequestMonitor<MIInfo>((Executor)executor, rm)
/*      */           {
/*      */             
/*      */             protected void handleError()
/*      */             {
/*  868 */               setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", commandGroup.getName()));
/*  869 */               super.handleError();
/*      */             }
/*      */           });
/*      */     }
/*      */     else {
/*      */       
/*  875 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void executeCommandGroups(RequestMonitor rm, List<GDBServerCommandGroup> commandGroups, GdbLaunch fLaunch, DsfExecutor executor) {
/*  887 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), fLaunch.getSession().getId());
/*  888 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  889 */     tracker.dispose();
/*      */     
/*  891 */     if (commandControl != null) {
/*  892 */       CountingRequestMonitor crm = new CountingRequestMonitor((Executor)executor, rm);
/*  893 */       crm.setDoneCount(commandGroups.size());
/*      */       
/*  895 */       for (GDBServerCommandGroup commandGroup : commandGroups) {
/*  896 */         executeCommandGroup(commandGroup, executor, commandControl, (RequestMonitor)crm);
/*      */       }
/*      */     } else {
/*      */       
/*  900 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */   
/*      */   public static void stepPreInitCommands(RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes) {
/*  906 */     IMxUGDBServer server = HardwareDebugUtil.getServer(fLaunch.getLaunchConfiguration()).orElse(null);
/*      */     
/*  908 */     if (server != null) {
/*      */       
/*  910 */       List<GDBServerCommandGroup> commandGroups = new ArrayList<>();
/*      */       
/*      */       try {
/*  913 */         server.doSetInitCommands(fLaunch.getLaunchConfiguration(), commandGroups);
/*      */         
/*  915 */         executeCommandGroups(rm, commandGroups, fLaunch, executor);
/*      */       }
/*  917 */       catch (CoreException e) {
/*  918 */         rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Failed to set init commands", (Throwable)e));
/*  919 */         rm.done();
/*      */       } 
/*      */     } else {
/*  922 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */   
/*      */   public static void stepPreDebugCommands(RequestMonitor rm, GdbLaunch fLaunch, DsfExecutor executor, Map<String, Object> attributes) {
/*  928 */     IMxUGDBServer server = HardwareDebugUtil.getServer(fLaunch.getLaunchConfiguration()).orElse(null);
/*      */     
/*  930 */     if (server != null) {
/*      */       
/*  932 */       List<GDBServerCommandGroup> commandGroups = new ArrayList<>();
/*      */       
/*      */       try {
/*  935 */         server.doSetDebugCommands(fLaunch.getLaunchConfiguration(), commandGroups);
/*      */         
/*  937 */         executeCommandGroups(rm, commandGroups, fLaunch, executor);
/*      */       }
/*  939 */       catch (CoreException e) {
/*  940 */         rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Failed to set debug commands", (Throwable)e));
/*  941 */         rm.done();
/*      */       } 
/*      */     } else {
/*  944 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepLoadImage(RequestMonitor rm, GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes, StepRunnable superImpl) {
/*  957 */     ILaunchConfiguration config = launch.getLaunchConfiguration(); byte b; int i; IPreLaunch[] arrayOfIPreLaunch;
/*  958 */     for (i = (arrayOfIPreLaunch = DebugLaunchRegistry.getInstance().getOrderedPreLaunches()).length, b = 0; b < i; ) { IPreLaunch preLaunch = arrayOfIPreLaunch[b];
/*  959 */       if (preLaunch.isLaunchConfigurationSupported(config) && 
/*  960 */         preLaunch.isDelegatedLoadImage(config)) {
/*  961 */         rm.done();
/*      */         
/*      */         return;
/*      */       } 
/*      */       b++; }
/*      */     
/*  967 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/*  968 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/*  969 */     tracker.dispose();
/*      */     
/*  971 */     LoadListInfo info = LoadListInfo.parseLoadListInfo(attributes).orElse(null);
/*  972 */     if (info != null) {
/*  973 */       IMxUGDBServer server = HardwareDebugUtil.getServer(launch.getLaunchConfiguration()).orElse(null);
/*  974 */       if (server instanceof IGDBJtagDevice) {
/*  975 */         List<CLICommand<MIInfo>> commandList = new ArrayList<>();
/*  976 */         for (LoadListInfo.LoadListItem item : info.getInternalItems()) {
/*  977 */           if (item.shouldDownload().booleanValue()) {
/*  978 */             String imageFileName = item.getAbsolutePath().replace("\\", "\\\\");
/*  979 */             String imageOffset = "";
/*  980 */             if (item.getDownloadAddress() != null) {
/*  981 */               imageOffset = String.format("0x%x", new Object[] { item.getDownloadAddress() });
/*      */             }
/*      */             
/*  984 */             List<String> commands = new ArrayList<>();
/*      */             
/*  986 */             ((IGDBJtagDevice)server).doLoadImage(imageFileName, imageOffset, commands);
/*      */             
/*  988 */             if (!commands.isEmpty()) {
/*  989 */               commandList.add(new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)));
/*      */             }
/*      */           } 
/*      */         } 
/*      */         
/*  994 */         CountingRequestMonitor crm = new CountingRequestMonitor((Executor)executor, rm);
/*  995 */         crm.setDoneCount(commandList.size());
/*      */         
/*  997 */         for (CLICommand<MIInfo> command : commandList) {
/*  998 */           commandControl.queueCommand((ICommand)command, new DataRequestMonitor((Executor)executor, (RequestMonitor)crm));
/*      */         }
/*      */         
/*      */         return;
/*      */       } 
/*      */     } 
/*      */     
/* 1005 */     superImpl.runStep(rm);
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepHandleRunMode(RequestMonitor rm, final GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes) {
/* 1017 */     if (launch.getLaunchMode().equals("run")) {
/* 1018 */       DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/* 1019 */       IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/* 1020 */       tracker.dispose();
/*      */ 
/*      */       
/* 1023 */       commandControl.queueCommand((ICommand)new CLICommand((IDMContext)commandControl.getContext(), "continue"), new DataRequestMonitor<MIInfo>((Executor)executor, rm)
/*      */           {
/*      */             protected void handleCompleted() {
/* 1026 */               super.handleCompleted();
/*      */ 
/*      */               
/*      */               try {
/* 1030 */                 launch.terminate();
/* 1031 */               } catch (DebugException e) {
/* 1032 */                 MCULoggerPlugin.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to terminating run mode launch", (Throwable)e));
/*      */               } 
/*      */             }
/*      */           });
/*      */     } else {
/* 1037 */       rm.done();
/*      */     } 
/*      */   }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */   
/*      */   public static void stepLoadSymbols(RequestMonitor rm, GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes, StepRunnable superImpl) {
/* 1049 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/* 1050 */     IMICommandControl commandControl = (IMICommandControl)tracker.getService(IMICommandControl.class);
/* 1051 */     tracker.dispose();
/*      */     
/* 1053 */     if (commandControl != null) {
/* 1054 */       IMxUGDBServer server = HardwareDebugUtil.getServer(launch.getLaunchConfiguration()).orElse(null);
/* 1055 */       if (server instanceof IGDBJtagDevice) {
/* 1056 */         LoadListInfo info = LoadListInfo.parseLoadListInfo(attributes).orElse(null);
/* 1057 */         if (info != null) {
/* 1058 */           List<String> commands = getLoadSymbolCommandsFromLoadList(launch, (IGDBJtagDevice)server, info);
/*      */           
/* 1060 */           if (!commands.isEmpty()) {
/* 1061 */             commandControl.queueCommand(
/* 1062 */                 (ICommand)new CLICommand((IDMContext)commandControl.getContext(), commandsToString(commands)), 
/* 1063 */                 new DataRequestMonitor((Executor)executor, rm));
/*      */           } else {
/* 1065 */             rm.done();
/*      */           } 
/*      */           
/*      */           return;
/*      */         } 
/*      */       } 
/*      */     } 
/* 1072 */     superImpl.runStep(rm);
/*      */   }
/*      */   
/*      */   private static List<String> getLoadSymbolCommandsFromLoadList(GdbLaunch launch, IGDBJtagDevice device, LoadListInfo info) {
/* 1076 */     List<String> commands = new ArrayList<>();
/* 1077 */     LoadListInfo.LoadListItem primaryItem = info.getPrimaryItem().orElse(null);
/*      */ 
/*      */     
/* 1080 */     getLoadSymbolCommandForItem(launch, device, primaryItem, true, commands);
/*      */ 
/*      */     
/* 1083 */     for (LoadListInfo.LoadListItem item : info.getAdditionalItems()) {
/* 1084 */       getLoadSymbolCommandForItem(launch, device, item, false, commands);
/*      */     }
/*      */     
/* 1087 */     return commands;
/*      */   }
/*      */   
/*      */   private static void getLoadSymbolCommandForItem(GdbLaunch launch, IGDBJtagDevice device, LoadListInfo.LoadListItem item, boolean primaryItem, List<String> commands) {
/* 1091 */     if (item != null && item.shouldLoadSymbols().booleanValue()) {
/* 1092 */       String imageFileName = item.getAbsolutePath().replace("\\", "\\\\");
/* 1093 */       String symbolOffset = null;
/* 1094 */       if (item.getSymbolAddress() != null) {
/* 1095 */         symbolOffset = String.format("0x%x", new Object[] { item.getSymbolAddress() });
/*      */       }
/*      */       
/* 1098 */       if (!primaryItem && symbolOffset == null) {
/* 1099 */         symbolOffset = getAddressForSection(".text", imageFileName).orElse(null);
/* 1100 */         if (symbolOffset == null) {
/*      */           
/* 1102 */           if ("run".equals(launch.getLaunchMode())) {
/*      */             return;
/*      */           }
/*      */ 
/*      */ 
/*      */           
/* 1108 */           terminateLaunch(launch, NLS.bind("The ELF file {0} does not contain any .text section. Either manually enter the offset for the ELF file in the launch configuration or disable symbol loading for the ELF file.", item.getAbsolutePath()));
/*      */         } 
/*      */       } 
/*      */       
/* 1112 */       device.doLoadSymbol(imageFileName, symbolOffset, commands);
/*      */     } 
/*      */   }
/*      */   private static Optional<String> getAddressForSection(String sectionName, String elfFile) {
/*      */     
/* 1117 */     try { Exception exception1 = null, exception2 = null;
/*      */ 
/*      */       
/*      */       try {  }
/*      */       finally
/* 1122 */       { exception2 = null; if (exception1 == null) { exception1 = exception2; } else if (exception1 != exception2) { exception1.addSuppressed(exception2); }  }  } catch (IOException e)
/*      */     
/* 1124 */     { e.printStackTrace(); }
/*      */ 
/*      */     
/* 1127 */     return Optional.empty();
/*      */   }
/*      */   
/*      */   private static IGDBJtagDevice getDevice(ILaunchConfiguration config) {
/* 1131 */     String serverId = HardwareDebugUtil.getServerId(config).orElse("");
/* 1132 */     if (!serverId.isEmpty()) {
/* 1133 */       GDBJtagDeviceContribution server = GDBServerContributionFactory.findById(serverId);
/* 1134 */       if (server != null) {
/* 1135 */         return server.getDevice();
/*      */       }
/*      */     } 
/* 1138 */     return null;
/*      */   }
/*      */   
/*      */   public static void stepSetProgramCounter(final RequestMonitor rm, GdbLaunch launch, final DsfExecutor executor, StepRunnable superImpl) {
/*      */     try {
/* 1143 */       ILaunchConfiguration config = launch.getLaunchConfiguration();
/* 1144 */       if (!config.getAttributes().containsKey("com.st.stm32cube.ide.mcu.debug.launch.override_start_address_mode")) {
/*      */         
/* 1146 */         superImpl.runStep(rm);
/*      */       } else {
/* 1148 */         String vectorTable, mode = config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.override_start_address_mode", "default");
/*      */         String str1;
/* 1150 */         switch ((str1 = mode).hashCode()) { case 3571: if (!str1.equals("pc")) {
/*      */               break;
/*      */             }
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */ 
/*      */             
/* 1237 */             superImpl.runStep(rm); return;case 861618642: if (!str1.equals("vector_table")) break;  vectorTable = config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.vector_table", ""); if (!vectorTable.isEmpty()) { DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId()); final IGDBControl control = (IGDBControl)tracker.getService(IGDBControl.class); tracker.dispose(); final IGDBJtagDevice server = getDevice(config); if (server != null) { CpuCoreEnum coreEnum = MCUDebugPlugin.getCpuCoreFromConfig(launch.getLaunchConfiguration()).orElse(null); if (coreEnum != null) { long reset_handler; List<String> commands; CountingRequestMonitor crm; switch (coreEnum) { case Cortex_A5: case Cortex_A7: case Cortex_A8: case Cortex_A9: case Cortex_A12: case Cortex_A15: case Cortex_A17: case Cortex_A35: case Cortex_A53: case Cortex_A57: case Cortex_A72: reset_handler = Long.decode("0x" + vectorTable).longValue(); commands = new ArrayList<>(); server.doSetPC(Long.toHexString(reset_handler), commands); crm = new CountingRequestMonitor((Executor)executor, rm); crm.setDoneCount(commands.size()); for (String command : commands)
/*      */                         control.queueCommand((ICommand)new CLICommand((IDMContext)control.getContext(), command), new DataRequestMonitor((Executor)executor, (RequestMonitor)crm));  return; }  ICommand<MIDataReadMemoryBytesInfo> commandRead = control.getCommandFactory().createMIDataReadMemoryBytes((IDMContext)control.getContext(), "0x" + vectorTable, 4L, 4); control.queueCommand(commandRead, new DataRequestMonitor<MIDataReadMemoryBytesInfo>((Executor)executor, rm) { protected void handleSuccess() { MIDataReadMemoryBytesInfo data = (MIDataReadMemoryBytesInfo)getData(); if (data != null) { MemoryByte[] mem = data.getMIMemoryBlock(); long reset_handler = 0L; for (int i = 0; i < mem.length; i++)
/*      */                               reset_handler += (mem[i].getValue() & 0xFFL) << 8 * i;  List<String> commands = new ArrayList<>(); server.doSetPC(Long.toHexString(reset_handler), commands); CountingRequestMonitor crm = new CountingRequestMonitor((Executor)executor, rm); crm.setDoneCount(commands.size()); for (String command : commands)
/*      */                               control.queueCommand((ICommand)new CLICommand((IDMContext)control.getContext(), command), new DataRequestMonitor((Executor)executor, (RequestMonitor)crm));  } else { rm.done(); }  } }
/*      */                     ); } else { rm.done(); }  } else { rm.done(); }  } else { rm.done(); }  return;case 1544803905: if (!str1.equals("default"))
/* 1242 */               break;  rm.done();
/*      */             return; }
/*      */ 
/*      */         
/* 1246 */         MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "Invalid override start address mode detected: " + mode);
/* 1247 */         rm.done();
/*      */       }
/*      */     
/*      */     }
/* 1251 */     catch (CoreException ex) {
/* 1252 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Failed to set program counter", (Throwable)ex));
/* 1253 */       rm.done();
/*      */     } 
/*      */   }
/*      */   
/*      */   public static void stepSecondarySourceGDBInitFile(final RequestMonitor rm, GdbLaunch launch, DsfExecutor executor, Map<String, Object> attributes) {
/* 1258 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), launch.getSession().getId());
/* 1259 */     ISecondaryGDBBackend gdbBackend = (ISecondaryGDBBackend)tracker.getService(ISecondaryGDBBackend.class);
/* 1260 */     ISecondaryCommandControl commandControl = (ISecondaryCommandControl)tracker.getService(ISecondaryCommandControl.class);
/* 1261 */     tracker.dispose();
/*      */     
/* 1263 */     if (commandControl != null && gdbBackend != null) {
/*      */       try {
/* 1265 */         IPath workingDirectory = gdbBackend.getGDBWorkingDirectory();
/* 1266 */         String gdbinitFile = gdbBackend.getGDBInitFile();
/*      */         
/* 1268 */         if (gdbinitFile != null && !gdbinitFile.isEmpty() && workingDirectory != null) {
/* 1269 */           IPath path = workingDirectory.append(gdbinitFile);
/* 1270 */           if (path.toFile().exists()) {
/* 1271 */             commandControl.queueCommand(
/* 1272 */                 commandControl.getCommandFactory().createCLISource(commandControl.getContext(), path.toOSString()), 
/* 1273 */                 new DataRequestMonitor<MIInfo>((Executor)executor, rm)
/*      */                 {
/*      */                   protected void handleCompleted() {
/* 1276 */                     rm.setStatus(getStatus());
/* 1277 */                     rm.done();
/*      */                   }
/*      */                 });
/*      */           } else {
/* 1281 */             rm.done();
/*      */           } 
/*      */         } else {
/* 1284 */           rm.done();
/*      */         } 
/* 1286 */       } catch (CoreException e) {
/* 1287 */         rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", -1, "Failed to get path to init file for live channel", (Throwable)e));
/* 1288 */         rm.done();
/*      */       } 
/*      */     } else {
/*      */       
/* 1292 */       rm.done();
/*      */     } 
/*      */   }
/*      */   
/*      */   public static interface StepRunnable {
/*      */     void runStep(RequestMonitor param1RequestMonitor);
/*      */   }
/*      */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\LaunchSequenceUtil.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */