/*     */ package com.st.stm32cube.ide.mcu.debug.launch.device;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.DebugFeatureEnum;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.GDBServerCommandGroup;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.IMxUGDBServer;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.ui.IDebuggerTab;
/*     */ import com.st.stm32cube.ide.mcu.ide.core.TargetHelper;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Board;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Mcu;
/*     */ import com.st.stm32cube.ide.mcu.toolchain.ToolChainHelper;
/*     */ import java.io.InputStream;
/*     */ import java.io.InputStreamReader;
/*     */ import java.util.Collection;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Optional;
/*     */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.GenericDevice;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.gdb.service.command.IGDBControl;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.cdt.managedbuilder.core.IConfiguration;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.FileLocator;
/*     */ import org.eclipse.core.runtime.IPath;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.core.runtime.Status;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ import org.eclipse.debug.core.model.IProcess;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.ui.IMemento;
/*     */ import org.eclipse.ui.XMLMemento;
/*     */ import org.osgi.framework.Bundle;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AbstractDebugHardware
/*     */   extends GenericDevice
/*     */   implements IMxUGDBServer
/*     */ {
/*     */   private static final String BOARDS_XML = "boards.xml";
/*     */   private static final int DEFAULT_PORT_NUMBER = 61234;
/*     */   protected static final String DEFAULT_IP = "localhost";
/*     */   protected static final String NONE = "NONE";
/*     */   protected static final String EMPTY_STRING = "";
/*     */   protected static final String NEWLINE = "\n";
/*     */   protected static final String ORG_ECLIPSE_CDT_LAUNCH_PROJECT_ATTR = "org.eclipse.cdt.launch.PROJECT_ATTR";
/*     */   private IDebuggerTab debuggerTab;
/*     */   private XMLMemento boardXMLRoot;
/*     */   
/*     */   public AbstractDebugHardware() {
/*  65 */     this.boardXMLRoot = null;
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public void createControl(Composite parent, IDebuggerTab dt) {
/*  71 */     this.debuggerTab = dt;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public IDebuggerTab getDebuggerTab() {
/*  79 */     return this.debuggerTab;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public abstract Composite getControl();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void updateLaunchDialog() {
/*  94 */     this.debuggerTab.subPageChanged();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getDefaultGdbClient() {
/* 101 */     return "arm-none-eabi-gdb";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getServerInstallLocation(ILaunchConfiguration config) throws CoreException {
/* 111 */     throw new CoreException(new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Not implemented"));
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getServerWorkingDir(ILaunchConfiguration config) throws CoreException {
/* 121 */     throw new CoreException(new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Not implemented"));
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean getAutoStartDefault() {
/* 128 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void connectionModeChanged(boolean selection) {}
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void doRemote(String connection, Collection<String> commands) {
/* 140 */     String cmd = "target remote " + connection;
/* 141 */     addCmd(commands, cmd);
/*     */   }
/*     */ 
/*     */   
/*     */   public void getPreScript(ILaunchConfiguration config, Collection<String> commands) {}
/*     */ 
/*     */   
/*     */   public String getDefaultIpAddress() {
/* 149 */     return "localhost";
/*     */   }
/*     */ 
/*     */   
/*     */   public String getDefaultPortNumber() {
/* 154 */     return "61234";
/*     */   }
/*     */ 
/*     */   
/*     */   protected String escapeSpaces(String file) {
/* 159 */     if (file.indexOf(' ') >= 0) return String.valueOf('"') + file + '"'; 
/* 160 */     return file;
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   protected void addCmd(Collection<String> commands, String cmd) {
/* 166 */     commands.add(String.valueOf(cmd) + System.lineSeparator());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void initGUI() {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getWaitBeforeConnect() {
/* 180 */     return 0;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getServerErrorMsg(int exitVal) {
/* 188 */     return Messages.AbstractDebugHardware_ERROR_connectionToTargetFailed;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean setBoardXML(Bundle bundle, String path) {
/* 214 */     if (this.boardXMLRoot == null) {
/* 215 */       Path path1 = new Path(path);
/*     */       
/*     */       try {
/* 218 */         InputStream is = FileLocator.openStream(bundle, (IPath)path1, false);
/* 219 */         InputStreamReader isr = new InputStreamReader(is);
/* 220 */         this.boardXMLRoot = XMLMemento.createReadRoot(isr);
/* 221 */         isr.close();
/* 222 */       } catch (Exception e) {
/*     */         
/* 224 */         return false;
/*     */       } 
/*     */     } 
/* 227 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected XMLMemento getBoardXML() {
/* 234 */     return this.boardXMLRoot;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public HashMap<String, String> getDeviceOptions(Bundle bundle, String projectName) {
/* 244 */     HashMap<String, String> options = null;
/*     */     
/* 246 */     if (!setBoardXML(bundle, "boards.xml")) {
/* 247 */       return options;
/*     */     }
/* 249 */     XMLMemento xmlRoot = getBoardXML();
/* 250 */     if (xmlRoot == null) {
/* 251 */       return options;
/*     */     }
/*     */ 
/*     */ 
/*     */     
/* 256 */     String name = "TODO";
/* 257 */     IMemento[] elements = xmlRoot.getChildren("Board");
/*     */     
/* 259 */     options = getOptions(elements, name);
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 264 */     if (options.size() <= 0) {
/* 265 */       name = "TODO";
/* 266 */       elements = xmlRoot.getChildren("MCU");
/*     */       
/* 268 */       options = getOptions(elements, name);
/*     */     } 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 274 */     if (options.size() <= 0) {
/* 275 */       name = "NONE";
/* 276 */       elements = xmlRoot.getChildren("MCU");
/*     */       
/* 278 */       options = getOptions(elements, name);
/*     */     } 
/*     */ 
/*     */     
/* 282 */     return options;
/*     */   }
/*     */   
/*     */   private HashMap<String, String> getOptions(IMemento[] elements, String name) {
/* 286 */     HashMap<String, String> options = new HashMap<>();
/*     */     
/* 288 */     for (int i = 0; i < elements.length; i++) {
/* 289 */       if (elements[i].getString("name").equals(name) || 
/* 290 */         elements[i].getString("name").equals("*")) {
/* 291 */         IMemento[] xmloptions = elements[i].getChildren("Option");
/* 292 */         for (int j = 0; j < xmloptions.length; j++) {
/* 293 */           String id = xmloptions[j].getString("id");
/* 294 */           String value = xmloptions[j].getString("value");
/* 295 */           if (id != null && value != null && !options.containsKey(id)) {
/* 296 */             options.put(id, value);
/*     */           }
/*     */         } 
/*     */         
/*     */         break;
/*     */       } 
/*     */     } 
/* 303 */     return options;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getDeviceGDBScript(Bundle bundle, String projectName) {
/* 311 */     if (!setBoardXML(bundle, "boards.xml")) {
/* 312 */       return "";
/*     */     }
/* 314 */     XMLMemento xmlRoot = getBoardXML();
/* 315 */     if (xmlRoot == null) {
/* 316 */       return "";
/*     */     }
/* 318 */     IMemento[] nodes = xmlRoot.getChildren("Board");
/* 319 */     String script = getGDBScript(nodes, projectName, deviceType.BOARD);
/*     */     
/* 321 */     if ("".equals(script)) {
/* 322 */       nodes = xmlRoot.getChildren("MCU");
/* 323 */       script = getGDBScript(nodes, projectName, deviceType.MCU);
/*     */     } 
/*     */     
/* 326 */     if ("".equals(script)) {
/* 327 */       nodes = xmlRoot.getChildren("Fallback");
/* 328 */       script = getGDBScript(nodes, projectName, deviceType.NONE);
/*     */     } 
/*     */ 
/*     */     
/* 332 */     return script;
/*     */   }
/*     */   
/*     */   private enum deviceType {
/* 336 */     BOARD,
/* 337 */     MCU,
/* 338 */     NONE;
/*     */   }
/*     */   
/*     */   private String getGDBScript(IMemento[] nodes, String projectName, deviceType type) {
/* 342 */     return "monitor reset\nload\ntbreak main\ncontinue";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getServerPersistentArg() {
/* 428 */     return "";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static String getScriptSection(String cmdFile, int section) {
/* 435 */     String[] sections = cmdFile.split("#sec_[a-zA-Z]+#");
/* 436 */     if (section >= 0 && section < sections.length) {
/* 437 */       return sections[section].trim();
/*     */     }
/* 439 */     return "";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected String getProjectName(ILaunchConfiguration configuration) {
/* 448 */     String projectName = "";
/*     */     try {
/* 450 */       projectName = configuration.getAttribute("org.eclipse.cdt.launch.PROJECT_ATTR", "");
/* 451 */     } catch (CoreException e) {
/* 452 */       return "";
/*     */     } 
/* 454 */     return projectName;
/*     */   }
/*     */ 
/*     */   
/*     */   public boolean preLaunchCheck(ILaunchConfiguration config) throws CoreException {
/* 459 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void verifyServer(ILaunchConfiguration config, IProcess iProcess) throws CoreException {
/*     */     try {
/* 472 */       Thread.sleep((getWaitBeforeConnect() * 1000));
/* 473 */     } catch (InterruptedException interruptedException) {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 479 */     if (iProcess.isTerminated()) {
/* 480 */       int exitVal = iProcess.getExitValue();
/* 481 */       String errMsg = getServerErrorMsg(exitVal);
/* 482 */       throw new CoreException(new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", errMsg));
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Optional<String> getConfigurationErrorMsg() {
/* 493 */     return Optional.empty();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void dispose() {}
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected String getDeviceParam(ILaunchConfiguration config) {
/* 508 */     IConfiguration buildConfig = MCUDebugPlugin.getConfigFromDebugLaunch(config);
/* 509 */     if (buildConfig != null && ToolChainHelper.isArmBareToolchainIntegration(buildConfig)) {
/*     */       try {
/* 511 */         Board board = TargetHelper.getBoard(buildConfig);
/* 512 */         if (board.isGeneric()) {
/* 513 */           Mcu mcu = TargetHelper.getMcu(buildConfig);
/* 514 */           return mcu.getName();
/*     */         } 
/* 516 */         return board.getName();
/*     */       }
/* 518 */       catch (CoreException|org.eclipse.cdt.managedbuilder.core.BuildException e) {
/*     */         try {
/* 520 */           Mcu mcu = TargetHelper.getMcu(buildConfig);
/* 521 */           return mcu.getName();
/* 522 */         } catch (CoreException e1) {
/* 523 */           MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e1);
/*     */         } 
/*     */       } 
/*     */     }
/* 527 */     return "";
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public abstract void createSWVsession(ILaunchConfiguration paramILaunchConfiguration, IGDBControl paramIGDBControl, DsfSession paramDsfSession, RequestMonitor paramRequestMonitor) throws CoreException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean generateServerStartFiles(ILaunchConfiguration configuration) {
/* 544 */     return true;
/*     */   }
/*     */ 
/*     */   
/*     */   public boolean isDebugFeatureSupported(DebugFeatureEnum feature) {
/* 549 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void doSetInitCommands(ILaunchConfiguration configuration, List<GDBServerCommandGroup> commandGroups) throws CoreException {}
/*     */ 
/*     */ 
/*     */   
/*     */   public void doSetDebugCommands(ILaunchConfiguration configuration, List<GDBServerCommandGroup> commandGroups) throws CoreException {}
/*     */ 
/*     */ 
/*     */   
/*     */   public void resizeScrolledComposite() {
/* 564 */     getDebuggerTab().resizeScrolledComposite();
/*     */   }
/*     */   
/*     */   public void doOnApply(ILaunchConfigurationWorkingCopy configuraiton) {}
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\device\AbstractDebugHardware.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */