/*     */ package com.st.stm32cube.ide.mcu.debug.launch.device;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.ui.IDebuggerTab;
/*     */ import org.eclipse.jface.layout.GridDataFactory;
/*     */ import org.eclipse.jface.layout.GridLayoutFactory;
/*     */ import org.eclipse.swt.events.ModifyEvent;
/*     */ import org.eclipse.swt.events.ModifyListener;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Control;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Text;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ClockSettingsWidget
/*     */   extends Composite
/*     */ {
/*     */   private static final String EMPTY_STRING = "";
/*     */   private Text coreClock;
/*     */   private Label lblCoreClock;
/*     */   private Button btnLimit;
/*     */   private Text maxSwoClock;
/*     */   private Label lblMaxSwoClock;
/*     */   private String maxSwoClockValue;
/*     */   
/*     */   public ClockSettingsWidget(Composite parent, int style, final IDebuggerTab page) {
/*  42 */     super(parent, style);
/*     */     
/*  44 */     GridLayoutFactory.fillDefaults().applyTo(this);
/*  45 */     GridDataFactory.fillDefaults().grab(true, true).align(4, 16777216).applyTo((Control)this);
/*     */     
/*  47 */     this.lblCoreClock = new Label(parent, 0);
/*  48 */     this.lblCoreClock.setText(Messages.ClockSettingsWidget_0);
/*  49 */     GridDataFactory.swtDefaults().applyTo((Control)this.lblCoreClock);
/*     */     
/*  51 */     this.coreClock = new Text(parent, 2048);
/*  52 */     GridDataFactory.swtDefaults().hint(100, -1).applyTo((Control)this.coreClock);
/*  53 */     this.coreClock.addModifyListener(new ModifyListener()
/*     */         {
/*     */           public void modifyText(ModifyEvent e) {
/*  56 */             page.updateLaunchConfigurationDialog();
/*     */           }
/*     */         });
/*     */     
/*  60 */     this.btnLimit = new Button(parent, 32);
/*  61 */     GridDataFactory.swtDefaults().span(2, 1).applyTo((Control)this.btnLimit);
/*  62 */     this.btnLimit.setText(Messages.ClockSettingsWidget_1);
/*     */     
/*  64 */     this.lblMaxSwoClock = new Label(parent, 0);
/*  65 */     this.lblMaxSwoClock.setText(Messages.ClockSettingsWidget_2);
/*  66 */     GridDataFactory.swtDefaults().align(4, 16777216).applyTo((Control)this.lblMaxSwoClock);
/*     */     
/*  68 */     this.maxSwoClock = new Text(parent, 2048);
/*  69 */     GridDataFactory.swtDefaults().hint(100, -1).applyTo((Control)this.maxSwoClock);
/*  70 */     this.maxSwoClock.addModifyListener(new ModifyListener()
/*     */         {
/*     */           public void modifyText(ModifyEvent e) {
/*  73 */             if (ClockSettingsWidget.this.btnLimit.getSelection()) {
/*  74 */               ClockSettingsWidget.this.maxSwoClockValue = ClockSettingsWidget.this.maxSwoClock.getText();
/*     */             }
/*  76 */             page.updateLaunchConfigurationDialog();
/*     */           }
/*     */         });
/*     */     
/*  80 */     this.btnLimit.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/*  83 */             ClockSettingsWidget.this.setEnabled(ClockSettingsWidget.this.isEnabled());
/*  84 */             ClockSettingsWidget.this.maxSwoClock.setText(ClockSettingsWidget.this.btnLimit.getSelection() ? ClockSettingsWidget.this.maxSwoClockValue : Messages.ClockSettingsWidget_3);
/*  85 */             page.updateLaunchConfigurationDialog();
/*     */           }
/*     */         });
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getCoreClock() {
/*     */     try {
/*  96 */       int value = (int)(Double.parseDouble(this.coreClock.getText()) * 1000000.0D);
/*  97 */       return value;
/*  98 */     } catch (NumberFormatException e) {
/*  99 */       return "";
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getMaxSwoClock() {
/*     */     try {
/* 109 */       int value = (int)(Double.parseDouble(this.maxSwoClockValue) * 1000.0D);
/* 110 */       return value;
/* 111 */     } catch (NullPointerException|NumberFormatException e) {
/* 112 */       return "";
/*     */     } 
/*     */   }
/*     */   
/*     */   public boolean isSwoClockLimited() {
/* 117 */     return this.btnLimit.getSelection();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setCoreClock(String value) {
/*     */     try {
/* 126 */       double coreClockMhz = Integer.parseInt(value) / 1000000.0D;
/* 127 */       this.coreClock.setText(coreClockMhz);
/* 128 */     } catch (NumberFormatException e) {
/* 129 */       this.coreClock.setText("");
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setMaxSwoClock(String value, boolean isSwoClockLimited) {
/*     */     try {
/* 139 */       this.maxSwoClockValue = Integer.parseInt(value) / 1000;
/* 140 */     } catch (NumberFormatException e) {
/* 141 */       this.maxSwoClockValue = "";
/*     */     } 
/* 143 */     this.btnLimit.setSelection(isSwoClockLimited);
/* 144 */     this.maxSwoClock.setText(isSwoClockLimited ? this.maxSwoClockValue : Messages.ClockSettingsWidget_3);
/* 145 */     setEnabled(isEnabled());
/*     */   }
/*     */ 
/*     */   
/*     */   public void setEnabled(boolean enabled) {
/* 150 */     super.setEnabled(enabled);
/* 151 */     this.coreClock.setEnabled(enabled);
/* 152 */     this.lblCoreClock.setEnabled(enabled);
/* 153 */     this.btnLimit.setEnabled(enabled);
/* 154 */     this.lblMaxSwoClock.setEnabled((enabled && this.btnLimit.getSelection()));
/* 155 */     this.maxSwoClock.setEnabled((enabled && this.btnLimit.getSelection()));
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\device\ClockSettingsWidget.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */