/*     */ package com.st.stm32cube.ide.mcu.debug.launch.handler;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.IRestartConfigurationsService;
/*     */ import java.util.Optional;
/*     */ import java.util.concurrent.Executor;
/*     */ import org.eclipse.cdt.dsf.concurrent.DsfExecutor;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.datamodel.DMContexts;
/*     */ import org.eclipse.cdt.dsf.debug.service.command.ICommandControlService;
/*     */ import org.eclipse.cdt.dsf.service.DsfServicesTracker;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.cdt.dsf.ui.viewmodel.datamodel.IDMVMContext;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.commands.IDebugCommandRequest;
/*     */ import org.eclipse.debug.core.commands.IEnabledStateRequest;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DSFRestartConfigurationsHandler
/*     */   implements IRestartConfigurationsHandler
/*     */ {
/*     */   private final DsfExecutor fExecutor;
/*     */   private final DsfSession fSession;
/*     */   private final ILaunch fLaunch;
/*     */   
/*     */   public DSFRestartConfigurationsHandler(DsfSession session, ILaunch launch) {
/*  39 */     this.fSession = session;
/*  40 */     this.fExecutor = this.fSession.getExecutor();
/*  41 */     this.fLaunch = launch;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void canExecute(IEnabledStateRequest request) {
/*  52 */     request.setEnabled(true);
/*  53 */     request.done();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean execute(final IDebugCommandRequest request) {
/*  64 */     Optional<ICommandControlService.ICommandControlDMContext> context = getContext(request);
/*  65 */     if (!context.isPresent()) {
/*  66 */       request.done();
/*  67 */       return false;
/*     */     } 
/*     */     
/*  70 */     DsfServicesTracker tracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), this.fSession.getId());
/*  71 */     IRestartConfigurationsService funcService = (IRestartConfigurationsService)tracker.getService(IRestartConfigurationsService.class);
/*  72 */     tracker.dispose();
/*  73 */     funcService.doRestartConfigurations(context.get(), request, this.fLaunch, 
/*  74 */         new RequestMonitor((Executor)this.fExecutor, null)
/*     */         {
/*     */           protected void handleCompleted() {
/*  77 */             if (!request.isCanceled()) {
/*  78 */               request.done();
/*     */             }
/*     */           }
/*     */         });
/*  82 */     return true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private Optional<ICommandControlService.ICommandControlDMContext> getContext(IDebugCommandRequest request) {
/*  91 */     if ((request.getElements()).length != 1 || !(request.getElements()[0] instanceof IDMVMContext)) {
/*  92 */       return Optional.empty();
/*     */     }
/*     */     
/*  95 */     IDMVMContext context = (IDMVMContext)request.getElements()[0];
/*  96 */     ICommandControlService.ICommandControlDMContext controlDmc = (ICommandControlService.ICommandControlDMContext)DMContexts.getAncestorOfType(context.getDMContext(), ICommandControlService.ICommandControlDMContext.class);
/*  97 */     if (controlDmc != null) {
/*  98 */       return Optional.of(controlDmc);
/*     */     }
/* 100 */     return Optional.empty();
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\handler\DSFRestartConfigurationsHandler.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */