/*     */ package com.st.stm32cube.ide.mcu.debug.launch.service.restart;
/*     */ 
/*     */ import com.st.stm32cube.ide.common.utils.ThreadHelper;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.GDBServerCommandGroup;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.LaunchSequenceUtil;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.ResetStrategy;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.RestartStrategy;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.concurrent.Executor;
/*     */ import org.eclipse.cdt.dsf.concurrent.DataRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.ImmediateRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.ReflectionSequence;
/*     */ import org.eclipse.cdt.dsf.concurrent.ReflectionSequence.Execute;
/*     */ import org.eclipse.cdt.dsf.concurrent.ReflectionSequence.RollBack;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.datamodel.DMContexts;
/*     */ import org.eclipse.cdt.dsf.debug.service.IRunControl;
/*     */ import org.eclipse.cdt.dsf.debug.service.command.ICommandControlService;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.dsf.gdb.service.IGDBProcesses;
/*     */ import org.eclipse.cdt.dsf.service.DsfServicesTracker;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.cdt.dsf.ui.viewmodel.datamodel.IDMVMContext;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IStatus;
/*     */ import org.eclipse.core.runtime.Status;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.commands.IDebugCommandRequest;
/*     */ import org.eclipse.jface.dialogs.MessageDialog;
/*     */ import org.eclipse.osgi.util.NLS;
/*     */ import org.eclipse.ui.PlatformUI;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestartServiceSequence
/*     */   extends ReflectionSequence
/*     */ {
/*     */   private DsfServicesTracker fTracker;
/*     */   private GdbLaunch fLaunch;
/*     */   private RestartStrategy fRestartStrategy;
/*     */   private IDebugCommandRequest fRequest;
/*     */   
/*     */   public RestartServiceSequence(ILaunch launch, DsfSession session, RestartStrategy restartStrategy, RequestMonitor rm, IDebugCommandRequest request) {
/*  86 */     super(session.getExecutor(), rm);
/*  87 */     this.fLaunch = (GdbLaunch)launch;
/*  88 */     this.fRestartStrategy = restartStrategy;
/*  89 */     this.fRequest = request;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected String[] getExecutionOrder(String groupName) {
/*  99 */     if ("GROUP_TOP_LEVEL".equals(groupName)) {
/* 100 */       return new String[] { "stepInitializeBaseSequence", 
/* 101 */           "stepSuspendTarget", 
/* 102 */           "stepResetHaltTarget", 
/* 103 */           "stepUserCommands", 
/* 104 */           "stepConfigureSwv", 
/* 105 */           "stepSetupExceptions", 
/* 106 */           "stepRestart", 
/* 107 */           "stepCleanupBaseSequence" };
/*     */     }
/*     */     
/* 110 */     return null;
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepInitializeBaseSequence(RequestMonitor rm) {
/* 115 */     this.fTracker = new DsfServicesTracker(MCUDebugPlugin.getBundleContext(), this.fLaunch.getSession().getId());
/* 116 */     rm.done();
/*     */   }
/*     */ 
/*     */   
/*     */   @RollBack("stepInitializeBaseSequence")
/*     */   public void rollBackInitializeBaseSequence(RequestMonitor rm) {
/* 122 */     this.fTracker.dispose();
/* 123 */     this.fTracker = null;
/* 124 */     rm.done();
/*     */   }
/*     */   
/*     */   @Execute
/*     */   public void stepSuspendTarget(RequestMonitor rm) {
/* 129 */     IRunControl runControl = (IRunControl)this.fTracker.getService(IRunControl.class);
/* 130 */     IRunControl.IContainerDMContext containerDmc = getContainerDMContext();
/* 131 */     if (containerDmc != null && runControl != null) {
/* 132 */       if (!runControl.isSuspended((IRunControl.IExecutionDMContext)containerDmc)) {
/*     */         
/* 134 */         runControl.suspend((IRunControl.IExecutionDMContext)containerDmc, (RequestMonitor)new ImmediateRequestMonitor(rm));
/*     */       } else {
/*     */         
/* 137 */         rm.done();
/*     */       } 
/*     */     } else {
/*     */       
/* 141 */       rm.setStatus((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", "Failed to check target state."));
/* 142 */       rm.done();
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepCleanupBaseSequence(RequestMonitor rm) {
/* 149 */     this.fTracker.dispose();
/* 150 */     this.fTracker = null;
/* 151 */     rm.done();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepResetHaltTarget(RequestMonitor rm) {
/* 165 */     GDBServerCommandGroup comGroup = new GDBServerCommandGroup("Reset Command");
/* 166 */     ResetStrategy resetStrategy = ResetStrategy.find(this.fRestartStrategy.getResetAttribute(), this.fRestartStrategy.getResetStrategies(), ResetStrategy.ResetStrategySearchKey.NAME);
/* 167 */     if (resetStrategy != null) {
/* 168 */       resetStrategy.getGDBCommands().forEach(s -> paramGDBServerCommandGroup.addCommand(s.trim()));
/* 169 */       LaunchSequenceUtil.executeCommandGroups(rm, Arrays.asList(new GDBServerCommandGroup[] { comGroup }, ), this.fLaunch, getExecutor());
/*     */     } else {
/* 171 */       String title = "Reset type not found";
/* 172 */       String msg = NLS.bind("Unable to find reset type ''{0}''.\nPlease reconfigure your Restart Configuration.", this.fRestartStrategy.getResetAttribute());
/* 173 */       ThreadHelper.runInUiThreadAsync(() -> MessageDialog.openError(PlatformUI.getWorkbench().getDisplay().getActiveShell(), paramString1, paramString2));
/* 174 */       rm.cancel();
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepUserCommands(RequestMonitor rm) {
/* 189 */     List<GDBServerCommandGroup> gdbCommandGroups = new ArrayList<>();
/* 190 */     gdbCommandGroups.add(this.fRestartStrategy.getGdbCommandGroup());
/* 191 */     if (!gdbCommandGroups.isEmpty()) {
/* 192 */       LaunchSequenceUtil.executeCommandGroups(rm, gdbCommandGroups, this.fLaunch, getExecutor());
/*     */     } else {
/* 194 */       rm.done();
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepConfigureSwv(RequestMonitor rm) {
/* 209 */     Map<String, Object> attributes = new HashMap<>();
/*     */     try {
/* 211 */       attributes = this.fLaunch.getLaunchConfiguration().getAttributes();
/* 212 */     } catch (CoreException coreException) {}
/* 213 */     LaunchSequenceUtil.stepConfigureSwv(rm, this.fLaunch, getExecutor(), attributes);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepSetupExceptions(RequestMonitor rm) {
/* 224 */     LaunchSequenceUtil.stepSetupExceptions(rm, this.fLaunch, getExecutor());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @Execute
/*     */   public void stepRestart(RequestMonitor rm) {
/* 238 */     if (!this.fRestartStrategy.getStartApplication()) {
/* 239 */       ICommandControlService commandControl = (ICommandControlService)this.fTracker.getService(ICommandControlService.class);
/* 240 */       commandControl.flushAllCachesAndRefresh(rm);
/* 241 */       this.fRequest.done();
/*     */       
/*     */       return;
/*     */     } 
/* 245 */     IRunControl.IContainerDMContext containerDmc = getContainerDMContext();
/*     */     
/* 247 */     if (containerDmc == null) {
/* 248 */       this.fRequest.cancel();
/* 249 */       rm.done();
/*     */       
/*     */       return;
/*     */     } 
/* 253 */     IGDBProcesses procService = (IGDBProcesses)this.fTracker.getService(IGDBProcesses.class);
/*     */     
/* 255 */     if (procService != null) {
/* 256 */       Map<String, Object> attributes = null;
/*     */       try {
/* 258 */         attributes = this.fLaunch.getLaunchConfiguration().getAttributes();
/* 259 */       } catch (CoreException coreException) {}
/*     */       
/* 261 */       procService.restart(containerDmc, attributes, 
/* 262 */           new DataRequestMonitor<IRunControl.IContainerDMContext>((Executor)getExecutor(), rm)
/*     */           {
/*     */             protected void handleCompleted() {
/* 265 */               if (!RestartServiceSequence.this.fRequest.isCanceled()) {
/* 266 */                 RestartServiceSequence.this.fRequest.done();
/*     */               }
/*     */             }
/*     */           });
/*     */     } else {
/* 271 */       rm.done();
/* 272 */       this.fRequest.done();
/*     */     } 
/*     */   }
/*     */   
/*     */   private IRunControl.IContainerDMContext getContainerDMContext() {
/* 277 */     if ((this.fRequest.getElements()).length == 1) {
/* 278 */       Object element = this.fRequest.getElements()[0];
/* 279 */       if (element instanceof IDMVMContext) {
/* 280 */         return (IRunControl.IContainerDMContext)DMContexts.getAncestorOfType(((IDMVMContext)element).getDMContext(), IRunControl.IContainerDMContext.class);
/*     */       }
/*     */     } 
/* 283 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\service\restart\RestartServiceSequence.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */