/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import org.eclipse.core.runtime.Assert;
/*     */ import org.eclipse.swt.events.PaintEvent;
/*     */ import org.eclipse.swt.events.PaintListener;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.graphics.Point;
/*     */ import org.eclipse.swt.layout.GridData;
/*     */ import org.eclipse.swt.layout.GridLayout;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Layout;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ @Deprecated
/*     */ public class BreakCrossTriggeringMatrix
/*     */   extends Composite
/*     */ {
/*     */   private static final String KEY_CORE_SRC = "KEY_CORE_SRC";
/*     */   private static final String KEY_CORE_DST = "KEY_CORE_DST";
/*     */   private Integer coreCount;
/*     */   private String[] coreLabels;
/*  40 */   private List<BctmListener> listeners = new ArrayList<>();
/*     */   private final BctmConfiguration configuration;
/*  42 */   private List<Button> fBctmButtonList = new ArrayList<>();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static class BctmConfiguration
/*     */   {
/*     */     public final boolean[][] breakMatrix;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public BctmConfiguration(int coreCount) {
/*  62 */       this.breakMatrix = new boolean[coreCount][coreCount];
/*  63 */       for (int i = 0; i < coreCount; i++) {
/*  64 */         for (int j = 0; j < coreCount; j++) {
/*  65 */           this.breakMatrix[i][j] = false;
/*     */         }
/*     */       } 
/*     */     }
/*     */     
/*     */     public void setAll(boolean value) {
/*  71 */       int size = this.breakMatrix.length;
/*  72 */       for (int i = 0; i < size; i++) {
/*  73 */         for (int j = 0; j < size; j++) {
/*  74 */           if (i != j) this.breakMatrix[i][j] = value;
/*     */         
/*     */         } 
/*     */       } 
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public BreakCrossTriggeringMatrix(Composite parent) {
/*  87 */     this(parent, 2, (String[])null);
/*     */   }
/*     */   
/*     */   public BreakCrossTriggeringMatrix(Composite parent, Integer coreCount) {
/*  91 */     this(parent, coreCount.intValue(), (String[])null);
/*     */   }
/*     */   
/*     */   public BreakCrossTriggeringMatrix(Composite parent, int coreCount, String[] labels) {
/*  95 */     this(parent, coreCount, labels, new BctmConfiguration(coreCount));
/*     */   }
/*     */ 
/*     */   
/*     */   public BreakCrossTriggeringMatrix(Composite parent, int coreCount, String[] labels, BctmConfiguration configuration) {
/* 100 */     super(parent, 0);
/* 101 */     setLayout((Layout)new GridLayout());
/* 102 */     this.coreCount = Integer.valueOf(coreCount);
/* 103 */     if (labels != null) {
/* 104 */       Assert.isTrue((coreCount == labels.length), "coreCount and label.length must be equals");
/* 105 */       this.coreLabels = new String[labels.length];
/* 106 */       System.arraycopy(labels, 0, this.coreLabels, 0, this.coreLabels.length);
/*     */     } else {
/* 108 */       this.coreLabels = new String[coreCount];
/* 109 */       for (int c = 0; c < coreCount; c++) {
/* 110 */         this.coreLabels[c] = Integer.toString(c);
/*     */       }
/*     */     } 
/*     */     
/* 114 */     this.configuration = configuration;
/*     */     
/* 116 */     createContent();
/*     */   }
/*     */   
/*     */   public BctmConfiguration getConfiguration() {
/* 120 */     return this.configuration;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void createContent() {
/* 132 */     if (this.coreCount.intValue() > 2) {
/* 133 */       createMatrix();
/*     */     } else {
/* 135 */       createSimpleMode();
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*     */   protected void configureAll(boolean value) {
/* 141 */     for (Button breakButton : this.fBctmButtonList) {
/* 142 */       if (breakButton.getSelection() != value) {
/* 143 */         breakButton.setSelection(value);
/*     */       }
/*     */     } 
/*     */   }
/*     */ 
/*     */   
/*     */   public void setEnabled(boolean enabled) {
/* 150 */     for (Button breakButton : this.fBctmButtonList) {
/* 151 */       breakButton.setEnabled(enabled);
/*     */     }
/* 153 */     super.setEnabled(enabled);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void createSimpleMode() {
/* 166 */     for (int c1 = 0; c1 < this.coreCount.intValue(); c1++) {
/* 167 */       for (int c2 = 0; c2 < this.coreCount.intValue(); c2++) {
/* 168 */         if (c1 != c2) {
/*     */ 
/*     */           
/* 171 */           Button breakButton = new Button(this, 32);
/* 172 */           breakButton.setText(String.format("core %s breaks core %s", new Object[] {
/* 173 */                   this.coreLabels[c1], this.coreLabels[c2] }));
/* 174 */           breakButton.setData("KEY_CORE_SRC", Integer.valueOf(c1));
/* 175 */           breakButton.setData("KEY_CORE_DST", Integer.valueOf(c2));
/* 176 */           breakButton.setSelection(this.configuration.breakMatrix[c1][c2]);
/* 177 */           breakButton.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */               {
/*     */                 public void widgetSelected(SelectionEvent e) {
/* 180 */                   BreakCrossTriggeringMatrix.this.selectionChanged((Button)e.widget);
/*     */                 }
/*     */               });
/* 183 */           this.fBctmButtonList.add(breakButton);
/*     */         } 
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected void createMatrix() {
/* 199 */     Composite matrixComp = new Composite(this, 2048);
/* 200 */     GridLayout gl = new GridLayout(this.coreCount.intValue() + 1, true);
/* 201 */     gl.marginWidth = 0;
/* 202 */     gl.marginHeight = 0;
/* 203 */     gl.horizontalSpacing = 0;
/* 204 */     gl.verticalSpacing = 0;
/* 205 */     matrixComp.setLayout((Layout)gl);
/* 206 */     matrixComp.setLayoutData(new GridData(1));
/* 207 */     matrixComp.setBackground(getDisplay().getSystemColor(1));
/* 208 */     matrixComp.setBackgroundMode(2);
/*     */ 
/*     */     
/* 211 */     final Label blankLabel = new Label(matrixComp, 0);
/* 212 */     blankLabel.setLayoutData(new GridData(4, 4, true, true));
/* 213 */     blankLabel.addPaintListener(new PaintListener()
/*     */         {
/*     */           
/*     */           public void paintControl(PaintEvent e)
/*     */           {
/* 218 */             e.gc.setForeground(BreakCrossTriggeringMatrix.this.getDisplay().getSystemColor(15));
/* 219 */             Point p = blankLabel.getSize();
/* 220 */             e.gc.setLineWidth(2);
/* 221 */             e.gc.drawLine(0, p.y, p.x, p.y);
/* 222 */             e.gc.drawLine(p.x, 0, p.x, p.y);
/* 223 */             e.gc.setLineWidth(1);
/* 224 */             e.gc.drawLine(0, 0, p.x, p.y);
/*     */           }
/*     */         });
/*     */ 
/*     */     
/* 229 */     for (int h = 0; h < this.coreCount.intValue(); h++) {
/* 230 */       final Composite lblComp = new Composite(matrixComp, 0);
/* 231 */       lblComp.setLayout((Layout)new GridLayout());
/* 232 */       lblComp.setLayoutData(new GridData(4, 4, true, true));
/* 233 */       lblComp.addPaintListener(new PaintListener()
/*     */           {
/*     */             
/*     */             public void paintControl(PaintEvent e)
/*     */             {
/* 238 */               e.gc.setForeground(BreakCrossTriggeringMatrix.this.getDisplay().getSystemColor(15));
/* 239 */               Point p = lblComp.getSize();
/* 240 */               e.gc.setLineWidth(2);
/* 241 */               e.gc.drawLine(0, p.y, p.x, p.y);
/*     */             }
/*     */           });
/*     */       
/* 245 */       Label label = new Label(lblComp, 0);
/* 246 */       label.setText(Integer.toString(h));
/* 247 */       label.setToolTipText(this.coreLabels[h]);
/* 248 */       label.setLayoutData(new GridData(16777216, 4, true, true));
/*     */     } 
/*     */ 
/*     */     
/* 252 */     for (int l = 0; l < this.coreCount.intValue(); l++) {
/*     */       
/* 254 */       final Composite lblComp = new Composite(matrixComp, 0);
/* 255 */       lblComp.setLayout((Layout)new GridLayout());
/* 256 */       lblComp.setLayoutData(new GridData(4, 4, true, true));
/* 257 */       lblComp.addPaintListener(new PaintListener()
/*     */           {
/*     */             
/*     */             public void paintControl(PaintEvent e)
/*     */             {
/* 262 */               e.gc.setForeground(BreakCrossTriggeringMatrix.this.getDisplay().getSystemColor(15));
/* 263 */               Point p = lblComp.getSize();
/* 264 */               e.gc.setLineWidth(2);
/* 265 */               e.gc.drawLine(p.x, 0, p.x, p.y);
/*     */             }
/*     */           });
/*     */       
/* 269 */       Label lbl = new Label(lblComp, 0);
/* 270 */       lbl.setText(Integer.toString(l));
/* 271 */       lbl.setToolTipText(this.coreLabels[l]);
/* 272 */       lbl.setLayoutData(new GridData(16777216, 4, true, true));
/*     */ 
/*     */       
/* 275 */       for (int c = 0; c < this.coreCount.intValue(); c++) {
/* 276 */         if (c != l) {
/* 277 */           Button b = new Button(matrixComp, 32);
/* 278 */           b.setData("KEY_CORE_SRC", Integer.valueOf(l));
/* 279 */           b.setData("KEY_CORE_DST", Integer.valueOf(c));
/* 280 */           b.setSelection(this.configuration.breakMatrix[l][c]);
/* 281 */           b.setToolTipText(
/* 282 */               String.format("Check this box to indicate that breaks on core %s should stop core %s.", new Object[] {
/* 283 */                   this.coreLabels[l], this.coreLabels[c] }));
/* 284 */           b.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */               {
/*     */                 public void widgetSelected(SelectionEvent e) {
/* 287 */                   BreakCrossTriggeringMatrix.this.selectionChanged((Button)e.widget);
/*     */                 }
/*     */               });
/* 290 */           this.fBctmButtonList.add(b);
/*     */         } else {
/* 292 */           final Label diagBlankLabel = new Label(matrixComp, 0);
/* 293 */           diagBlankLabel.setLayoutData(new GridData(4, 4, true, true));
/* 294 */           diagBlankLabel.addPaintListener(new PaintListener()
/*     */               {
/*     */                 
/*     */                 public void paintControl(PaintEvent e)
/*     */                 {
/* 299 */                   e.gc.setForeground(BreakCrossTriggeringMatrix.this.getDisplay().getSystemColor(15));
/* 300 */                   Point p = diagBlankLabel.getSize();
/* 301 */                   e.gc.setLineWidth(1);
/* 302 */                   e.gc.drawLine(0, 0, p.x, p.y);
/*     */                 }
/*     */               });
/*     */         } 
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void addBctmListener(BctmListener listener) {
/* 341 */     this.listeners.add(listener);
/*     */   }
/*     */   
/*     */   public boolean removeBctmListener(BctmListener listener) {
/* 345 */     return this.listeners.remove(listener);
/*     */   }
/*     */   
/*     */   private void selectionChanged(Button button) {
/* 349 */     int coreSrc = ((Integer)button.getData("KEY_CORE_SRC")).intValue();
/* 350 */     int coreDst = ((Integer)button.getData("KEY_CORE_DST")).intValue();
/* 351 */     boolean stop = button.getSelection();
/* 352 */     this.configuration.breakMatrix[coreSrc][coreDst] = stop;
/* 353 */     fireSelectionChanged(coreSrc, coreDst, stop, this.configuration);
/*     */   }
/*     */ 
/*     */   
/*     */   private void fireSelectionChanged(int coreSrc, int coreDst, boolean stop, BctmConfiguration configuration) {
/* 358 */     for (BctmListener bctmListener : this.listeners)
/* 359 */       bctmListener.selectionChanged(coreSrc, coreDst, stop, configuration); 
/*     */   }
/*     */   
/*     */   public static interface BctmListener {
/*     */     void selectionChanged(int param1Int1, int param1Int2, boolean param1Boolean, BreakCrossTriggeringMatrix.BctmConfiguration param1BctmConfiguration);
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launc\\ui\BreakCrossTriggeringMatrix.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */