/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.Activator;
/*     */ import com.st.stm32cube.ide.mcu.ide.core.TargetHelper;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Mcu;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IStatus;
/*     */ import org.eclipse.core.runtime.Status;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class TabHelper
/*     */ {
/*     */   private static final String EMPTY_STRING = "";
/*     */   private static final String MULTICPU = "_multicpu_";
/*     */   
/*     */   public IProject getProject(ILaunchConfiguration config) throws CoreException {
/*  46 */     IProject project = null;
/*  47 */     String projText = config.getAttribute("org.eclipse.cdt.launch.PROJECT_ATTR", "");
/*     */     
/*  49 */     if (projText != null && !projText.isEmpty()) {
/*  50 */       project = ResourcesPlugin.getWorkspace().getRoot().getProject(projText);
/*     */     }
/*  52 */     return project;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getNbCpusFromConfig(ILaunchConfiguration config) {
/*  63 */     int nbCpus = 1;
/*     */     try {
/*  65 */       IProject project = getProject(config);
/*  66 */       if (project != null) {
/*  67 */         Mcu mcu = TargetHelper.getMcu(project);
/*  68 */         nbCpus = mcu.getCpus().size();
/*     */       } 
/*  70 */     } catch (CoreException ce) {
/*  71 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)ce, "Failed to get number of cpus from config");
/*     */     } 
/*  73 */     return nbCpus;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getBinaryFromConfig(ILaunchConfiguration config) {
/*  84 */     String binStr = "";
/*     */     try {
/*  86 */       binStr = config.getAttribute("org.eclipse.cdt.launch.PROGRAM_NAME", "");
/*  87 */     } catch (CoreException e) {
/*  88 */       Activator.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", 4, e.getMessage(), (Throwable)e));
/*     */     } 
/*  90 */     return binStr;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List<String> getBinariesFromConfig(ILaunchConfiguration config) {
/* 102 */     List<String> fBinaries = new ArrayList<>();
/*     */     try {
/* 104 */       int i = 1;
/* 105 */       String programName = config.getAttribute("org.eclipse.cdt.launch.PROGRAM_NAME", "");
/* 106 */       while (!programName.isEmpty()) {
/* 107 */         fBinaries.add(programName);
/* 108 */         programName = config.getAttribute("org.eclipse.cdt.launch.PROGRAM_NAME_multicpu_" + i, "");
/* 109 */         i++;
/*     */       } 
/* 111 */     } catch (CoreException ce) {
/* 112 */       Activator.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", 4, ce.getMessage(), (Throwable)ce));
/*     */     } 
/* 114 */     return fBinaries;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setAttribute(ILaunchConfigurationWorkingCopy config, String attribute, int index, String value) {
/* 131 */     if (value == null || value.isEmpty()) {
/* 132 */       value = "";
/*     */     }
/* 134 */     if (index > 0) {
/* 135 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/* 137 */     config.setAttribute(attribute, value);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setAttribute(ILaunchConfigurationWorkingCopy config, String attribute, int index, int value) {
/* 154 */     if (index > 0) {
/* 155 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/* 157 */     config.setAttribute(attribute, value);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setAttribute(ILaunchConfigurationWorkingCopy config, String attribute, int index, boolean value) {
/* 174 */     if (index > 0) {
/* 175 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/* 177 */     config.setAttribute(attribute, value);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getAttribute(ILaunchConfiguration config, String attribute, int index, String defaultValue) {
/* 194 */     String value = defaultValue;
/* 195 */     if (index > 0) {
/* 196 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/*     */     try {
/* 199 */       value = config.getAttribute(attribute, defaultValue);
/* 200 */     } catch (CoreException e) {
/* 201 */       Activator.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", 4, e.getMessage(), (Throwable)e));
/*     */     } 
/* 203 */     return value;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public int getAttribute(ILaunchConfiguration config, String attribute, int index, int defaultValue) {
/* 220 */     int value = defaultValue;
/* 221 */     if (index > 0) {
/* 222 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/*     */     try {
/* 225 */       value = config.getAttribute(attribute, defaultValue);
/* 226 */     } catch (CoreException e) {
/* 227 */       Activator.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", 4, e.getMessage(), (Throwable)e));
/*     */     } 
/* 229 */     return value;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean getAttribute(ILaunchConfiguration config, String attribute, int index, boolean defaultValue) {
/* 246 */     boolean value = defaultValue;
/* 247 */     if (index > 0) {
/* 248 */       attribute = String.valueOf(attribute) + "_multicpu_" + index;
/*     */     }
/*     */     try {
/* 251 */       value = config.getAttribute(attribute, defaultValue);
/* 252 */     } catch (CoreException e) {
/* 253 */       Activator.log((IStatus)new Status(4, "com.st.stm32cube.ide.mcu.debug.launch", 4, e.getMessage(), (Throwable)e));
/*     */     } 
/* 255 */     return value;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launc\\ui\TabHelper.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */