/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui.externalloaders;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.common.ui.oss.resources.SWTResourceManager;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.Activator;
/*     */ import com.st.stm32cube.ide.mcu.externaltools.MCUExternalToolsPlugin;
/*     */ import java.io.File;
/*     */ import java.util.ArrayList;
/*     */ import java.util.List;
/*     */ import java.util.stream.Collectors;
/*     */ import org.eclipse.core.resources.IFile;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.core.variables.VariablesPlugin;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ import org.eclipse.jface.dialogs.TitleAreaDialog;
/*     */ import org.eclipse.jface.layout.GridDataFactory;
/*     */ import org.eclipse.jface.layout.GridLayoutFactory;
/*     */ import org.eclipse.jface.viewers.ArrayContentProvider;
/*     */ import org.eclipse.jface.viewers.CellLabelProvider;
/*     */ import org.eclipse.jface.viewers.ColumnLabelProvider;
/*     */ import org.eclipse.jface.viewers.DoubleClickEvent;
/*     */ import org.eclipse.jface.viewers.IContentProvider;
/*     */ import org.eclipse.jface.viewers.IDoubleClickListener;
/*     */ import org.eclipse.jface.viewers.ILabelProvider;
/*     */ import org.eclipse.jface.viewers.ISelection;
/*     */ import org.eclipse.jface.viewers.ISelectionChangedListener;
/*     */ import org.eclipse.jface.viewers.IStructuredSelection;
/*     */ import org.eclipse.jface.viewers.ITreeContentProvider;
/*     */ import org.eclipse.jface.viewers.SelectionChangedEvent;
/*     */ import org.eclipse.jface.viewers.TableViewer;
/*     */ import org.eclipse.jface.viewers.TableViewerColumn;
/*     */ import org.eclipse.swt.events.ModifyEvent;
/*     */ import org.eclipse.swt.events.ModifyListener;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.graphics.Image;
/*     */ import org.eclipse.swt.layout.GridData;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Combo;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Control;
/*     */ import org.eclipse.swt.widgets.Display;
/*     */ import org.eclipse.swt.widgets.FileDialog;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Shell;
/*     */ import org.eclipse.swt.widgets.Table;
/*     */ import org.eclipse.swt.widgets.TableColumn;
/*     */ import org.eclipse.ui.dialogs.ElementTreeSelectionDialog;
/*     */ import org.eclipse.ui.model.BaseWorkbenchContentProvider;
/*     */ import org.eclipse.ui.model.WorkbenchLabelProvider;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class CubeProgExtLoadersLaunchWidget
/*     */   extends Composite
/*     */ {
/*     */   private Composite fBaseComp;
/*     */   private TableViewer fTableViewer;
/*     */   
/*     */   public class CubeProgExtLoadersAddEditDialog
/*     */     extends TitleAreaDialog
/*     */   {
/*     */     private static final String BTN_BROWSE_WS_LABEL = "Workspace...";
/*     */     private static final String BTN_BROWSE_FS_LABEL = "File system...";
/*     */     private static final String LBL_LOADER_SELECTION = "External Loader:";
/*     */     private static final String BTN_INITIALIZE_LABEL = "Initialize";
/*     */     private static final String BTN_ENABLED_LABEL = "Enabled";
/*     */     private static final String ADD_SHELL_TITLE = "External Loader";
/*     */     private static final String ADD_DIALOG_TITLE = "Add External Loader";
/*     */     private static final String EDIT_DIALOG_TITLE = "Edit External Loader";
/*     */     private static final String ADD_DIALOG_MSG = "Select the external loader to add to the launch configuration";
/*     */     private static final String EDIT_DIALOG_MSG = "";
/*     */     private static final String ADD_DIALOG_LOADER_NOT_FOUND_ERROR_MSG = "External loader not found";
/*     */     private static final String ADD_DIALOG_LOADER_DUPLICATE_ERROR_MSG = "Duplicate external loader";
/*     */     private static final String BROWSE_WS_DIALOG_TITLE = "External loader selection";
/*     */     private static final String BROWSE_WS_DIALOG_MSG = "Select external loader from workspace";
/*     */     private static final String BROWSE_FS_DIALOG_TITLE = "Select external loader";
/*     */     private static final String LOADER_FILE_EXTENSION = "stldr";
/*     */     private Button fBtnBrowseCustomWs;
/*     */     private Button fBtnBrowseCustomFs;
/*     */     private Combo fComboLoaderSelection;
/*     */     private Button fBtnInitialize;
/*     */     private Button fBtnEnabled;
/* 100 */     private CubeProgExtLoader fLoaderInfo = null;
/*     */     
/*     */     public CubeProgExtLoadersAddEditDialog(Shell parentShell, CubeProgExtLoader edit) {
/* 103 */       super(parentShell);
/* 104 */       this.fLoaderInfo = edit;
/*     */     }
/*     */ 
/*     */     
/*     */     public void create() {
/* 109 */       super.create();
/* 110 */       getShell().setText("External Loader");
/* 111 */       if (this.fLoaderInfo == null) {
/* 112 */         setTitle("Add External Loader");
/* 113 */         setMessage("Select the external loader to add to the launch configuration");
/*     */       } else {
/* 115 */         setTitle("Edit External Loader");
/* 116 */         setMessage("");
/*     */       } 
/*     */       
/* 119 */       validate();
/*     */     }
/*     */ 
/*     */     
/*     */     protected Control createDialogArea(Composite parent) {
/* 124 */       Composite dlgArea = (Composite)super.createDialogArea(parent);
/* 125 */       Composite baseComposite = new Composite(dlgArea, 0);
/*     */       
/* 127 */       GridLayoutFactory.swtDefaults().numColumns(4).applyTo(baseComposite);
/* 128 */       GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)baseComposite);
/*     */       
/* 130 */       (new Label(baseComposite, 0)).setText("External Loader:");
/*     */       
/* 132 */       this.fComboLoaderSelection = new Combo(baseComposite, 0);
/* 133 */       GridDataFactory.fillDefaults().grab(true, false).span(1, 1).applyTo((Control)this.fComboLoaderSelection);
/* 134 */       List<String> builtinLoaders = CubeProgExtLoadersLaunchWidget.this.getBuiltIns();
/* 135 */       this.fComboLoaderSelection.setItems(builtinLoaders.<String>toArray(new String[builtinLoaders.size()]));
/*     */       
/* 137 */       this.fComboLoaderSelection.addModifyListener(new ModifyListener()
/*     */           {
/*     */             public void modifyText(ModifyEvent e) {
/* 140 */               CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.validate();
/*     */             }
/*     */           });
/*     */       
/* 144 */       this.fBtnBrowseCustomWs = new Button(baseComposite, 8);
/* 145 */       this.fBtnBrowseCustomWs.setText("Workspace...");
/* 146 */       this.fBtnBrowseCustomWs.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 149 */               ElementTreeSelectionDialog dialog = new ElementTreeSelectionDialog(CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.getShell(), (ILabelProvider)new WorkbenchLabelProvider(), (ITreeContentProvider)new BaseWorkbenchContentProvider());
/* 150 */               dialog.setTitle("External loader selection");
/* 151 */               dialog.setMessage("Select external loader from workspace");
/* 152 */               dialog.setInput(ResourcesPlugin.getWorkspace().getRoot());
/*     */               
/* 154 */               if (dialog.open() == 0) {
/* 155 */                 Object sel = dialog.getFirstResult();
/* 156 */                 if (sel instanceof IFile) {
/* 157 */                   String newValue = "${workspace_loc:" + ((IFile)sel).getFullPath() + "}";
/* 158 */                   CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.add(newValue);
/* 159 */                   CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.select(CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.getItemCount() - 1);
/*     */                 } 
/*     */               } 
/*     */             }
/*     */           });
/*     */       
/* 165 */       this.fBtnBrowseCustomFs = new Button(baseComposite, 8);
/* 166 */       this.fBtnBrowseCustomFs.setText("File system...");
/* 167 */       this.fBtnBrowseCustomFs.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 170 */               FileDialog dialog = new FileDialog(CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.getShell(), 0);
/* 171 */               dialog.setFilterExtensions(new String[] { "*.stldr" });
/* 172 */               dialog.setText("Select external loader");
/* 173 */               String selected = dialog.open();
/* 174 */               if (selected != null) {
/* 175 */                 CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.add(selected);
/* 176 */                 CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.select(CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog.this.fComboLoaderSelection.getItemCount() - 1);
/*     */               } 
/*     */             }
/*     */           });
/*     */       
/* 181 */       this.fBtnEnabled = new Button(baseComposite, 32);
/* 182 */       this.fBtnEnabled.setText("Enabled");
/* 183 */       GridDataFactory.fillDefaults().span(4, 1).applyTo((Control)this.fBtnEnabled);
/*     */       
/* 185 */       this.fBtnInitialize = new Button(baseComposite, 32);
/* 186 */       this.fBtnInitialize.setText("Initialize");
/* 187 */       GridDataFactory.fillDefaults().span(4, 1).applyTo((Control)this.fBtnInitialize);
/*     */ 
/*     */       
/* 190 */       if (this.fLoaderInfo != null) {
/*     */         
/* 192 */         int listIdx = CubeProgExtLoadersLaunchWidget.this.getBuiltIns().indexOf(this.fLoaderInfo.getLoaderPath());
/* 193 */         if (-1 == listIdx) {
/*     */           
/* 195 */           this.fComboLoaderSelection.add(this.fLoaderInfo.getLoaderPath());
/* 196 */           this.fComboLoaderSelection.select(this.fComboLoaderSelection.getItemCount() - 1);
/*     */         } else {
/*     */           
/* 199 */           this.fComboLoaderSelection.select(listIdx);
/*     */         } 
/* 201 */         this.fBtnEnabled.setSelection(this.fLoaderInfo.getEnabled());
/* 202 */         this.fBtnInitialize.setSelection(this.fLoaderInfo.getInitialize());
/*     */       } else {
/*     */         
/* 205 */         this.fComboLoaderSelection.select(0);
/* 206 */         this.fBtnInitialize.setSelection(false);
/* 207 */         this.fBtnEnabled.setSelection(true);
/*     */       } 
/*     */       
/* 210 */       this.fBtnInitialize.setEnabled(CubeProgExtLoadersLaunchWidget.this.initializeAllowed(this.fLoaderInfo));
/* 211 */       return (Control)dlgArea;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public CubeProgExtLoader getLoaderInfo() {
/* 219 */       return this.fLoaderInfo;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     private boolean isBuiltIn(String loaderId) {
/* 228 */       return CubeProgExtLoadersLaunchWidget.this.getBuiltIns().contains(loaderId);
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     private boolean checkValidPath(String loaderId) {
/*     */       try {
/* 238 */         String loaderIdResolved = VariablesPlugin.getDefault().getStringVariableManager().performStringSubstitution(loaderId);
/* 239 */         Path loaderPath = new Path(loaderIdResolved);
/* 240 */         String loaderExt = loaderPath.getFileExtension();
/* 241 */         if (loaderExt != null && loaderExt.equals("stldr")) {
/* 242 */           File loaderFile = new File(loaderPath.toOSString());
/* 243 */           return loaderFile.isFile();
/*     */         } 
/* 245 */       } catch (CoreException coreException) {}
/*     */ 
/*     */       
/* 248 */       return false;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     private boolean isDuplicate(String loaderId) {
/* 257 */       return CubeProgExtLoadersLaunchWidget.this.fLoaders.stream().filter(e -> e.getLoaderPath().equals(param1String)).findAny().isPresent();
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     private void validate() {
/* 264 */       String loaderPath = this.fComboLoaderSelection.getText();
/* 265 */       Button okBtn = getButton(0);
/* 266 */       if (okBtn != null) {
/* 267 */         String editId = (this.fLoaderInfo != null) ? this.fLoaderInfo.getLoaderPath() : "";
/*     */         
/* 269 */         if (!loaderPath.equals(editId) && isDuplicate(loaderPath)) {
/* 270 */           okBtn.setEnabled(false);
/* 271 */           setErrorMessage("Duplicate external loader");
/*     */         
/*     */         }
/* 274 */         else if (isBuiltIn(loaderPath) || checkValidPath(loaderPath)) {
/* 275 */           okBtn.setEnabled(true);
/* 276 */           setErrorMessage(null);
/*     */         } else {
/* 278 */           okBtn.setEnabled(false);
/* 279 */           setErrorMessage("External loader not found");
/*     */         } 
/*     */       } 
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     protected void okPressed() {
/* 288 */       if (this.fLoaderInfo == null) {
/* 289 */         this.fLoaderInfo = new CubeProgExtLoader();
/*     */       }
/*     */       
/* 292 */       String loaderId = this.fComboLoaderSelection.getText();
/* 293 */       this.fLoaderInfo.setLoaderPath(loaderId);
/* 294 */       if (this.fBtnInitialize.isEnabled()) {
/* 295 */         this.fLoaderInfo.setInitialize(this.fBtnInitialize.getSelection());
/*     */       } else {
/* 297 */         this.fLoaderInfo.setInitialize(false);
/*     */       } 
/* 299 */       this.fLoaderInfo.setEnabled(this.fBtnEnabled.getSelection());
/* 300 */       super.okPressed();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */   
/* 306 */   private List<CubeProgExtLoader> fLoaders = new ArrayList<>();
/*     */   
/*     */   private Runnable fAttributeChangedListener;
/*     */   private Button fAddBtn;
/*     */   private Button fRemoveBtn;
/*     */   private Button fEditBtn;
/*     */   private List<String> fAvailableLoaders;
/*     */   
/*     */   public CubeProgExtLoadersLaunchWidget(Composite parent, int style) {
/* 315 */     super(parent, style);
/* 316 */     GridLayoutFactory.swtDefaults().margins(0, 0).applyTo(this);
/* 317 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)this);
/* 318 */     createUI(this);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void initializeFrom(ILaunchConfiguration configuration) {
/* 326 */     this.fLoaders.clear();
/*     */     try {
/* 328 */       String attribute = configuration.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.cubeprog_external_loaders", "").trim();
/* 329 */       this.fLoaders.addAll(CubeProgExtLoader.fromJson(attribute));
/* 330 */     } catch (CoreException coreException) {}
/*     */ 
/*     */     
/* 333 */     this.fTableViewer.refresh();
/* 334 */     this.fRemoveBtn.setEnabled(false);
/* 335 */     this.fEditBtn.setEnabled(false);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void initializeFrom(List<CubeProgExtLoader> loaders) {
/* 343 */     this.fLoaders.clear();
/* 344 */     this.fLoaders.addAll(loaders);
/* 345 */     this.fTableViewer.refresh();
/* 346 */     this.fRemoveBtn.setEnabled(false);
/* 347 */     this.fEditBtn.setEnabled(false);
/*     */   }
/*     */ 
/*     */   
/*     */   public void setEnabled(boolean enabled) {
/* 352 */     this.fBaseComp.setEnabled(enabled);
/* 353 */     this.fTableViewer.getTable().setEnabled(enabled);
/* 354 */     this.fTableViewer.getTable().setHeaderVisible(enabled);
/* 355 */     this.fTableViewer.setInput(enabled ? this.fLoaders : null);
/* 356 */     this.fRemoveBtn.setEnabled(enabled);
/* 357 */     this.fEditBtn.setEnabled(enabled);
/* 358 */     this.fAddBtn.setEnabled(enabled);
/* 359 */     super.setEnabled(enabled);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void performApply(ILaunchConfigurationWorkingCopy configuration) {
/* 367 */     configuration.setAttribute("com.st.stm32cube.ide.mcu.debug.launch.cubeprog_external_loaders", CubeProgExtLoader.toJson(this.fLoaders));
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setAttributeChangedListener(Runnable attributeChangedListener) {
/* 375 */     this.fAttributeChangedListener = attributeChangedListener;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List<CubeProgExtLoader> getLoaders() {
/* 383 */     return this.fLoaders;
/*     */   }
/*     */   
/*     */   private void createUI(Composite parent) {
/* 387 */     this.fBaseComp = new Composite(parent, 0);
/* 388 */     GridLayoutFactory.swtDefaults().numColumns(2).margins(0, 0).applyTo(this.fBaseComp);
/* 389 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)this.fBaseComp);
/*     */     
/* 391 */     this.fTableViewer = new TableViewer(this.fBaseComp, 68352);
/*     */     
/* 393 */     Table table = this.fTableViewer.getTable();
/* 394 */     table.setLayoutData(new GridData(4, 4, true, false, 1, 1));
/* 395 */     table.setLinesVisible(true);
/* 396 */     table.setHeaderVisible(true);
/*     */     
/* 398 */     TableViewerColumn loaderColumn = new TableViewerColumn(this.fTableViewer, 0);
/* 399 */     loaderColumn.setLabelProvider((CellLabelProvider)new ColumnLabelProvider()
/*     */         {
/*     */           public String getText(Object element) {
/* 402 */             String ret = "";
/* 403 */             if (element instanceof CubeProgExtLoader) {
/* 404 */               ret = ((CubeProgExtLoader)element).getLoaderPath();
/*     */             }
/* 406 */             return ret;
/*     */           }
/*     */         });
/* 409 */     TableColumn loaderTColumn = loaderColumn.getColumn();
/* 410 */     loaderTColumn.setWidth(400);
/* 411 */     loaderTColumn.setText("Loader");
/*     */     
/* 413 */     TableViewerColumn enabledColumn = new TableViewerColumn(this.fTableViewer, 0);
/* 414 */     enabledColumn.setLabelProvider((CellLabelProvider)new ColumnLabelProvider()
/*     */         {
/*     */           public String getText(Object element) {
/* 417 */             String ret = "";
/* 418 */             if (element instanceof CubeProgExtLoader) {
/* 419 */               ret = ((CubeProgExtLoader)element).getEnabled() ? "true" : "false";
/*     */             }
/* 421 */             return ret;
/*     */           }
/*     */ 
/*     */           
/*     */           public Image getImage(Object element) {
/* 426 */             Image ret = null;
/* 427 */             if (element instanceof CubeProgExtLoader) {
/* 428 */               if (((CubeProgExtLoader)element).getEnabled()) {
/* 429 */                 ret = SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/true.png");
/*     */               } else {
/* 431 */                 ret = SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/false.png");
/*     */               } 
/*     */             }
/* 434 */             return ret;
/*     */           }
/*     */         });
/*     */     
/* 438 */     TableColumn enabledTColumn = enabledColumn.getColumn();
/* 439 */     enabledTColumn.setWidth(100);
/* 440 */     enabledTColumn.setText("Enabled");
/*     */     
/* 442 */     TableViewerColumn initializeColumn = new TableViewerColumn(this.fTableViewer, 0);
/* 443 */     initializeColumn.setLabelProvider((CellLabelProvider)new ColumnLabelProvider()
/*     */         {
/*     */           public String getText(Object element) {
/* 446 */             String ret = "";
/* 447 */             if (element instanceof CubeProgExtLoader) {
/* 448 */               ret = ((CubeProgExtLoader)element).getInitialize() ? "true" : "false";
/*     */             }
/* 450 */             return ret;
/*     */           }
/*     */ 
/*     */           
/*     */           public Image getImage(Object element) {
/* 455 */             Image ret = null;
/* 456 */             if (element instanceof CubeProgExtLoader) {
/* 457 */               if (((CubeProgExtLoader)element).getInitialize()) {
/* 458 */                 ret = SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/true.png");
/*     */               } else {
/* 460 */                 ret = SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/false.png");
/*     */               } 
/*     */             }
/* 463 */             return ret;
/*     */           }
/*     */         });
/*     */     
/* 467 */     TableColumn initializeTColumn = initializeColumn.getColumn();
/* 468 */     initializeTColumn.setWidth(100);
/* 469 */     initializeTColumn.setText("Initialize");
/*     */     
/* 471 */     this.fTableViewer.setContentProvider((IContentProvider)new ArrayContentProvider());
/* 472 */     this.fTableViewer.addSelectionChangedListener(new ISelectionChangedListener()
/*     */         {
/*     */           public void selectionChanged(SelectionChangedEvent event) {
/* 475 */             CubeProgExtLoader selectedLoader = CubeProgExtLoadersLaunchWidget.this.getSelectedLoader();
/* 476 */             CubeProgExtLoadersLaunchWidget.this.fRemoveBtn.setEnabled((selectedLoader != null));
/* 477 */             CubeProgExtLoadersLaunchWidget.this.fEditBtn.setEnabled((selectedLoader != null));
/*     */           }
/*     */         });
/*     */     
/* 481 */     this.fTableViewer.setInput(this.fLoaders);
/*     */     
/* 483 */     this.fTableViewer.addDoubleClickListener(new IDoubleClickListener()
/*     */         {
/*     */           public void doubleClick(DoubleClickEvent event) {
/* 486 */             CubeProgExtLoader loader = CubeProgExtLoadersLaunchWidget.this.getSelectedLoader();
/* 487 */             if (loader != null) {
/* 488 */               CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog addDialog = new CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog(Display.getDefault().getActiveShell(), loader);
/* 489 */               if (addDialog.open() == 0) {
/* 490 */                 CubeProgExtLoadersLaunchWidget.this.fTableViewer.refresh();
/* 491 */                 CubeProgExtLoadersLaunchWidget.this.notifyListeners();
/*     */               } 
/*     */             } 
/*     */           }
/*     */         });
/*     */     
/* 497 */     Composite buttonsBaseComp = new Composite(this.fBaseComp, 0);
/* 498 */     GridLayoutFactory.swtDefaults().numColumns(1).margins(0, 0).equalWidth(true).applyTo(buttonsBaseComp);
/* 499 */     GridDataFactory.fillDefaults().grab(false, false).applyTo((Control)buttonsBaseComp);
/*     */     
/* 501 */     this.fAddBtn = new Button(buttonsBaseComp, 8);
/* 502 */     this.fAddBtn.setText("Add...");
/* 503 */     this.fAddBtn.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/* 506 */             CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog addDialog = new CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog(Display.getDefault().getActiveShell(), null);
/* 507 */             if (addDialog.open() == 0) {
/* 508 */               CubeProgExtLoader newLoader = addDialog.getLoaderInfo();
/* 509 */               if (newLoader != null) {
/* 510 */                 CubeProgExtLoadersLaunchWidget.this.fLoaders.add(newLoader);
/* 511 */                 CubeProgExtLoadersLaunchWidget.this.fTableViewer.refresh();
/* 512 */                 CubeProgExtLoadersLaunchWidget.this.notifyListeners();
/*     */               } 
/*     */             } 
/*     */           }
/*     */         });
/* 517 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)this.fAddBtn);
/* 518 */     this.fEditBtn = new Button(buttonsBaseComp, 8);
/* 519 */     this.fEditBtn.setText("Edit...");
/* 520 */     this.fEditBtn.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/* 523 */             CubeProgExtLoader loader = CubeProgExtLoadersLaunchWidget.this.getSelectedLoader();
/* 524 */             if (loader != null) {
/* 525 */               CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog addDialog = new CubeProgExtLoadersLaunchWidget.CubeProgExtLoadersAddEditDialog(Display.getDefault().getActiveShell(), loader);
/* 526 */               if (addDialog.open() == 0) {
/* 527 */                 CubeProgExtLoadersLaunchWidget.this.fTableViewer.refresh();
/* 528 */                 CubeProgExtLoadersLaunchWidget.this.notifyListeners();
/*     */               } 
/*     */             } 
/*     */           }
/*     */         });
/*     */     
/* 534 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)this.fEditBtn);
/* 535 */     this.fRemoveBtn = new Button(buttonsBaseComp, 8);
/* 536 */     this.fRemoveBtn.setText("Remove");
/* 537 */     this.fRemoveBtn.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/* 540 */             ISelection selection = CubeProgExtLoadersLaunchWidget.this.fTableViewer.getSelection();
/* 541 */             if (selection instanceof IStructuredSelection) {
/* 542 */               Object loader = ((IStructuredSelection)selection).getFirstElement();
/* 543 */               if (loader instanceof CubeProgExtLoader) {
/* 544 */                 CubeProgExtLoadersLaunchWidget.this.fLoaders.remove(loader);
/* 545 */                 CubeProgExtLoadersLaunchWidget.this.fTableViewer.refresh();
/* 546 */                 CubeProgExtLoadersLaunchWidget.this.notifyListeners();
/*     */               } 
/*     */             } 
/*     */           }
/*     */         });
/* 551 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)this.fRemoveBtn);
/*     */   }
/*     */   
/*     */   private CubeProgExtLoader getSelectedLoader() {
/* 555 */     ISelection selection = this.fTableViewer.getSelection();
/* 556 */     if (selection instanceof IStructuredSelection) {
/* 557 */       Object element = ((IStructuredSelection)selection).getFirstElement();
/* 558 */       if (element instanceof CubeProgExtLoader) {
/* 559 */         return (CubeProgExtLoader)element;
/*     */       }
/*     */     } 
/* 562 */     return null;
/*     */   }
/*     */   
/*     */   private void notifyListeners() {
/* 566 */     if (this.fAttributeChangedListener != null) {
/* 567 */       this.fAttributeChangedListener.run();
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean initializeAllowed(CubeProgExtLoader loader) {
/* 577 */     List<CubeProgExtLoader> initLoaders = CubeProgExtLoader.getInitializeLoader(this.fLoaders);
/* 578 */     if (loader == null)
/*     */     {
/* 580 */       return initLoaders.isEmpty();
/*     */     }
/*     */     
/* 583 */     return ((List)this.fLoaders.stream().filter(e -> (e.getInitialize() && !paramCubeProgExtLoader1.equals(e))).collect(Collectors.toList())).isEmpty();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private List<String> getBuiltIns() {
/* 592 */     if (this.fAvailableLoaders == null) {
/* 593 */       this.fAvailableLoaders = new ArrayList<>();
/*     */       try {
/* 595 */         String cpPath = MCUExternalToolsPlugin.getCubeProgrammerLocation();
/* 596 */         File[] fileList = (new File(String.valueOf(cpPath) + '/' + "ExternalLoader")).listFiles(); byte b; int i; File[] arrayOfFile1;
/* 597 */         for (i = (arrayOfFile1 = fileList).length, b = 0; b < i; ) { File file = arrayOfFile1[b];
/* 598 */           this.fAvailableLoaders.add(file.getName()); b++; }
/*     */       
/* 600 */       } catch (IllegalArgumentException|InterruptedException|java.net.URISyntaxException|java.io.IOException e) {
/* 601 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", e, "Failed to get install location for STM32CubeProgrammer");
/*     */       } 
/*     */     } 
/* 604 */     return this.fAvailableLoaders;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launc\\ui\externalloaders\CubeProgExtLoadersLaunchWidget.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */