/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.analytics.core.MCUAnalytics;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.GDBServerContributionFactory;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.export.HardwareDebugUtil;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryCommandControl;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryGDBBackend;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.livedata.ISecondaryGDBLiveDataService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.IRestartConfigurationsService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.restart.IRestartService;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.service.secureState.ISecureStateService;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Board;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.ITargetObject;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import java.util.List;
/*     */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.GDBJtagDeviceContribution;
/*     */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.IGDBJtagDevice;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.Sequence;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.ServicesLaunchSequence;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.runtime.IProgressMonitor;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DSFServicesLaunchSequence
/*     */   extends ServicesLaunchSequence
/*     */ {
/*     */   private GdbLaunch fLaunch;
/*     */   
/*     */   public DSFServicesLaunchSequence(DsfSession session, GdbLaunch launch, IProgressMonitor pm) {
/*  49 */     super(session, launch, pm);
/*  50 */     this.fLaunch = launch;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public Sequence.Step[] getSteps() {
/*  58 */     List<Sequence.Step> steps = new ArrayList<>(Arrays.asList(super.getSteps()));
/*     */     
/*  60 */     steps.add(new Sequence.Step()
/*     */         {
/*     */           public void execute(RequestMonitor rm) {
/*  63 */             ((IRestartService)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(IRestartService.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[0])).initialize(rm);
/*     */           }
/*     */         });
/*     */     
/*  67 */     steps.add(new Sequence.Step()
/*     */         {
/*     */           public void execute(RequestMonitor rm) {
/*  70 */             ((IRestartConfigurationsService)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(IRestartConfigurationsService.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[0])).initialize(rm);
/*     */           }
/*     */         });
/*     */     
/*  74 */     steps.add(new Sequence.Step()
/*     */         {
/*     */           public void execute(RequestMonitor rm) {
/*  77 */             ((ISecureStateService)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(ISecureStateService.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[0])).initialize(rm);
/*     */           }
/*     */         });
/*     */     
/*     */     try {
/*  82 */       ILaunchConfiguration config = this.fLaunch.getLaunchConfiguration();
/*  83 */       boolean enableLive = config.getAttribute("com.st.stm32cube.ide.mcu.debug.launch.enable_live_expr", false);
/*  84 */       if (enableLive) {
/*     */ 
/*     */ 
/*     */ 
/*     */         
/*  89 */         steps.add(new Sequence.Step()
/*     */             {
/*     */               public void execute(RequestMonitor rm) {
/*  92 */                 ISecondaryGDBBackend service = (ISecondaryGDBBackend)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(ISecondaryGDBBackend.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[] { DSFServicesLaunchSequence.access$0(this.this$0).getLaunchConfiguration() });
/*  93 */                 if (service != null) {
/*  94 */                   service.initialize(rm);
/*     */                 } else {
/*  96 */                   rm.done();
/*     */                 } 
/*     */               }
/*     */             });
/*     */         
/* 101 */         steps.add(new Sequence.Step()
/*     */             {
/*     */               public void execute(RequestMonitor rm) {
/* 104 */                 ISecondaryCommandControl service = (ISecondaryCommandControl)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(ISecondaryCommandControl.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[] { DSFServicesLaunchSequence.access$0(this.this$0).getLaunchConfiguration() });
/* 105 */                 if (service != null) {
/* 106 */                   service.initialize(rm);
/*     */                 } else {
/* 108 */                   rm.done();
/*     */                 } 
/*     */               }
/*     */             });
/*     */         
/* 113 */         steps.add(new Sequence.Step()
/*     */             {
/*     */               public void execute(RequestMonitor rm) {
/* 116 */                 ISecondaryGDBLiveDataService service = (ISecondaryGDBLiveDataService)DSFServicesLaunchSequence.this.fLaunch.getServiceFactory().createService(ISecondaryGDBLiveDataService.class, DSFServicesLaunchSequence.this.fLaunch.getSession(), new Object[] { DSFServicesLaunchSequence.access$0(this.this$0).getLaunchConfiguration() });
/* 117 */                 if (service != null) {
/* 118 */                   service.initialize(rm);
/*     */                 } else {
/* 120 */                   rm.done();
/*     */                 } 
/*     */               }
/*     */             });
/*     */       } 
/* 125 */     } catch (Exception exception) {}
/*     */ 
/*     */     
/* 128 */     return steps.<Sequence.Step>toArray(new Sequence.Step[steps.size()]);
/*     */   }
/*     */ 
/*     */   
/*     */   public void run() {
/* 133 */     ILaunchConfiguration config = this.fLaunch.getLaunchConfiguration();
/* 134 */     if (config != null) {
/* 135 */       IMxUGDBServer server = null;
/* 136 */       String deviceId = HardwareDebugUtil.getServerId(config).orElse(null);
/* 137 */       if (deviceId != null) {
/* 138 */         GDBJtagDeviceContribution contribution = GDBServerContributionFactory.findById(deviceId);
/* 139 */         if (contribution != null) {
/* 140 */           IGDBJtagDevice device = contribution.getDevice();
/* 141 */           if (device instanceof IMxUGDBServer) {
/* 142 */             ITargetObject iTargetObject; server = (IMxUGDBServer)device;
/*     */ 
/*     */             
/* 145 */             IProject project = MCUDebugPlugin.getProject(config);
/*     */             
/* 147 */             Board board = MCUDebugPlugin.getBoardFromConfig(config).orElse(null);
/* 148 */             Board board1 = board;
/* 149 */             if (board == null || board.isGeneric()) {
/* 150 */               iTargetObject = MCUDebugPlugin.getMcuFromConfig(config).orElse(null);
/*     */             }
/* 152 */             if (iTargetObject != null) {
/* 153 */               MCUAnalytics.registerData(project, "CubeIDE_targetDevice", iTargetObject.getName());
/* 154 */               MCUAnalytics.registerData(project, "CubeIDE_targetSerie", iTargetObject.getSerie().getName().toUpperCase());
/*     */             } 
/*     */             
/* 157 */             MCUAnalytics.registerData(project, "CubeIDE_debugServerName", contribution.getDeviceName());
/*     */             
/* 159 */             server.logAnalytics(config);
/* 160 */             MCUAnalytics.sendAnalyticsData();
/*     */           } 
/*     */         } 
/*     */       } 
/*     */     } 
/*     */     
/* 166 */     super.run();
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\DSFServicesLaunchSequence.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */