/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.ui.IGenericDebugConfigElement;
/*     */ import com.st.stm32cube.ide.mcu.ide.MCUIdePlugin;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.HashSet;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Optional;
/*     */ import java.util.Set;
/*     */ import java.util.TreeMap;
/*     */ import org.eclipse.core.runtime.IConfigurationElement;
/*     */ import org.eclipse.core.runtime.IExtension;
/*     */ import org.eclipse.core.runtime.IExtensionPoint;
/*     */ import org.eclipse.core.runtime.IExtensionRegistry;
/*     */ import org.eclipse.core.runtime.Platform;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class DebugLaunchRegistry
/*     */ {
/*     */   private static final String CUSTOM_CONFIG_EXTENSION_POINT_ID = "com.st.stm32cube.ide.mcu.debug.launch.configurationUiElement";
/*     */   private static final String CUSTOM_CONFIG_ELEMENT = "debugConfigElement";
/*     */   private static final String CUSTOM_CONFIG_ELEMENT_CLASS = "class";
/*     */   private static final String CUSTOM_CONFIG_ELEMENT_LEVEL = "level";
/*     */   private static final String PRE_LAUNCH_EXTENSION_POINT_ID = "com.st.stm32cube.ide.mcu.debug.launch.preLaunch";
/*     */   private static final String PRE_LAUNCH_ELEMENT = "preLaunch";
/*     */   private static final String PRE_LAUNCH_CLASS = "class";
/*     */   private static final String PRE_LAUNCH_ORDER = "order";
/*     */   private static DebugLaunchRegistry instance;
/*     */   private Map<Integer, Set<IGenericDebugConfigElement>> customDebugConfigElements;
/*     */   private Map<Integer, Set<IPreLaunch>> preLaunches;
/*     */   
/*     */   public static DebugLaunchRegistry getInstance() {
/*  47 */     if (instance == null) {
/*  48 */       instance = new DebugLaunchRegistry();
/*     */     }
/*  50 */     return instance;
/*     */   }
/*     */   
/*     */   private DebugLaunchRegistry() {
/*  54 */     this.customDebugConfigElements = new HashMap<>();
/*  55 */     this.preLaunches = new TreeMap<>();
/*  56 */     loadExtensions();
/*     */   }
/*     */   
/*     */   private void loadExtensions() {
/*  60 */     IExtensionRegistry reg = Platform.getExtensionRegistry();
/*     */     
/*  62 */     IExtensionPoint ep = reg.getExtensionPoint("com.st.stm32cube.ide.mcu.debug.launch.configurationUiElement");
/*  63 */     IExtension[] exts = ep.getExtensions(); int i;
/*  64 */     for (i = 0; i < exts.length; i++) {
/*  65 */       IConfigurationElement[] elems = exts[i].getConfigurationElements(); byte b; int j; IConfigurationElement[] arrayOfIConfigurationElement1;
/*  66 */       for (j = (arrayOfIConfigurationElement1 = elems).length, b = 0; b < j; ) { IConfigurationElement elem = arrayOfIConfigurationElement1[b];
/*  67 */         if (elem.getName().equals("debugConfigElement")) {
/*     */           try {
/*  69 */             int level = Integer.parseInt(Optional.<String>ofNullable(elem.getAttribute("level")).orElse("0"));
/*  70 */             Set<IGenericDebugConfigElement> set = this.customDebugConfigElements.get(Integer.valueOf(level));
/*  71 */             if (set == null) {
/*  72 */               set = new HashSet<>();
/*     */             }
/*  74 */             set.add((IGenericDebugConfigElement)elem.createExecutableExtension("class"));
/*  75 */             this.customDebugConfigElements.put(Integer.valueOf(level), set);
/*  76 */           } catch (NumberFormatException|org.eclipse.core.runtime.CoreException e) {
/*  77 */             MCULoggerPlugin.logException(MCUIdePlugin.getUniqueIdentifier(), e);
/*     */           } 
/*     */         }
/*     */         b++; }
/*     */     
/*     */     } 
/*  83 */     ep = reg.getExtensionPoint("com.st.stm32cube.ide.mcu.debug.launch.preLaunch");
/*  84 */     exts = ep.getExtensions();
/*  85 */     for (i = 0; i < exts.length; i++) {
/*  86 */       IConfigurationElement[] elems = exts[i].getConfigurationElements(); byte b; int j; IConfigurationElement[] arrayOfIConfigurationElement1;
/*  87 */       for (j = (arrayOfIConfigurationElement1 = elems).length, b = 0; b < j; ) { IConfigurationElement elem = arrayOfIConfigurationElement1[b];
/*  88 */         if (elem.getName().equals("preLaunch"))
/*     */           try {
/*  90 */             int order = Integer.parseInt(Optional.<String>ofNullable(elem.getAttribute("order"))
/*  91 */                 .orElse(Integer.toString(2147483647)));
/*  92 */             Set<IPreLaunch> set = this.preLaunches.get(Integer.valueOf(order));
/*  93 */             if (set == null) {
/*  94 */               set = new HashSet<>();
/*     */             }
/*  96 */             set.add((IPreLaunch)elem.createExecutableExtension("class"));
/*  97 */             this.preLaunches.put(Integer.valueOf(order), set);
/*  98 */           } catch (NumberFormatException|org.eclipse.core.runtime.CoreException e) {
/*  99 */             MCULoggerPlugin.logException(MCUIdePlugin.getUniqueIdentifier(), e);
/*     */           }  
/*     */         b++; }
/*     */     
/*     */     } 
/*     */   }
/*     */   
/*     */   public IGenericDebugConfigElement[] getCustomDebugConfigElements(int level) {
/* 107 */     Set<IGenericDebugConfigElement> set = this.customDebugConfigElements.get(Integer.valueOf(level));
/* 108 */     if (set != null) {
/* 109 */       return set.<IGenericDebugConfigElement>toArray(new IGenericDebugConfigElement[set.size()]);
/*     */     }
/* 111 */     return new IGenericDebugConfigElement[0];
/*     */   }
/*     */   
/*     */   public IGenericDebugConfigElement[] getCustomDebugConfigElements() {
/* 115 */     List<IGenericDebugConfigElement> res = new ArrayList<>();
/* 116 */     this.customDebugConfigElements.values().forEach(m -> { 
/* 117 */         }); return res.<IGenericDebugConfigElement>toArray(new IGenericDebugConfigElement[res.size()]);
/*     */   }
/*     */   
/*     */   public IPreLaunch[] getOrderedPreLaunches() {
/* 121 */     List<IPreLaunch> res = new ArrayList<>();
/* 122 */     this.preLaunches.values().forEach(launches -> { 
/* 123 */         }); return res.<IPreLaunch>toArray(new IPreLaunch[res.size()]);
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\DebugLaunchRegistry.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */