/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.toolchain.ToolChainHelper;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.managedbuilder.core.IConfiguration;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.resources.IResource;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IPath;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.debug.core.DebugException;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.model.IProcess;
/*     */ import org.eclipse.debug.core.model.ISourceLocator;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class MCUGdbLaunch
/*     */   extends GdbLaunch
/*     */ {
/*     */   public MCUGdbLaunch(ILaunchConfiguration launchConfiguration, String mode, ISourceLocator locator) {
/*  37 */     super(launchConfiguration, mode, locator);
/*     */   }
/*     */ 
/*     */   
/*     */   public void shutdownSession(RequestMonitor rm) {
/*  42 */     super.shutdownSession(rm); byte b;
/*     */     int i;
/*     */     IProcess[] arrayOfIProcess;
/*  45 */     for (i = (arrayOfIProcess = getProcesses()).length, b = 0; b < i; ) { IProcess p = arrayOfIProcess[b];
/*  46 */       if ("openocd".equals(p.getLabel())) {
/*     */         try {
/*  48 */           p.terminate();
/*  49 */         } catch (DebugException e) {
/*  50 */           MCULoggerPlugin.logException(MCUDebugPlugin.getUniqueIdentifier(), (Throwable)e);
/*     */         } 
/*     */       }
/*     */       b++; }
/*     */   
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public IProject getProjectFromLaunchConf() throws CoreException {
/*  61 */     IProject project = null;
/*  62 */     ILaunchConfiguration config = getLaunchConfiguration();
/*  63 */     if (config != null) {
/*  64 */       String projectName = config.getAttribute("org.eclipse.cdt.launch.PROJECT_ATTR", 
/*  65 */           null);
/*     */       
/*  67 */       if (projectName == null) {
/*  68 */         IResource[] resources = getLaunchConfiguration().getMappedResources();
/*  69 */         if (resources != null && resources.length > 0 && resources[0] instanceof IProject) {
/*  70 */           project = (IProject)resources[0];
/*     */         }
/*     */       } else {
/*  73 */         projectName = projectName.trim();
/*  74 */         if (projectName.length() == 0) {
/*  75 */           return null;
/*     */         }
/*  77 */         project = ResourcesPlugin.getWorkspace().getRoot().getProject(projectName);
/*     */       } 
/*     */     } 
/*     */     
/*  81 */     if (project == null || !project.isAccessible())
/*     */     {
/*  83 */       return null;
/*     */     }
/*  85 */     return project;
/*     */   }
/*     */   
/*     */   public IPath getGDBPath() {
/*     */     Path path1;
/*  90 */     IPath path = super.getGDBPath();
/*  91 */     if (path != null) {
/*     */       
/*  93 */       if ("${TOOLCHAIN_PATH}".equals(path.segment(0))) {
/*  94 */         path = path.removeFirstSegments(1);
/*     */       }
/*     */ 
/*     */       
/*  98 */       if ("arm-none-eabi-gdb".equals(path.toString())) {
/*  99 */         ILaunchConfiguration launchConfig = getLaunchConfiguration();
/* 100 */         IConfiguration buildConfig = MCUDebugPlugin.getConfigFromDebugLaunch(launchConfig);
/* 101 */         path1 = new Path(ToolChainHelper.getPrefixedCommand(buildConfig, "gdb"));
/*     */       } 
/*     */     } 
/* 104 */     return (IPath)path1;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\MCUGdbLaunch.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */