/*     */ package com.st.stm32cube.ide.mcu.debug.launch;
/*     */ 
/*     */ import com.google.gson.Gson;
/*     */ import com.google.gson.JsonSyntaxException;
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.ResetStrategy;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.RestartStrategy;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.export.HardwareDebugUtil;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Optional;
/*     */ import org.eclipse.cdt.debug.core.CDebugUtils;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestartListInfo
/*     */ {
/*     */   private static final String EMPTY_STRING = "";
/*  27 */   private int fVersion = 0;
/*  28 */   private ArrayList<RestartStrategy> fItems = new ArrayList<>();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RestartListInfo(ArrayList<RestartStrategy> restartStrategies) {
/*  36 */     this.fItems = restartStrategies;
/*  37 */     this.fVersion = 1;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ArrayList<RestartStrategy> getInternalItems() {
/*  44 */     return this.fItems;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String asJSON() {
/*  51 */     return (new Gson()).toJson(this);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static Optional<RestartListInfo> parseRestartListInfo(ILaunchConfiguration launch) throws CoreException {
/*  60 */     String restartListJson = (String)CDebugUtils.getAttribute(launch.getAttributes(), getRestartConfsAttributeName(launch), "");
/*  61 */     if (restartListJson != null && !restartListJson.isEmpty()) {
/*     */       try {
/*  63 */         RestartListInfo info = (RestartListInfo)(new Gson()).fromJson(restartListJson, RestartListInfo.class);
/*  64 */         if (info.fVersion == 0) {
/*  65 */           ArrayList<RestartStrategy> restartStrategies; String str; switch ((str = HardwareDebugUtil.getServerId(launch).orElse("")).hashCode()) { case -834922902: if (!str.equals("com.st.stm32cube.ide.mcu.debug.openocd")) {
/*     */                 break;
/*     */               }
/*  68 */               restartStrategies = info.getInternalItems();
/*     */ 
/*     */               
/*  71 */               restartStrategies.removeIf(restartStrategy -> (restartStrategy.getDisplayName().equals("Reset") && restartStrategy.getGdbCommandGroup().getCommands().isEmpty()));
/*     */ 
/*     */               
/*  74 */               for (RestartStrategy restartStrategy : restartStrategies) {
/*  75 */                 restartStrategy.getResetStrategies().removeIf(resetStrategy -> resetStrategy.getDisplayName().equals("Reset"));
/*     */               }
/*     */               break; }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */           
/*  83 */           for (RestartStrategy item : info
/*     */ 
/*     */             
/*  86 */             .fItems) {
/*  87 */             item.setStartApplication(true);
/*     */           }
/*     */           
/*  90 */           info.fVersion = 1;
/*     */         } 
/*  92 */         return Optional.ofNullable(info);
/*  93 */       } catch (JsonSyntaxException e) {
/*  94 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to parse restart list information: " + restartListJson);
/*     */       } 
/*     */     }
/*  97 */     return Optional.empty();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static String getRestartConfsAttributeName(ILaunchConfiguration launch) {
/* 104 */     IMxUGDBServer server = HardwareDebugUtil.getServer(launch).orElse(null);
/* 105 */     return (server != null) ? server.getRestartConfigurationsAttributName() : "";
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\RestartListInfo.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */