/*     */ package com.st.stm32cube.ide.mcu.debug.launch.device;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.GDBServerCommandGroup;
/*     */ import java.util.List;
/*     */ import java.util.Objects;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestartStrategy
/*     */ {
/*     */   private static final String COPY = "_copy";
/*     */   private static final String ADDITIONAL_COMMANDS = "Additional commands";
/*     */   public static final boolean DEFAULT_START_APPLICATION = true;
/*     */   private String fDisplayName;
/*     */   private boolean fIsSuppressible;
/*     */   private String fResetAttribute;
/*     */   private List<ResetStrategy> fResetStrategies;
/*     */   private GDBServerCommandGroup fGdbCommandGroup;
/*     */   private boolean fStartApplication;
/*     */   
/*     */   public enum RestartStrategySearchKey
/*     */   {
/*  36 */     NAME,
/*  37 */     ATTRIBUTE;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RestartStrategy(String displayName, boolean isSuppressible, String resetAttribute, List<ResetStrategy> resetStrategies) {
/*  47 */     this(displayName, isSuppressible, resetAttribute, resetStrategies, new GDBServerCommandGroup("Additional commands"));
/*  48 */     this.fStartApplication = true;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RestartStrategy(String displayName, boolean isSuppressible, String resetAttribute, List<ResetStrategy> resetStrategies, GDBServerCommandGroup gdbCommandGroups) {
/*  57 */     Objects.requireNonNull(displayName);
/*  58 */     Objects.requireNonNull(resetAttribute);
/*  59 */     Objects.requireNonNull(resetStrategies);
/*  60 */     Objects.requireNonNull(gdbCommandGroups);
/*     */     
/*  62 */     this.fDisplayName = displayName;
/*  63 */     this.fIsSuppressible = isSuppressible;
/*  64 */     this.fResetAttribute = resetAttribute;
/*  65 */     this.fResetStrategies = resetStrategies;
/*  66 */     this.fGdbCommandGroup = gdbCommandGroups;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getDisplayName() {
/*  81 */     return this.fDisplayName;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setDisplayName(String name) {
/*  89 */     this.fDisplayName = name;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public boolean isSuppressible() {
/*  96 */     return this.fIsSuppressible;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getResetAttribute() {
/* 105 */     return this.fResetAttribute;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setResetAttribute(String resetAttribute) {
/* 113 */     this.fResetAttribute = resetAttribute;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List<ResetStrategy> getResetStrategies() {
/* 122 */     return this.fResetStrategies;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setResetStrategies(List<ResetStrategy> newResetStrategy) {
/* 131 */     this.fResetStrategies = newResetStrategy;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public GDBServerCommandGroup getGdbCommandGroup() {
/* 140 */     return this.fGdbCommandGroup;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void setGdbCommandGroup(GDBServerCommandGroup gdbServerCommand) {
/* 149 */     this.fGdbCommandGroup = gdbServerCommand;
/*     */   }
/*     */   
/*     */   public boolean getStartApplication() {
/* 153 */     return this.fStartApplication;
/*     */   }
/*     */   
/*     */   public void setStartApplication(boolean start) {
/* 157 */     this.fStartApplication = start;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static RestartStrategy find(String key, List<RestartStrategy> strategies, RestartStrategySearchKey keyType) {
/* 175 */     for (RestartStrategy strategy : strategies) {
/* 176 */       switch (keyType) {
/*     */         case null:
/* 178 */           if (strategy.getResetAttribute().equals(key)) {
/* 179 */             return strategy;
/*     */           }
/*     */ 
/*     */         
/*     */         case NAME:
/* 184 */           if (strategy.getDisplayName().equals(key)) {
/* 185 */             return strategy;
/*     */           }
/*     */       } 
/*     */     
/*     */     } 
/* 190 */     return null;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static RestartStrategy duplicate(RestartStrategy restartStrategy) {
/* 200 */     return new RestartStrategy(String.valueOf(restartStrategy.fDisplayName) + "_copy", true, restartStrategy.getResetAttribute(), restartStrategy.getResetStrategies(), restartStrategy.getGdbCommandGroup());
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\device\RestartStrategy.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */