/*     */ package com.st.stm32cube.ide.mcu.debug.launch.importexecwizard;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.analytics.core.MCUAnalytics;
/*     */ import com.st.stm32cube.ide.mcu.analytics.core.MCUAnalyticsUtils;
/*     */ import com.st.stm32cube.ide.mcu.ide.ui.wizard.MCUProjectCreationWizardProjectOptionsGroupComposite;
/*     */ import com.st.stm32cube.ide.mcu.productdb.MCUProductDbResources;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Core;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Cpu;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.ITargetObject;
/*     */ import com.st.stm32cube.ide.mcu.productdb.core.Mcu;
/*     */ import com.st.stm32cube.ide.mcu.toolchain.ToolChainHelper;
/*     */ import java.util.Optional;
/*     */ import org.eclipse.cdt.core.CCorePlugin;
/*     */ import org.eclipse.cdt.core.model.CoreModel;
/*     */ import org.eclipse.cdt.core.settings.model.ICConfigurationDescription;
/*     */ import org.eclipse.cdt.core.settings.model.ICProjectDescription;
/*     */ import org.eclipse.cdt.core.settings.model.ICProjectDescriptionManager;
/*     */ import org.eclipse.cdt.managedbuilder.core.IConfiguration;
/*     */ import org.eclipse.cdt.managedbuilder.core.IHoldsOptions;
/*     */ import org.eclipse.cdt.managedbuilder.core.IManagedProject;
/*     */ import org.eclipse.cdt.managedbuilder.core.IOption;
/*     */ import org.eclipse.cdt.managedbuilder.core.IProjectType;
/*     */ import org.eclipse.cdt.managedbuilder.core.IToolChain;
/*     */ import org.eclipse.cdt.managedbuilder.core.ManagedBuildManager;
/*     */ import org.eclipse.cdt.managedbuilder.internal.core.Configuration;
/*     */ import org.eclipse.cdt.managedbuilder.internal.core.ManagedBuildInfo;
/*     */ import org.eclipse.cdt.managedbuilder.internal.core.ManagedProject;
/*     */ import org.eclipse.core.resources.IFile;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.resources.IProjectDescription;
/*     */ import org.eclipse.core.resources.IResource;
/*     */ import org.eclipse.core.resources.IWorkspace;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IPath;
/*     */ import org.eclipse.core.runtime.IProgressMonitor;
/*     */ import org.eclipse.core.runtime.IStatus;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.core.runtime.Status;
/*     */ import org.eclipse.debug.core.DebugPlugin;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationType;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ import org.eclipse.debug.ui.DebugUITools;
/*     */ import org.eclipse.jface.dialogs.MessageDialog;
/*     */ import org.eclipse.jface.viewers.IStructuredSelection;
/*     */ import org.eclipse.jface.wizard.IWizardPage;
/*     */ import org.eclipse.jface.wizard.Wizard;
/*     */ import org.eclipse.swt.widgets.Shell;
/*     */ import org.eclipse.ui.INewWizard;
/*     */ import org.eclipse.ui.IWorkbench;
/*     */ import org.eclipse.ui.PlatformUI;
/*     */ import org.eclipse.ui.progress.UIJob;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class STM32ImportExecutableWizard
/*     */   extends Wizard
/*     */   implements INewWizard
/*     */ {
/*     */   public static final String STM32_C_CPP_APPLICATION_LAUNCHTYPE = "com.st.stm32cube.ide.mcu.debug.launch.launchConfigurationType";
/*     */   public static final String TOOLCHAIN_ID = "com.st.stm32cube.ide.mcu.gnu.managedbuild.toolchain.exe.debug";
/*     */   public static final String PROJECTTYPE_ID = "com.st.stm32cube.ide.mcu.gnu.managedbuild.projecttype.exe";
/*     */   public static final String WINDOW_TITLE = "STM32 Cortex-M Executable";
/*     */   private STM32ImportExecutableWizardPage1 page1;
/*     */   
/*     */   public void addPages() {
/*  79 */     super.addPages();
/*  80 */     this.page1 = new STM32ImportExecutableWizardPage1("");
/*  81 */     addPage((IWizardPage)this.page1);
/*     */   }
/*     */ 
/*     */   
/*     */   public void init(IWorkbench workbench, IStructuredSelection selection) {
/*  86 */     setWindowTitle("STM32 Cortex-M Executable");
/*  87 */     setNeedsProgressMonitor(true);
/*     */   }
/*     */ 
/*     */   
/*     */   public boolean performFinish() {
/*  92 */     boolean ret = true;
/*  93 */     String errMsg = "";
/*     */ 
/*     */     
/*  96 */     String exePath = this.page1.getExecPath();
/*  97 */     Optional<Mcu> mcu = this.page1.getTargetSettings().getSelectedMcu();
/*  98 */     Optional<Cpu> cpu = this.page1.getTargetSettings().getSelectedCpu();
/*  99 */     Optional<Core> core = this.page1.getTargetSettings().getSelectedCore();
/* 100 */     boolean editLaunchConfig = true;
/*     */     
/* 102 */     IProject project = null;
/* 103 */     if (!exePath.isEmpty() && mcu.isPresent() && cpu.isPresent() && core.isPresent()) {
/*     */       
/* 105 */       String projectName = (new Path(exePath)).lastSegment();
/*     */       
/* 107 */       project = createUniqueProject(projectName);
/* 108 */       if (project != null) {
/*     */         
/* 110 */         if (setupProject(project, mcu.get(), cpu.get(), core.get())) {
/*     */           
/* 112 */           IFile link = setupLink(project, exePath);
/* 113 */           if (link != null) {
/* 114 */             final ILaunchConfiguration launchConfig = createLaunchConfig(project, link);
/* 115 */             if (launchConfig != null) {
/* 116 */               if (editLaunchConfig)
/*     */               {
/* 118 */                 (new UIJob("Edit launch configuration")
/*     */                   {
/*     */                     public IStatus runInUIThread(IProgressMonitor monitor) {
/* 121 */                       Shell shell = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getShell();
/* 122 */                       if (shell != null) {
/* 123 */                         DebugUITools.openLaunchConfigurationDialog(shell, launchConfig, "org.eclipse.debug.ui.launchGroup.debug", null);
/*     */                       }
/* 125 */                       return Status.OK_STATUS;
/*     */                     }
/* 127 */                   }).schedule();
/*     */               
/*     */               }
/*     */             }
/*     */             else {
/*     */               
/* 133 */               errMsg = "Failed to create the launch configuration";
/*     */             } 
/*     */           } else {
/*     */             
/* 137 */             errMsg = "Failed to link the executable file.";
/*     */           } 
/*     */         } else {
/*     */           
/* 141 */           errMsg = "Failed to configure the project.";
/*     */         } 
/*     */       } else {
/*     */         
/* 145 */         errMsg = "Failed to create the project.";
/*     */       } 
/*     */     } else {
/*     */       
/* 149 */       errMsg = "Invalid dialog values";
/*     */     } 
/*     */     
/* 152 */     if (!errMsg.isEmpty()) {
/* 153 */       MessageDialog.openError(getShell(), "STM32 Cortex-M Executable", errMsg);
/* 154 */       ret = false;
/*     */     } 
/*     */     
/* 157 */     if (ret) {
/*     */       
/* 159 */       MCUAnalytics.registerEvent(project, "CubeIDE_createProject");
/* 160 */       MCUAnalytics.registerData(project, "CubeIDE_project_sourceType", 
/* 161 */           MCUAnalyticsUtils.format(MCUProjectCreationWizardProjectOptionsGroupComposite.ProjectSourceType.BINARY.toString()));
/*     */       
/* 163 */       ITargetObject target = MCUProductDbResources.getInstance().getTarget(((Mcu)mcu.get()).getRefName());
/* 164 */       if (target != null) {
/* 165 */         MCUAnalytics.registerData(project, "CubeIDE_targetDevice", target.getName());
/* 166 */         MCUAnalytics.registerData(project, "CubeIDE_targetSerie", target.getSerie().getName().toUpperCase());
/*     */       } 
/* 168 */       MCUAnalytics.sendAnalyticsData();
/*     */     } 
/*     */     
/* 171 */     return ret;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private IProject createUniqueProject(String projectName) {
/* 180 */     IProject ret = null;
/* 181 */     IWorkspace wc = ResourcesPlugin.getWorkspace();
/* 182 */     IProject project = wc.getRoot().getProject(projectName);
/*     */ 
/*     */     
/* 185 */     int postFix = 0;
/* 186 */     while (project.exists()) {
/* 187 */       project = wc.getRoot().getProject(String.valueOf(projectName) + "_" + postFix++);
/*     */     }
/*     */     
/* 190 */     IProjectDescription projDesc = wc.newProjectDescription(project.getName());
/* 191 */     projDesc.setLocation(null);
/*     */     try {
/* 193 */       ret = CCorePlugin.getDefault().createCProject(projDesc, project, null, "org.eclipse.cdt.debug");
/* 194 */     } catch (Exception e) {
/* 195 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", e, "STM32ImportExecutableWizard, Failed create project.");
/*     */     } 
/*     */     
/* 198 */     return ret;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean setupProject(IProject project, Mcu mcu, Cpu cpu, Core core) {
/* 208 */     boolean ret = false;
/* 209 */     String errMsg = "";
/* 210 */     Exception errExc = null;
/*     */ 
/*     */     
/* 213 */     IToolChain toolChain = ManagedBuildManager.getExtensionToolChain("com.st.stm32cube.ide.mcu.gnu.managedbuild.toolchain.exe.debug");
/* 214 */     IProjectType projType = ManagedBuildManager.getExtensionProjectType("com.st.stm32cube.ide.mcu.gnu.managedbuild.projecttype.exe");
/* 215 */     if (toolChain != null && projType != null) {
/* 216 */       IConfiguration[] configs = ManagedBuildManager.getExtensionConfigurations(toolChain, projType);
/*     */       
/* 218 */       if (configs.length > 0) {
/* 219 */         ICProjectDescriptionManager projectDescMngr = CoreModel.getDefault().getProjectDescriptionManager();
/*     */         
/*     */         try {
/* 222 */           ICProjectDescription description = projectDescMngr.createProjectDescription(project, false);
/*     */           
/* 224 */           ManagedBuildInfo managedBuildInfo = ManagedBuildManager.createBuildInfo((IResource)project);
/* 225 */           if (managedBuildInfo != null) {
/*     */             
/* 227 */             ManagedProject managedProject = new ManagedProject((IResource)project, projType);
/* 228 */             managedBuildInfo.setManagedProject((IManagedProject)managedProject);
/*     */             
/* 230 */             Configuration buildConfigTemplate = (Configuration)configs[0];
/* 231 */             Configuration buildConfigNew = new Configuration(managedProject, buildConfigTemplate, ManagedBuildManager.calculateChildId(buildConfigTemplate.getId(), null), false, true);
/*     */ 
/*     */             
/* 234 */             ICConfigurationDescription cfgDes = description.createConfiguration("org.eclipse.cdt.managedbuilder.core.configurationDataProvider", buildConfigNew.getConfigurationData());
/* 235 */             buildConfigNew.setConfigurationDescription(cfgDes);
/* 236 */             buildConfigNew.exportArtifactInfo();
/* 237 */             buildConfigNew.setName("cortex-m-debug");
/*     */ 
/*     */             
/* 240 */             IToolChain buildConfigNewToolchain = buildConfigNew.getToolChain();
/* 241 */             IOption mcuOption = buildConfigNewToolchain.getOptionBySuperClassId(ToolChainHelper.getToolChainInfo((IConfiguration)buildConfigNew).getBuildOptionMcuId());
/* 242 */             ManagedBuildManager.setOption((IConfiguration)buildConfigNew, (IHoldsOptions)buildConfigNewToolchain, mcuOption, mcu.getRefName());
/*     */ 
/*     */ 
/*     */             
/* 246 */             IOption cpuIdOption = buildConfigNewToolchain.getOptionBySuperClassId(ToolChainHelper.getToolChainInfo((IConfiguration)buildConfigNew).getBuildOptionCpuId());
/* 247 */             ManagedBuildManager.setOption((IConfiguration)buildConfigNew, (IHoldsOptions)buildConfigNewToolchain, cpuIdOption, cpu.getId());
/*     */             
/* 249 */             IOption coreIdOption = buildConfigNewToolchain.getOptionBySuperClassId(ToolChainHelper.getToolChainInfo((IConfiguration)buildConfigNew).getBuildOptionCoreId());
/* 250 */             ManagedBuildManager.setOption((IConfiguration)buildConfigNew, (IHoldsOptions)buildConfigNewToolchain, coreIdOption, core.getId());
/*     */ 
/*     */             
/* 253 */             projectDescMngr.setProjectDescription(project, description);
/* 254 */             ManagedBuildManager.saveBuildInfo(project, true);
/*     */             
/* 256 */             ret = true;
/*     */           } else {
/* 258 */             errMsg = "STM32ImportExecutableWizard, Failed create build info.";
/*     */           } 
/* 260 */         } catch (Exception e) {
/* 261 */           errExc = e;
/*     */         } 
/*     */       } else {
/* 264 */         errMsg = "STM32ImportExecutableWizard, config template not found.";
/*     */       } 
/*     */     } else {
/* 267 */       errMsg = "STM32ImportExecutableWizard, toolchain/projecttype not found.";
/*     */     } 
/*     */     
/* 270 */     if (!errMsg.isEmpty()) {
/* 271 */       MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", errMsg);
/*     */     }
/*     */     
/* 274 */     if (errExc != null) {
/* 275 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", errExc, "STM32ImportExecutableWizard, Failed setup project.");
/*     */     }
/*     */     
/* 278 */     return ret;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private IFile setupLink(IProject project, String toFile) {
/* 288 */     Path path = new Path(toFile);
/* 289 */     String linkName = path.lastSegment();
/* 290 */     IFile link = project.getFile(linkName);
/*     */     try {
/* 292 */       link.createLink((IPath)path, 256, null);
/* 293 */     } catch (CoreException e) {
/* 294 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "STM32ImportExecutableWizard, failed to create link.");
/*     */     } 
/* 296 */     return link.exists() ? link : null;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private ILaunchConfiguration createLaunchConfig(IProject project, IFile execFile) {
/* 306 */     ILaunchConfiguration ret = null;
/*     */     
/* 308 */     ILaunchConfigurationType launchType = DebugPlugin.getDefault().getLaunchManager().getLaunchConfigurationType("com.st.stm32cube.ide.mcu.debug.launch.launchConfigurationType");
/* 309 */     if (launchType != null) {
/*     */       try {
/* 311 */         ILaunchConfigurationWorkingCopy launchWc = launchType.newInstance(null, project.getName());
/* 312 */         launchWc.setMappedResources(new IResource[] { (IResource)project });
/* 313 */         launchWc.setAttribute("org.eclipse.cdt.launch.PROJECT_ATTR", project.getName());
/* 314 */         launchWc.setAttribute("org.eclipse.cdt.launch.PROGRAM_NAME", execFile.getName());
/* 315 */         launchWc.setAttribute("com.st.stm32cube.ide.mcu.debug.launch.formatVersion", 2);
/* 316 */         launchWc.setAttribute("com.st.stm32cube.ide.mcu.debug.launch.useRemoteTarget", true);
/* 317 */         launchWc.setAttribute("org.eclipse.cdt.launch.ATTR_BUILD_BEFORE_LAUNCH_ATTR", 0);
/* 318 */         ret = launchWc.doSave();
/* 319 */       } catch (CoreException e) {
/* 320 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "STM32ImportExecutableWizard, Failed create launch configuration.");
/*     */       } 
/*     */     }
/* 323 */     return ret;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\importexecwizard\STM32ImportExecutableWizard.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */