/*     */ package com.st.stm32cube.ide.mcu.debug.launch.importexecwizard;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.toolchain.ui.TargetWidget;
/*     */ import java.io.File;
/*     */ import org.eclipse.jface.layout.GridDataFactory;
/*     */ import org.eclipse.jface.layout.GridLayoutFactory;
/*     */ import org.eclipse.jface.wizard.WizardPage;
/*     */ import org.eclipse.swt.events.ModifyEvent;
/*     */ import org.eclipse.swt.events.ModifyListener;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Control;
/*     */ import org.eclipse.swt.widgets.FileDialog;
/*     */ import org.eclipse.swt.widgets.Group;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Text;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class STM32ImportExecutableWizardPage1
/*     */   extends WizardPage
/*     */ {
/*     */   private Text fTxtExec;
/*     */   private TargetWidget fTargetWidget;
/*     */   public static final String PAGE_TITLE = "Import STM32 Cortex-M Executable File";
/*     */   public static final String PAGE_DESCRIPTION = "Select executable to debug and configure a matching STM32 device.";
/*     */   
/*     */   protected STM32ImportExecutableWizardPage1(String pageName) {
/*  41 */     super(pageName);
/*  42 */     setTitle("Import STM32 Cortex-M Executable File");
/*  43 */     setDescription("Select executable to debug and configure a matching STM32 device.");
/*  44 */     setPageComplete(false);
/*     */   }
/*     */ 
/*     */   
/*     */   public void createControl(Composite parent) {
/*  49 */     Composite baseComp = new Composite(parent, 0);
/*  50 */     GridLayoutFactory.swtDefaults().numColumns(1).applyTo(baseComp);
/*  51 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)baseComp);
/*     */     
/*  53 */     Composite execGrp = new Composite(baseComp, 0);
/*  54 */     GridLayoutFactory.swtDefaults().numColumns(3).applyTo(execGrp);
/*  55 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)execGrp);
/*  56 */     Label lblExec = new Label(execGrp, 0);
/*  57 */     lblExec.setText("Executable:");
/*  58 */     this.fTxtExec = new Text(execGrp, 2052);
/*  59 */     GridDataFactory.swtDefaults().align(4, 16777216).grab(true, false).applyTo((Control)this.fTxtExec);
/*  60 */     Button btnSelectExec = new Button(execGrp, 0);
/*  61 */     GridDataFactory.swtDefaults().align(4, 16777216).applyTo((Control)btnSelectExec);
/*  62 */     btnSelectExec.setText("Browse...");
/*     */     
/*  64 */     this.fTxtExec.addModifyListener(new ModifyListener()
/*     */         {
/*     */           public void modifyText(ModifyEvent e) {
/*  67 */             STM32ImportExecutableWizardPage1.this.validate();
/*     */           }
/*     */         });
/*     */     
/*  71 */     btnSelectExec.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/*  74 */             FileDialog dialog = new FileDialog(STM32ImportExecutableWizardPage1.this.getShell(), 0);
/*  75 */             dialog.setFilterExtensions(new String[] { "*.elf", "*.axf" });
/*  76 */             dialog.setText("Select executable to debug");
/*  77 */             String selected = dialog.open();
/*  78 */             if (selected != null) {
/*  79 */               STM32ImportExecutableWizardPage1.this.fTxtExec.setText(selected);
/*  80 */               STM32ImportExecutableWizardPage1.this.validate();
/*     */             } 
/*     */           }
/*     */         });
/*     */     
/*  85 */     Group devSettingsGrp = new Group(baseComp, 0);
/*  86 */     devSettingsGrp.setText("STM32 device");
/*  87 */     GridLayoutFactory.swtDefaults().applyTo((Composite)devSettingsGrp);
/*  88 */     GridDataFactory.fillDefaults().grab(true, false).span(3, 1).applyTo((Control)devSettingsGrp);
/*     */     
/*  90 */     this.fTargetWidget = new TargetWidget((Composite)devSettingsGrp, 0, () -> validate());
/*     */ 
/*     */ 
/*     */     
/*  94 */     GridDataFactory.fillDefaults().grab(true, false).span(3, 1).applyTo((Control)this.fTargetWidget);
/*     */     
/*  96 */     setControl((Control)baseComp);
/*     */   }
/*     */   
/*     */   public String getExecPath() {
/* 100 */     return this.fTxtExec.getText();
/*     */   }
/*     */   
/*     */   public TargetWidget getTargetSettings() {
/* 104 */     return this.fTargetWidget;
/*     */   }
/*     */   
/*     */   private boolean validExe() {
/* 108 */     boolean ret = false;
/* 109 */     String exePath = this.fTxtExec.getText();
/* 110 */     if (!exePath.isEmpty())
/*     */     {
/* 112 */       ret = (new File(exePath)).exists();
/*     */     }
/* 114 */     return ret;
/*     */   }
/*     */   
/*     */   private boolean validTargetSettings() {
/* 118 */     return (this.fTargetWidget.getSelectedMcu().isPresent() && this.fTargetWidget.getSelectedCpu().isPresent() && this.fTargetWidget.getSelectedCore().isPresent());
/*     */   }
/*     */   
/*     */   private void validate() {
/* 122 */     if (validExe() && validTargetSettings()) {
/* 123 */       setPageComplete(true);
/*     */     } else {
/* 125 */       setPageComplete(false);
/*     */     } 
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\importexecwizard\STM32ImportExecutableWizardPage1.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */