/*     */ package com.st.stm32cube.ide.mcu.debug.launch.livedata;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.utils.GDBDSFHelper;
/*     */ import java.util.Dictionary;
/*     */ import java.util.Hashtable;
/*     */ import org.eclipse.cdt.dsf.concurrent.DataRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.ImmediateRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.debug.service.IExpressions;
/*     */ import org.eclipse.cdt.dsf.mi.service.IMICommandControl;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIDataReadMemoryInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIDataWriteMemoryInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarAssignInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarCreateInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarDeleteInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarListChildrenInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarSetFormatInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarShowAttributesInfo;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIVarUpdateInfo;
/*     */ import org.eclipse.cdt.dsf.service.AbstractDsfService;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.debug.core.model.MemoryByte;
/*     */ import org.osgi.framework.BundleContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class AbstractGDBLiveDataService
/*     */   extends AbstractDsfService
/*     */   implements IGDBLiveDataService
/*     */ {
/*     */   public AbstractGDBLiveDataService(DsfSession session) {
/*  48 */     super(session);
/*     */   }
/*     */ 
/*     */   
/*     */   public void initialize(final RequestMonitor requestMonitor) {
/*  53 */     super.initialize((RequestMonitor)new ImmediateRequestMonitor(requestMonitor)
/*     */         {
/*     */           protected void handleSuccess() {
/*  56 */             AbstractGDBLiveDataService.this.initializeCommandControl(requestMonitor);
/*     */             
/*  58 */             if (requestMonitor.isSuccess()) {
/*  59 */               AbstractGDBLiveDataService.this.register(new String[] { IGDBLiveDataService.class.getName() }, new Hashtable<>());
/*     */             }
/*     */           }
/*     */         });
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void shutdown(final RequestMonitor requestMonitor) {
/*  69 */     super.shutdown((RequestMonitor)new ImmediateRequestMonitor(requestMonitor)
/*     */         {
/*     */           protected void handleSuccess() {
/*  72 */             AbstractGDBLiveDataService.this.unregister();
/*  73 */             requestMonitor.done();
/*     */           }
/*     */         });
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected BundleContext getBundleContext() {
/*  93 */     return MCUDebugPlugin.getBundleContext();
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarCreateInfo createVar(String expression) {
/*  98 */     return GDBDSFHelper.createVar(getSession(), getCommandControl(), 
/*  99 */         (IExpressions)getServicesTracker().getService(IExpressions.class), expression);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarShowAttributesInfo showVarAttributes(String varName) {
/* 104 */     return GDBDSFHelper.showVarAttributes(getSession(), getCommandControl(), varName);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarAssignInfo assignVar(String varName, String expression) {
/* 109 */     return GDBDSFHelper.assignVar(getSession(), getCommandControl(), varName, expression);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarDeleteInfo deleteVar(String varName) {
/* 114 */     return GDBDSFHelper.deleteVar(getSession(), getCommandControl(), varName);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarListChildrenInfo listVarChildren(String varName, int from, int to) {
/* 119 */     return GDBDSFHelper.listVarChildren(getSession(), getCommandControl(), varName, from, to);
/*     */   }
/*     */ 
/*     */   
/*     */   public String evaluateVarExpression(String expression) {
/* 124 */     return GDBDSFHelper.evaluateVarExpression(getSession(), getCommandControl(), expression);
/*     */   }
/*     */ 
/*     */   
/*     */   public String evaluateExpression(String expression) {
/* 129 */     return GDBDSFHelper.evaluateExpression(getSession(), getCommandControl(), expression);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarSetFormatInfo setFormatVar(String varName, String fmt) {
/* 134 */     return GDBDSFHelper.setFormatVar(getSession(), getCommandControl(), varName, fmt);
/*     */   }
/*     */ 
/*     */   
/*     */   public MIVarUpdateInfo updateVar(String varName) {
/* 139 */     return GDBDSFHelper.updateVar(getSession(), getCommandControl(), varName);
/*     */   }
/*     */ 
/*     */   
/*     */   public MemoryByte[] readMemory(String address, int nrBytes) {
/* 144 */     return GDBDSFHelper.readMemory(getSession(), getCommandControl(), address, nrBytes);
/*     */   }
/*     */ 
/*     */   
/*     */   public void readMemory(String address, int nrBytes, DataRequestMonitor<MIDataReadMemoryInfo> rm) {
/* 149 */     GDBDSFHelper.readMemory(getSession(), getCommandControl(), address, nrBytes, rm);
/*     */   }
/*     */ 
/*     */   
/*     */   public boolean writeMemory(String address, String value, int wordSize) {
/* 154 */     return GDBDSFHelper.writeMemory(getSession(), getCommandControl(), address, value, wordSize);
/*     */   }
/*     */ 
/*     */   
/*     */   public void writeMemory(String address, String value, int wordSize, DataRequestMonitor<MIDataWriteMemoryInfo> rm) {
/* 159 */     GDBDSFHelper.writeMemory(getSession(), getCommandControl(), address, value, wordSize, rm);
/*     */   }
/*     */   
/*     */   protected abstract void initializeCommandControl(RequestMonitor paramRequestMonitor);
/*     */   
/*     */   protected abstract IMICommandControl getCommandControl();
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\livedata\AbstractGDBLiveDataService.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */