/*    */ package com.st.stm32cube.ide.mcu.debug.launch.proxycontribution;
/*    */ 
/*    */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*    */ import java.util.ArrayList;
/*    */ import java.util.List;
/*    */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*    */ import org.eclipse.core.runtime.IConfigurationElement;
/*    */ import org.eclipse.core.runtime.IExtension;
/*    */ import org.eclipse.core.runtime.IExtensionPoint;
/*    */ import org.eclipse.core.runtime.IExtensionRegistry;
/*    */ import org.eclipse.core.runtime.Platform;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class GdbProxyRegistry
/*    */ {
/*    */   private static final String EXTENSION_POINT_ID = "com.st.stm32cube.ide.mcu.debug.launch.proxyContribution";
/*    */   private static GdbProxyRegistry instance;
/* 30 */   private List<GdbProxyContribution> contribs = new ArrayList<>();
/*    */   
/*    */   public GdbProxyRegistry() {
/* 33 */     loadExtensions();
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public static GdbProxyRegistry getInstance() {
/* 41 */     if (instance == null) {
/* 42 */       instance = new GdbProxyRegistry();
/*    */     }
/* 44 */     return instance;
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public IGdbProxyContribution getContribution(GdbLaunch launch) {
/* 55 */     for (GdbProxyContribution contrib : this.contribs) {
/* 56 */       if (contrib.isEnabled(launch)) {
/* 57 */         return contrib;
/*    */       }
/*    */     } 
/* 60 */     return null;
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   private void loadExtensions() {
/* 67 */     IExtensionRegistry reg = Platform.getExtensionRegistry();
/* 68 */     IExtensionPoint ep = reg.getExtensionPoint("com.st.stm32cube.ide.mcu.debug.launch.proxyContribution");
/* 69 */     if (ep != null) {
/*    */       try {
/* 71 */         IExtension[] exts = ep.getExtensions();
/* 72 */         for (int i = 0; i < exts.length; i++) {
/* 73 */           IConfigurationElement[] elems = exts[i].getConfigurationElements(); byte b; int j; IConfigurationElement[] arrayOfIConfigurationElement1;
/* 74 */           for (j = (arrayOfIConfigurationElement1 = elems).length, b = 0; b < j; ) { IConfigurationElement elem = arrayOfIConfigurationElement1[b];
/* 75 */             String proxyName = (elem.getAttribute("name") != null) ? elem.getAttribute("name") : "";
/* 76 */             String className = (elem.getAttribute("class") != null) ? elem.getAttribute("class") : "";
/*    */             try {
/* 78 */               String bundleName = elem.getContributor().getName();
/* 79 */               Object o = Platform.getBundle(bundleName).loadClass(className).newInstance();
/* 80 */               if (o instanceof GdbProxyContribution) {
/* 81 */                 GdbProxyContribution proxyContrib = (GdbProxyContribution)o;
/* 82 */                 proxyContrib.setName(proxyName);
/* 83 */                 this.contribs.add(proxyContrib);
/*    */               } 
/* 85 */             } catch (Exception e) {
/* 86 */               MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", String.format("GDBProxyRegistry, Bad extension; %s, %s", new Object[] { proxyName, className }));
/*    */             }  b++; }
/*    */         
/*    */         } 
/* 90 */       } catch (Exception e) {
/* 91 */         MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "GDBProxyRegistry, Failure finding extensions");
/*    */       } 
/*    */     } else {
/* 94 */       MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "GDBProxyRegistry, Failure finding extension point");
/*    */     } 
/*    */   }
/*    */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\proxycontribution\GdbProxyRegistry.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */