/*     */ package com.st.stm32cube.ide.mcu.debug.launch.service.restart;
/*     */ 
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.MCUGdbLaunch;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.ui.RestartConfigurationsDialog;
/*     */ import java.util.Hashtable;
/*     */ import java.util.concurrent.Executor;
/*     */ import org.eclipse.cdt.dsf.concurrent.DsfExecutor;
/*     */ import org.eclipse.cdt.dsf.concurrent.ImmediateRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.debug.service.command.ICommandControlService;
/*     */ import org.eclipse.cdt.dsf.service.AbstractDsfService;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.commands.IDebugCommandRequest;
/*     */ import org.eclipse.ui.IWorkbenchWindow;
/*     */ import org.eclipse.ui.PlatformUI;
/*     */ import org.osgi.framework.BundleContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestartConfigurationsService
/*     */   extends AbstractDsfService
/*     */   implements IRestartConfigurationsService
/*     */ {
/*  31 */   private DsfSession fSession = null;
/*     */ 
/*     */ 
/*     */   
/*     */   private DsfExecutor fExecutor;
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public RestartConfigurationsService(DsfSession session) {
/*  41 */     super(session);
/*  42 */     this.fSession = session;
/*  43 */     this.fExecutor = this.fSession.getExecutor();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void initialize(final RequestMonitor rm) {
/*  54 */     super.initialize((RequestMonitor)new ImmediateRequestMonitor(rm)
/*     */         {
/*     */           protected void handleSuccess() {
/*  57 */             RestartConfigurationsService.this.doInitialize(rm);
/*     */           }
/*     */         });
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void doInitialize(RequestMonitor rm) {
/*  67 */     register(new String[] { IRestartConfigurationsService.class.getName() }, new Hashtable<>());
/*  68 */     rm.done();
/*     */   }
/*     */ 
/*     */   
/*     */   public void shutdown(RequestMonitor rm) {
/*  73 */     unregister();
/*  74 */     super.shutdown(rm);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void doRestartConfigurations(ICommandControlService.ICommandControlDMContext ctx, IDebugCommandRequest request, ILaunch launch, RequestMonitor rm) {
/*  86 */     if (launch instanceof MCUGdbLaunch) {
/*  87 */       MCUGdbLaunch gdbLaunch = (MCUGdbLaunch)launch;
/*  88 */       IWorkbenchWindow window = PlatformUI.getWorkbench().getActiveWorkbenchWindow();
/*  89 */       RestartConfigurationsDialog restartConfDialog = new RestartConfigurationsDialog(window.getShell(), gdbLaunch);
/*  90 */       int val = restartConfDialog.open();
/*  91 */       if (val == 0) {
/*  92 */         IRestartService restartService = (IRestartService)getServicesTracker().getService(IRestartService.class);
/*  93 */         if (restartService != null) {
/*  94 */           restartService.doRestart(ctx, request, (ILaunch)gdbLaunch, new RequestMonitor((Executor)this.fExecutor, null)
/*     */               {
/*     */ 
/*     */                 
/*     */                 protected void handleCompleted() {}
/*     */               });
/*     */         }
/*     */       } else {
/* 102 */         request.cancel();
/*     */       } 
/*     */     } 
/* 105 */     rm.done();
/*     */   }
/*     */ 
/*     */   
/*     */   protected BundleContext getBundleContext() {
/* 110 */     return MCUDebugPlugin.getBundleContext();
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\service\restart\RestartConfigurationsService.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */