/*     */ package com.st.stm32cube.ide.mcu.debug.launch.service.secureState;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.MCUDebugPlugin;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.MCUGdbLaunch;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.ui.status.SecureSourceProvider;
/*     */ import java.util.Hashtable;
/*     */ import java.util.concurrent.Executor;
/*     */ import java.util.concurrent.RejectedExecutionException;
/*     */ import org.eclipse.cdt.dsf.concurrent.DataRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.ImmediateRequestMonitor;
/*     */ import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
/*     */ import org.eclipse.cdt.dsf.datamodel.IDMContext;
/*     */ import org.eclipse.cdt.dsf.datamodel.IDMEvent;
/*     */ import org.eclipse.cdt.dsf.debug.service.command.ICommand;
/*     */ import org.eclipse.cdt.dsf.gdb.launching.GdbLaunch;
/*     */ import org.eclipse.cdt.dsf.mi.service.IMICommandControl;
/*     */ import org.eclipse.cdt.dsf.mi.service.command.output.MIDataReadMemoryInfo;
/*     */ import org.eclipse.cdt.dsf.service.AbstractDsfService;
/*     */ import org.eclipse.cdt.dsf.service.DsfServiceEventHandler;
/*     */ import org.eclipse.cdt.dsf.service.DsfSession;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.debug.core.ILaunch;
/*     */ import org.eclipse.debug.core.model.MemoryByte;
/*     */ import org.eclipse.debug.internal.ui.DebugUIPlugin;
/*     */ import org.eclipse.debug.ui.DebugUITools;
/*     */ import org.eclipse.debug.ui.contexts.DebugContextEvent;
/*     */ import org.eclipse.debug.ui.contexts.IDebugContextListener;
/*     */ import org.eclipse.jface.viewers.StructuredSelection;
/*     */ import org.osgi.framework.BundleContext;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class SecureStateService
/*     */   extends AbstractDsfService
/*     */   implements ISecureStateService
/*     */ {
/*     */   private static final String REGISTER_DSCSR = "0xe000ee08";
/*     */   private SecureSourceProvider fSourceProvider;
/*     */   private boolean fIsSecureMode = false;
/*     */   private boolean fIsSuspended = false;
/*     */   
/*  71 */   private IDebugContextListener fDebugContextListener = new IDebugContextListener()
/*     */     {
/*     */       public void debugContextChanged(DebugContextEvent event)
/*     */       {
/*  75 */         handleDebugContextChanged(((StructuredSelection)event.getContext()).getFirstElement());
/*     */       }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */       
/*     */       private void handleDebugContextChanged(Object context) {
/*  85 */         ILaunch contextLaunch = DebugUIPlugin.getLaunch(context);
/*  86 */         if (contextLaunch instanceof GdbLaunch) {
/*  87 */           GdbLaunch gdbLaunch = (GdbLaunch)contextLaunch;
/*  88 */           DsfSession activeSession = gdbLaunch.getSession();
/*     */           
/*  90 */           if (activeSession.equals(SecureStateService.this.getSession())) {
/*  91 */             if (!SecureStateService.this.fIsSuspended) {
/*     */               return;
/*     */             }
/*     */             try {
/*  95 */               if (gdbLaunch instanceof MCUGdbLaunch) {
/*  96 */                 IProject prj = ((MCUGdbLaunch)gdbLaunch).getProjectFromLaunchConf();
/*  97 */                 if (SecureStateService.this.fSourceProvider != null) {
/*  98 */                   if (SecureStateService.this.hasSecureOrNonSecureNature(prj)) {
/*  99 */                     SecureStateService.this.fSourceProvider.setVariableIsSecureEnabled(true);
/* 100 */                     SecureStateService.this.fSourceProvider.setVariableSecureState(SecureStateService.this.fIsSecureMode);
/*     */                   } else {
/* 102 */                     SecureStateService.this.fSourceProvider.setVariableIsSecureEnabled(false);
/*     */                   } 
/*     */                 }
/*     */               } 
/* 106 */             } catch (CoreException e) {
/* 107 */               MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to get project from launch config");
/*     */             } 
/*     */           } 
/*     */         } 
/*     */       }
/*     */     };
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public SecureStateService(DsfSession session) {
/* 121 */     super(session);
/* 122 */     session.addServiceEventListener(this, null);
/*     */   }
/*     */ 
/*     */   
/*     */   protected BundleContext getBundleContext() {
/* 127 */     return MCUDebugPlugin.getBundleContext();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void initialize(final RequestMonitor rm) {
/* 138 */     super.initialize((RequestMonitor)new ImmediateRequestMonitor(rm)
/*     */         {
/*     */           protected void handleSuccess() {
/* 141 */             SecureStateService.this.doInitialize(rm);
/*     */           }
/*     */         });
/*     */   }
/*     */   
/*     */   private void doInitialize(RequestMonitor rm) {
/* 147 */     this.fSourceProvider = SecureSourceProvider.getInstance();
/*     */     
/* 149 */     DebugUITools.getDebugContextManager().addDebugContextListener(this.fDebugContextListener);
/* 150 */     register(new String[] { SecureStateService.class.getName() }, new Hashtable<>());
/* 151 */     rm.done();
/*     */   }
/*     */ 
/*     */   
/*     */   public void shutdown(RequestMonitor rm) {
/* 156 */     getSession().removeServiceEventListener(this);
/* 157 */     unregister();
/* 158 */     super.shutdown(rm);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   @DsfServiceEventHandler
/*     */   public void handleDsfEvent(Object event) {
/* 169 */     if (event instanceof IDMEvent) {
/* 170 */       IDMEvent<?> idmEvent = (IDMEvent)event;
/* 171 */       IDMContext context = idmEvent.getDMContext();
/* 172 */       ILaunch launch = DebugUIPlugin.getLaunch(context);
/* 173 */       if (context instanceof org.eclipse.cdt.dsf.debug.service.IRunControl.IExecutionDMContext) {
/* 174 */         if (idmEvent instanceof org.eclipse.cdt.dsf.debug.service.IRunControl.ISuspendedDMEvent) {
/* 175 */           this.fIsSuspended = true;
/* 176 */           handleSuspendDMEvent(launch);
/* 177 */         } else if (idmEvent instanceof org.eclipse.cdt.dsf.debug.service.IRunControl.IResumedDMEvent) {
/* 178 */           this.fIsSuspended = false;
/* 179 */           handleResumedDMEvent();
/* 180 */         } else if (idmEvent instanceof org.eclipse.cdt.dsf.debug.service.IRunControl.IExitedDMEvent) {
/* 181 */           handleExitedDMEvent();
/*     */         } 
/*     */       }
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void handleSuspendDMEvent(ILaunch launch) {
/* 197 */     if (isTrustZonePresent(launch)) {
/* 198 */       this.fSourceProvider.setVariableIsSecureEnabled(true);
/* 199 */       readMemoryData("0xe000ee08");
/*     */     } else {
/* 201 */       this.fSourceProvider.setVariableIsSecureEnabled(false);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean isTrustZonePresent(ILaunch launch) {
/*     */     try {
/* 212 */       if (launch != null && launch instanceof MCUGdbLaunch) {
/* 213 */         IProject project = ((MCUGdbLaunch)launch).getProjectFromLaunchConf();
/* 214 */         return hasSecureOrNonSecureNature(project);
/*     */       } 
/* 216 */     } catch (CoreException e) {
/* 217 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to get TrustZone status for project");
/*     */     } 
/*     */     
/* 220 */     return false;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void readMemoryData(String address) {
/* 228 */     DataRequestMonitor<MIDataReadMemoryInfo> rm = new DataRequestMonitor<MIDataReadMemoryInfo>((Executor)getExecutor(), null) {
/*     */         protected void handleCompleted() {
/* 230 */           super.handleCompleted();
/* 231 */           if (isSuccess()) {
/* 232 */             MIDataReadMemoryInfo dataReadInfo = (MIDataReadMemoryInfo)getData();
/* 233 */             if (dataReadInfo != null && 
/* 234 */               !dataReadInfo.isError()) {
/* 235 */               MemoryByte[] miMem = dataReadInfo.getMIMemoryBlock();
/* 236 */               if (miMem.length == 4) {
/* 237 */                 long regVal = miMem[2].getValue();
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */                 
/* 243 */                 SecureStateService.this.fIsSecureMode = ((regVal & 0x1L) == 1L);
/* 244 */                 if (SecureStateService.this.fSourceProvider != null) {
/* 245 */                   SecureStateService.this.fSourceProvider.setVariableSecureState(SecureStateService.this.fIsSecureMode);
/*     */                 }
/*     */               } 
/*     */             } 
/*     */           } 
/*     */         }
/*     */       };
/*     */ 
/*     */     
/* 254 */     IMICommandControl commandControl = (IMICommandControl)getServicesTracker().getService(IMICommandControl.class);
/* 255 */     ICommand<MIDataReadMemoryInfo> createMIDataReadMemory = 
/* 256 */       commandControl.getCommandFactory().createMIDataReadMemory((IDMContext)commandControl.getContext(), 0L, address, 3, 1, 1, 4, null);
/*     */ 
/*     */     
/*     */     try {
/* 260 */       getExecutor().execute(() -> {  });
/* 261 */     } catch (RejectedExecutionException e) {
/* 262 */       MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", e, "Failed execute read memory");
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void handleResumedDMEvent() {
/* 276 */     this.fSourceProvider.setVariableIsSecureEnabled(false);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void handleExitedDMEvent() {
/* 289 */     DebugUITools.getDebugContextManager().removeDebugContextListener(this.fDebugContextListener);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private boolean hasSecureOrNonSecureNature(IProject project) {
/* 304 */     boolean retVal = false;
/* 305 */     if (project != null) {
/*     */       try {
/* 307 */         if (project.hasNature("com.st.stm32cube.ide.mcu.MCUSecureProjectNature") || project.hasNature("com.st.stm32cube.ide.mcu.MCUNonSecureProjectNature")) {
/* 308 */           retVal = true;
/*     */         }
/* 310 */       } catch (CoreException coreException) {}
/*     */     }
/* 312 */     return retVal;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\service\secureState\SecureStateService.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */