/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.common.ui.oss.resources.SWTResourceManager;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.Activator;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.LoadListInfo;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Optional;
/*     */ import org.eclipse.cdt.managedbuilder.core.IConfiguration;
/*     */ import org.eclipse.cdt.managedbuilder.core.IManagedBuildInfo;
/*     */ import org.eclipse.cdt.managedbuilder.core.ManagedBuildManager;
/*     */ import org.eclipse.cdt.managedbuilder.macros.BuildMacroException;
/*     */ import org.eclipse.core.resources.IProject;
/*     */ import org.eclipse.core.resources.IResource;
/*     */ import org.eclipse.core.resources.ResourcesPlugin;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IPath;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.jface.dialogs.Dialog;
/*     */ import org.eclipse.jface.dialogs.MessageDialog;
/*     */ import org.eclipse.jface.layout.GridDataFactory;
/*     */ import org.eclipse.jface.layout.GridLayoutFactory;
/*     */ import org.eclipse.jface.viewers.ArrayContentProvider;
/*     */ import org.eclipse.jface.viewers.IBaseLabelProvider;
/*     */ import org.eclipse.jface.viewers.IContentProvider;
/*     */ import org.eclipse.jface.viewers.ILabelProviderListener;
/*     */ import org.eclipse.jface.viewers.ISelection;
/*     */ import org.eclipse.jface.viewers.IStructuredSelection;
/*     */ import org.eclipse.jface.viewers.ITableLabelProvider;
/*     */ import org.eclipse.jface.viewers.TableViewer;
/*     */ import org.eclipse.swt.events.ModifyEvent;
/*     */ import org.eclipse.swt.events.ModifyListener;
/*     */ import org.eclipse.swt.events.MouseAdapter;
/*     */ import org.eclipse.swt.events.MouseEvent;
/*     */ import org.eclipse.swt.events.MouseListener;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.graphics.Image;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Combo;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Control;
/*     */ import org.eclipse.swt.widgets.FileDialog;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Shell;
/*     */ import org.eclipse.swt.widgets.Table;
/*     */ import org.eclipse.swt.widgets.TableColumn;
/*     */ import org.eclipse.swt.widgets.Text;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class LoadListWidget
/*     */ {
/*     */   public static final String EMPTY_STRING = "";
/*     */   protected TableViewer fLoadListViewer;
/*  68 */   protected List<LoadListInfo.LoadListItem> fLoadListItems = new ArrayList<>();
/*     */   private Runnable fUpdateTab;
/*     */   
/*     */   public LoadListWidget(Composite parent, boolean onlyEditButton, Runnable updateTab) {
/*  72 */     this.fUpdateTab = updateTab;
/*  73 */     final Composite baseComposite = new Composite(parent, 0);
/*  74 */     GridLayoutFactory.fillDefaults()
/*  75 */       .numColumns(2)
/*  76 */       .applyTo(baseComposite);
/*  77 */     GridDataFactory.fillDefaults()
/*  78 */       .grab(true, false)
/*  79 */       .applyTo((Control)baseComposite);
/*     */     
/*  81 */     this.fLoadListViewer = new TableViewer(baseComposite, 67584);
/*  82 */     Table table = this.fLoadListViewer.getTable();
/*  83 */     TableColumn tc = new TableColumn(table, 0);
/*  84 */     tc.setText("File");
/*  85 */     tc.setWidth(350);
/*     */     
/*  87 */     tc = new TableColumn(table, 0);
/*  88 */     tc.setText("Build");
/*  89 */     tc.setWidth(100);
/*     */     
/*  91 */     tc = new TableColumn(table, 0);
/*  92 */     tc.setText("Download");
/*  93 */     tc.setWidth(100);
/*     */     
/*  95 */     tc = new TableColumn(table, 0);
/*  96 */     tc.setText("Load symbols");
/*  97 */     tc.setWidth(100);
/*     */     
/*  99 */     table.setHeaderVisible(true);
/* 100 */     table.setLinesVisible(true);
/*     */     
/* 102 */     this.fLoadListViewer.setContentProvider((IContentProvider)new ArrayContentProvider()
/*     */         {
/*     */           public Object[] getElements(Object inputElement) {
/* 105 */             if (inputElement instanceof List) {
/* 106 */               return ((List)inputElement).stream().filter(LoadListInfo.LoadListItem::isValid).toArray();
/*     */             }
/* 108 */             return new Object[0];
/*     */           }
/*     */         });
/* 111 */     this.fLoadListViewer.setLabelProvider((IBaseLabelProvider)new LoadListLabelProvider(null));
/* 112 */     this.fLoadListViewer.setInput(this.fLoadListItems);
/*     */     
/* 114 */     table.addMouseListener((MouseListener)new MouseAdapter()
/*     */         {
/*     */           public void mouseDoubleClick(MouseEvent e) {
/* 117 */             ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 118 */             if (selection != null && selection instanceof IStructuredSelection) {
/* 119 */               IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 120 */               Object o = structSelect.getFirstElement();
/* 121 */               if (o instanceof LoadListInfo.LoadListItem) {
/* 122 */                 LoadListInfo.LoadListItem toEdit = (LoadListInfo.LoadListItem)o;
/* 123 */                 int pos = LoadListWidget.this.fLoadListItems.indexOf(toEdit);
/* 124 */                 if (pos >= 0 && pos < LoadListWidget.this.fLoadListItems.size()) {
/* 125 */                   LoadListWidget.EditLoadDialog dialog = new LoadListWidget.EditLoadDialog(baseComposite.getShell(), toEdit);
/* 126 */                   if (dialog.open() == 0) {
/* 127 */                     LoadListInfo.LoadListItem result = dialog.getResult().orElse(null);
/* 128 */                     if (result != null) {
/* 129 */                       LoadListWidget.this.fLoadListItems.remove(pos);
/* 130 */                       LoadListWidget.this.fLoadListItems.add(pos, result);
/*     */                     } 
/*     */                   } 
/*     */                 } 
/*     */               } 
/*     */             } 
/*     */ 
/*     */             
/* 138 */             LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 139 */             LoadListWidget.this.fUpdateTab.run();
/*     */           }
/*     */         });
/*     */     
/* 143 */     GridDataFactory.fillDefaults()
/* 144 */       .grab(true, true)
/* 145 */       .applyTo((Control)table);
/*     */     
/* 147 */     Composite right = new Composite(baseComposite, 0);
/* 148 */     GridLayoutFactory.fillDefaults().applyTo(right);
/* 149 */     GridDataFactory.fillDefaults().applyTo((Control)right);
/*     */     
/* 151 */     if (!onlyEditButton) {
/* 152 */       Button button = new Button(right, 0);
/* 153 */       button.setText("Add...");
/* 154 */       GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)button);
/* 155 */       button.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 158 */               LoadListWidget.EditLoadDialog dialog = new LoadListWidget.EditLoadDialog(baseComposite.getShell(), null);
/* 159 */               if (dialog.open() == 0) {
/* 160 */                 LoadListInfo.LoadListItem result = dialog.getResult().orElse(null);
/* 161 */                 if (result != null) {
/* 162 */                   LoadListWidget.this.fLoadListItems.add(0, result);
/*     */                 }
/*     */               } 
/*     */ 
/*     */ 
/*     */               
/* 168 */               LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 169 */               LoadListWidget.this.fUpdateTab.run();
/*     */             }
/*     */           });
/*     */     } 
/*     */     
/* 174 */     Button b = new Button(right, 0);
/* 175 */     b.setText("Edit...");
/* 176 */     GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)b);
/* 177 */     b.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/* 180 */             ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 181 */             if (selection != null && selection instanceof IStructuredSelection) {
/* 182 */               IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 183 */               Object o = structSelect.getFirstElement();
/* 184 */               if (o instanceof LoadListInfo.LoadListItem) {
/* 185 */                 LoadListInfo.LoadListItem toEdit = (LoadListInfo.LoadListItem)o;
/* 186 */                 int pos = LoadListWidget.this.fLoadListItems.indexOf(toEdit);
/* 187 */                 if (pos >= 0 && pos < LoadListWidget.this.fLoadListItems.size()) {
/* 188 */                   LoadListWidget.EditLoadDialog dialog = new LoadListWidget.EditLoadDialog(baseComposite.getShell(), toEdit);
/* 189 */                   if (dialog.open() == 0) {
/* 190 */                     LoadListInfo.LoadListItem result = dialog.getResult().orElse(null);
/* 191 */                     if (result != null) {
/* 192 */                       LoadListWidget.this.fLoadListItems.remove(pos);
/* 193 */                       LoadListWidget.this.fLoadListItems.add(pos, result);
/*     */                     } 
/*     */                   } 
/*     */                 } 
/*     */               } 
/*     */             } 
/*     */ 
/*     */             
/* 201 */             LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 202 */             LoadListWidget.this.fUpdateTab.run();
/*     */           }
/*     */         });
/*     */     
/* 206 */     if (!onlyEditButton) {
/* 207 */       final Button removeButton = new Button(right, 0);
/* 208 */       removeButton.setText("Remove");
/* 209 */       GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)removeButton);
/* 210 */       removeButton.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 213 */               ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 214 */               if (selection != null && selection instanceof IStructuredSelection) {
/* 215 */                 IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 216 */                 Object o = structSelect.getFirstElement();
/* 217 */                 if (o instanceof LoadListInfo.LoadListItem) {
/* 218 */                   LoadListInfo.LoadListItem toRemove = (LoadListInfo.LoadListItem)o;
/*     */                   
/* 220 */                   if (toRemove.isFromMainTab().booleanValue()) {
/*     */                     return;
/*     */                   }
/*     */                   
/* 224 */                   int pos = LoadListWidget.this.fLoadListItems.indexOf(toRemove);
/* 225 */                   if (pos >= 0 && pos < LoadListWidget.this.fLoadListItems.size()) {
/* 226 */                     LoadListWidget.this.fLoadListItems.remove(pos);
/*     */                   }
/*     */                 } 
/*     */               } 
/* 230 */               LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 231 */               LoadListWidget.this.fUpdateTab.run();
/*     */             }
/*     */           });
/*     */       
/* 235 */       b = new Button(right, 0);
/* 236 */       b.setText("Move up");
/* 237 */       GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)b);
/* 238 */       b.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 241 */               ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 242 */               if (selection != null && selection instanceof IStructuredSelection) {
/* 243 */                 IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 244 */                 Object o = structSelect.getFirstElement();
/* 245 */                 if (o instanceof LoadListInfo.LoadListItem) {
/* 246 */                   LoadListInfo.LoadListItem toMove = (LoadListInfo.LoadListItem)o;
/* 247 */                   int pos = LoadListWidget.this.fLoadListItems.indexOf(toMove);
/* 248 */                   if (pos > 0) {
/*     */                     
/* 250 */                     LoadListWidget.this.fLoadListItems.remove(pos);
/* 251 */                     LoadListWidget.this.fLoadListItems.add(pos - 1, toMove);
/*     */                   } 
/*     */                 } 
/*     */               } 
/* 255 */               LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 256 */               LoadListWidget.this.fUpdateTab.run();
/*     */             }
/*     */           });
/*     */       
/* 260 */       b = new Button(right, 0);
/* 261 */       b.setText("Move down");
/* 262 */       GridDataFactory.fillDefaults().grab(true, false).applyTo((Control)b);
/* 263 */       b.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 266 */               ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 267 */               if (selection != null && selection instanceof IStructuredSelection) {
/* 268 */                 IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 269 */                 Object o = structSelect.getFirstElement();
/* 270 */                 if (o instanceof LoadListInfo.LoadListItem) {
/* 271 */                   LoadListInfo.LoadListItem toMove = (LoadListInfo.LoadListItem)o;
/* 272 */                   int pos = LoadListWidget.this.fLoadListItems.indexOf(toMove);
/* 273 */                   if (pos >= 0 && pos < LoadListWidget.this.fLoadListItems.size() - 1) {
/*     */                     
/* 275 */                     LoadListWidget.this.fLoadListItems.remove(pos);
/* 276 */                     LoadListWidget.this.fLoadListItems.add(pos + 1, toMove);
/*     */                   } 
/*     */                 } 
/*     */               } 
/* 280 */               LoadListWidget.this.fLoadListViewer.setInput(LoadListWidget.this.fLoadListItems);
/* 281 */               LoadListWidget.this.fUpdateTab.run();
/*     */             }
/*     */           });
/*     */       
/* 285 */       table.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 288 */               boolean removeEnabled = true;
/* 289 */               ISelection selection = LoadListWidget.this.fLoadListViewer.getSelection();
/* 290 */               if (selection != null && selection instanceof IStructuredSelection) {
/* 291 */                 IStructuredSelection structSelect = (IStructuredSelection)selection;
/* 292 */                 Object o = structSelect.getFirstElement();
/* 293 */                 if (o instanceof LoadListInfo.LoadListItem) {
/* 294 */                   LoadListInfo.LoadListItem selected = (LoadListInfo.LoadListItem)o;
/* 295 */                   removeEnabled = !selected.isFromMainTab().booleanValue();
/*     */                 } 
/*     */               } 
/* 298 */               removeButton.setEnabled(removeEnabled);
/*     */             }
/*     */           });
/*     */     } 
/*     */   }
/*     */   
/*     */   public void initializeFrom(ILaunchConfiguration configuration, String programPath, String projectName) throws CoreException {
/* 305 */     this.fLoadListItems.clear();
/* 306 */     LoadListInfo loadListInfo = LoadListInfo.parseLoadListInfo(configuration.getAttributes()).orElse(null);
/* 307 */     if (loadListInfo != null) {
/* 308 */       this.fLoadListItems = loadListInfo.getInternalItems();
/*     */     }
/*     */     
/* 311 */     if (this.fLoadListItems.isEmpty()) {
/* 312 */       String buildConfigId = null;
/* 313 */       this.fLoadListItems.add(new LoadListInfo.LoadListItem(true, programPath, null, null, projectName, buildConfigId, Boolean.valueOf(true), Boolean.valueOf(true), Boolean.valueOf(true)));
/*     */     } else {
/*     */       
/* 316 */       for (LoadListInfo.LoadListItem item : this.fLoadListItems) {
/* 317 */         if (item.isFromMainTab().booleanValue()) {
/* 318 */           item.setPath(programPath);
/* 319 */           item.setProjectName(projectName);
/*     */           break;
/*     */         } 
/*     */       } 
/*     */     } 
/* 324 */     this.fLoadListViewer.setInput(this.fLoadListItems);
/*     */   }
/*     */ 
/*     */   
/*     */   private class LoadListLabelProvider
/*     */     implements ITableLabelProvider
/*     */   {
/*     */     private LoadListLabelProvider() {}
/*     */ 
/*     */     
/*     */     public void addListener(ILabelProviderListener listener) {}
/*     */ 
/*     */     
/*     */     public void dispose() {}
/*     */ 
/*     */     
/*     */     public boolean isLabelProperty(Object element, String property) {
/* 341 */       return false;
/*     */     }
/*     */ 
/*     */ 
/*     */ 
/*     */     
/*     */     public void removeListener(ILabelProviderListener listener) {}
/*     */ 
/*     */ 
/*     */     
/*     */     public Image getColumnImage(Object element, int columnIndex) {
/* 352 */       String text = getColumnText(element, columnIndex);
/* 353 */       if (text != null && columnIndex >= 1 && columnIndex <= 3) {
/* 354 */         if (text.equals("true"))
/* 355 */           return SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/true.png"); 
/* 356 */         if (text.equals("false")) {
/* 357 */           return SWTResourceManager.getImage(Activator.getDefault().getBundle(), "loadlist/false.png");
/*     */         }
/*     */       } 
/*     */ 
/*     */ 
/*     */       
/* 363 */       if (columnIndex == 0 && 
/* 364 */         element instanceof LoadListInfo.LoadListItem) {
/* 365 */         int index = LoadListWidget.this.fLoadListItems.indexOf(element);
/* 366 */         if (index >= 0 && (
/* 367 */           (LoadListInfo.LoadListItem)element).shouldDownload().booleanValue()) {
/*     */           
/* 369 */           for (int i = index + 1; i < LoadListWidget.this.fLoadListItems.size(); i++) {
/* 370 */             if (((LoadListInfo.LoadListItem)LoadListWidget.this.fLoadListItems.get(i)).shouldDownload().booleanValue()) {
/* 371 */               return null;
/*     */             }
/*     */           } 
/* 374 */           return GDBJtagImages.getStartupTabImage();
/*     */         } 
/*     */       } 
/*     */ 
/*     */       
/* 379 */       return null;
/*     */     }
/*     */ 
/*     */     
/*     */     public String getColumnText(Object element, int columnIndex) {
/* 384 */       if (element instanceof LoadListInfo.LoadListItem) {
/* 385 */         String path; LoadListInfo.LoadListItem item = (LoadListInfo.LoadListItem)element;
/* 386 */         switch (columnIndex) {
/*     */           case 0:
/* 388 */             path = item.getPath();
/* 389 */             if (item.getProjectName() != null) {
/* 390 */               path = String.valueOf(path) + " [" + item.getProjectName() + "] ";
/*     */             }
/*     */             
/* 393 */             if (item.getDownloadAddress() != null) {
/* 394 */               path = String.valueOf(path) + " @ " + String.format("0x%x", new Object[] { item.getDownloadAddress() });
/*     */             }
/*     */             
/* 397 */             if (item.getSymbolAddress() != null) {
/* 398 */               path = String.valueOf(path) + " symbols @ " + String.format("0x%x", new Object[] { item.getSymbolAddress() });
/*     */             }
/*     */             
/* 401 */             return path;
/*     */           case 1:
/* 403 */             if (item.isFromMainTab().booleanValue()) {
/* 404 */               return "See Main tab";
/*     */             }
/* 406 */             return (String)item.shouldPerformBuild();
/*     */           
/*     */           case 2:
/* 409 */             return (String)item.shouldDownload();
/*     */           case 3:
/* 411 */             return (String)item.shouldLoadSymbols();
/*     */         } 
/*     */       } 
/* 414 */       return "";
/*     */     }
/*     */   }
/*     */   
/*     */   private class EditLoadDialog
/*     */     extends Dialog
/*     */   {
/*     */     private static final String USE_ACTIVE_BUILD_CONFIGURATION = "Use Active";
/* 422 */     private LoadListInfo.LoadListItem fResult = null;
/*     */     
/* 424 */     private LoadListInfo.LoadListItem fEditThis = null;
/*     */     
/*     */     private Label fTopLabel;
/*     */     private Text fProgramPath;
/*     */     private Text fDownloadOffset;
/*     */     private Text fSymbolAddress;
/*     */     private Combo fProjectName;
/*     */     private Combo fBuildConfigName;
/*     */     private Button fPerformBuild;
/*     */     private Button fDownload;
/*     */     private Button fLoadSymbols;
/*     */     
/*     */     protected EditLoadDialog(Shell parentShell, LoadListInfo.LoadListItem editThis) {
/* 437 */       super(parentShell);
/* 438 */       this.fEditThis = editThis;
/*     */     }
/*     */ 
/*     */     
/*     */     protected boolean isResizable() {
/* 443 */       return true;
/*     */     }
/*     */ 
/*     */     
/*     */     protected Control createDialogArea(Composite parent) {
/* 448 */       getShell().setText("Add/Edit item");
/*     */       
/* 450 */       Composite composite = (Composite)super.createDialogArea(parent);
/* 451 */       GridLayoutFactory.swtDefaults()
/* 452 */         .numColumns(2)
/* 453 */         .applyTo(composite);
/*     */       
/* 455 */       this.fTopLabel = new Label(composite, 0);
/* 456 */       GridDataFactory.fillDefaults()
/* 457 */         .span(2, 1)
/* 458 */         .applyTo((Control)this.fTopLabel);
/*     */       
/* 460 */       (new Label(composite, 0)).setText("Project:");
/* 461 */       this.fProjectName = new Combo(composite, 8);
/* 462 */       GridDataFactory.fillDefaults()
/* 463 */         .grab(true, false)
/* 464 */         .applyTo((Control)this.fProjectName);
/*     */       
/* 466 */       Label buildConfigurationLabel = new Label(composite, 0);
/* 467 */       buildConfigurationLabel.setText("Build configuration:");
/* 468 */       this.fBuildConfigName = new Combo(composite, 8);
/* 469 */       GridDataFactory.fillDefaults()
/* 470 */         .grab(true, false)
/* 471 */         .applyTo((Control)this.fBuildConfigName);
/*     */       
/* 473 */       (new Label(composite, 0)).setText("Program path:");
/* 474 */       this.fProgramPath = new Text(composite, 2048);
/* 475 */       GridDataFactory.fillDefaults()
/* 476 */         .grab(true, false)
/* 477 */         .applyTo((Control)this.fProgramPath);
/*     */ 
/*     */ 
/*     */       
/* 481 */       Button browseFS = new Button(composite, 0);
/* 482 */       browseFS.setText("File system...");
/*     */       
/* 484 */       this.fPerformBuild = new Button(composite, 32);
/* 485 */       this.fPerformBuild.setText("Perform build");
/* 486 */       GridDataFactory.fillDefaults().span(2, 1).applyTo((Control)this.fPerformBuild);
/*     */       
/* 488 */       Composite downloadComp = new Composite(composite, 0);
/* 489 */       GridLayoutFactory.fillDefaults().numColumns(3).applyTo(downloadComp);
/* 490 */       GridDataFactory.fillDefaults().span(2, 1).grab(true, false).applyTo((Control)downloadComp);
/* 491 */       this.fDownload = new Button(downloadComp, 32);
/* 492 */       this.fDownload.setText("Download");
/* 493 */       GridDataFactory.fillDefaults().span(3, 1).applyTo((Control)this.fDownload);
/*     */ 
/*     */       
/* 496 */       final Label downloadOffsetLabel = new Label(downloadComp, 0);
/* 497 */       downloadOffsetLabel.setText("Use download offset (hex)");
/* 498 */       this.fDownloadOffset = new Text(downloadComp, 2048);
/* 499 */       GridDataFactory.fillDefaults()
/* 500 */         .grab(true, false)
/* 501 */         .applyTo((Control)this.fDownloadOffset);
/*     */       
/* 503 */       Composite symbolComp = new Composite(composite, 0);
/* 504 */       GridLayoutFactory.fillDefaults().numColumns(3).applyTo(symbolComp);
/* 505 */       GridDataFactory.fillDefaults().span(2, 1).grab(true, false).applyTo((Control)symbolComp);
/* 506 */       this.fLoadSymbols = new Button(symbolComp, 32);
/* 507 */       this.fLoadSymbols.setText("Load symbols");
/* 508 */       GridDataFactory.fillDefaults().span(3, 1).applyTo((Control)this.fLoadSymbols);
/*     */ 
/*     */       
/* 511 */       final Label symbolAddressLabel = new Label(symbolComp, 0);
/* 512 */       symbolAddressLabel.setText("Use symbol address (hex)");
/* 513 */       this.fSymbolAddress = new Text(symbolComp, 2048);
/* 514 */       GridDataFactory.fillDefaults()
/* 515 */         .grab(true, false)
/* 516 */         .applyTo((Control)this.fSymbolAddress);
/*     */ 
/*     */       
/* 519 */       List<String> projNames = new ArrayList<>();
/* 520 */       projNames.add(""); byte b; int i; IProject[] arrayOfIProject;
/* 521 */       for (i = (arrayOfIProject = ResourcesPlugin.getWorkspace().getRoot().getProjects()).length, b = 0; b < i; ) { IProject project = arrayOfIProject[b];
/*     */         try {
/* 523 */           if (project.isOpen() && project.hasNature("org.eclipse.cdt.core.cnature")) {
/* 524 */             projNames.add(project.getName());
/*     */           }
/* 526 */         } catch (CoreException e1) {
/* 527 */           MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e1, "Failed to check project nature for load list");
/*     */         }  b++; }
/*     */       
/* 530 */       this.fProjectName.setItems(projNames.<String>toArray(new String[0]));
/*     */ 
/*     */       
/* 533 */       this.fDownload.setSelection(true);
/* 534 */       this.fLoadSymbols.setSelection(true);
/*     */ 
/*     */       
/* 537 */       if (this.fEditThis != null) {
/* 538 */         Map<String, String> buildConfigs = new HashMap<>();
/* 539 */         if (this.fEditThis.getPath() != null) {
/* 540 */           this.fProgramPath.setText(this.fEditThis.getPath());
/*     */         }
/* 542 */         if (this.fEditThis.getProjectName() != null) {
/* 543 */           this.fProjectName.setText(this.fEditThis.getProjectName());
/* 544 */           List<String> configs = new ArrayList<>();
/* 545 */           configs.add("");
/* 546 */           configs.add("Use Active");
/* 547 */           buildConfigs = getBuildConfigIdToNameMap();
/* 548 */           configs.addAll(buildConfigs.values());
/* 549 */           this.fBuildConfigName.setItems(configs.<String>toArray(new String[0]));
/*     */         } 
/* 551 */         if (this.fEditThis.useActiveBuildConfig()) {
/* 552 */           this.fBuildConfigName.setText("Use Active");
/* 553 */         } else if (this.fEditThis.getBuildConfigId() != null) {
/* 554 */           String name = buildConfigs.get(this.fEditThis.getBuildConfigId());
/* 555 */           if (name != null) {
/* 556 */             this.fBuildConfigName.setText(name);
/*     */           }
/*     */         } 
/* 559 */         if (this.fEditThis.getDownloadAddress() != null) {
/* 560 */           this.fDownloadOffset.setText(String.format("0x%x", new Object[] { this.fEditThis.getDownloadAddress() }));
/*     */         }
/* 562 */         if (this.fEditThis.getSymbolAddress() != null) {
/* 563 */           this.fSymbolAddress.setText(String.format("0x%x", new Object[] { this.fEditThis.getSymbolAddress() }));
/*     */         }
/* 565 */         if (this.fEditThis.shouldPerformBuild() != null) {
/* 566 */           this.fPerformBuild.setSelection(this.fEditThis.shouldPerformBuild().booleanValue());
/*     */         }
/* 568 */         if (this.fEditThis.shouldDownload() != null) {
/* 569 */           this.fDownload.setSelection(this.fEditThis.shouldDownload().booleanValue());
/*     */         }
/* 571 */         if (this.fEditThis.shouldLoadSymbols() != null) {
/* 572 */           this.fLoadSymbols.setSelection(this.fEditThis.shouldLoadSymbols().booleanValue());
/*     */         }
/*     */         
/* 575 */         if (this.fEditThis.isFromMainTab().booleanValue()) {
/*     */           
/* 577 */           this.fProgramPath.setEnabled(false);
/* 578 */           this.fProjectName.setEnabled(false);
/* 579 */           this.fBuildConfigName.setEnabled(false);
/* 580 */           this.fBuildConfigName.setVisible(false);
/* 581 */           buildConfigurationLabel.setVisible(false);
/* 582 */           browseFS.setEnabled(false);
/* 583 */           browseFS.setVisible(false);
/* 584 */           this.fPerformBuild.setEnabled(false);
/* 585 */           this.fPerformBuild.setVisible(false);
/*     */         } 
/*     */       } 
/*     */ 
/*     */       
/* 590 */       this.fProjectName.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 593 */               List<String> configs = new ArrayList<>();
/* 594 */               configs.add("");
/* 595 */               configs.add("Use Active");
/* 596 */               configs.addAll(LoadListWidget.EditLoadDialog.this.getBuildConfigIdToNameMap().values());
/* 597 */               LoadListWidget.EditLoadDialog.this.fBuildConfigName.setItems(configs.toArray(new String[0]));
/* 598 */               LoadListWidget.EditLoadDialog.this.fBuildConfigName.setText("Use Active");
/*     */               
/* 600 */               LoadListWidget.EditLoadDialog.this.updateFilePathAndBuild();
/* 601 */               LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */             }
/*     */           });
/*     */       
/* 605 */       this.fBuildConfigName.addModifyListener(new ModifyListener()
/*     */           {
/*     */             public void modifyText(ModifyEvent e)
/*     */             {
/* 609 */               LoadListWidget.EditLoadDialog.this.updateFilePathAndBuild();
/* 610 */               LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */             }
/*     */           });
/*     */       
/* 614 */       browseFS.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 617 */               FileDialog fileDialog = new FileDialog(LoadListWidget.EditLoadDialog.this.getShell());
/* 618 */               fileDialog.setFilterExtensions(new String[] { "*.elf", "*.axf" });
/*     */ 
/*     */               
/* 621 */               String programPath = LoadListInfo.LoadListItem.getAbsolutePath(LoadListWidget.EditLoadDialog.this.fProjectName.getText(), LoadListWidget.EditLoadDialog.this.fProgramPath.getText());
/* 622 */               if (!programPath.isEmpty()) {
/* 623 */                 fileDialog.setFileName(programPath);
/*     */               } else {
/* 625 */                 String path = String.valueOf(ResourcesPlugin.getWorkspace().getRoot().getLocation().toOSString()) + "/";
/* 626 */                 fileDialog.setFilterPath(path);
/*     */               } 
/*     */               
/* 629 */               String result = fileDialog.open();
/* 630 */               if (result != null) {
/* 631 */                 LoadListWidget.EditLoadDialog.this.fProgramPath.setText(result);
/*     */ 
/*     */                 
/* 634 */                 LoadListWidget.EditLoadDialog.this.fBuildConfigName.setItems(new String[] { "" });
/* 635 */                 LoadListWidget.EditLoadDialog.this.fBuildConfigName.setText("");
/* 636 */                 LoadListWidget.EditLoadDialog.this.fProjectName.setText("");
/* 637 */                 LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */               } 
/*     */             }
/*     */           });
/*     */       
/* 642 */       this.fProgramPath.addModifyListener(new ModifyListener()
/*     */           {
/*     */             public void modifyText(ModifyEvent e) {
/* 645 */               LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */             }
/*     */           });
/*     */       
/* 649 */       this.fDownload.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 652 */               LoadListWidget.EditLoadDialog.this.fDownloadOffset.setEnabled(LoadListWidget.EditLoadDialog.this.fDownload.getSelection());
/* 653 */               downloadOffsetLabel.setEnabled(LoadListWidget.EditLoadDialog.this.fDownload.getSelection());
/*     */             }
/*     */           });
/*     */       
/* 657 */       this.fDownloadOffset.addVerifyListener(new HexTextVerifyListener());
/* 658 */       this.fDownloadOffset.addModifyListener(new ModifyListener()
/*     */           {
/*     */             public void modifyText(ModifyEvent e) {
/* 661 */               LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */             }
/*     */           });
/*     */       
/* 665 */       this.fLoadSymbols.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */           {
/*     */             public void widgetSelected(SelectionEvent e) {
/* 668 */               LoadListWidget.EditLoadDialog.this.fSymbolAddress.setEnabled(LoadListWidget.EditLoadDialog.this.fLoadSymbols.getSelection());
/* 669 */               symbolAddressLabel.setEnabled(LoadListWidget.EditLoadDialog.this.fLoadSymbols.getSelection());
/*     */             }
/*     */           });
/*     */       
/* 673 */       this.fSymbolAddress.addVerifyListener(new HexTextVerifyListener());
/* 674 */       this.fSymbolAddress.addModifyListener(new ModifyListener()
/*     */           {
/*     */             public void modifyText(ModifyEvent e) {
/* 677 */               LoadListWidget.EditLoadDialog.this.updateButtons();
/*     */             }
/*     */           });
/*     */       
/* 681 */       updateButtons();
/*     */       
/* 683 */       return (Control)composite;
/*     */     }
/*     */     
/*     */     private void updateFilePathAndBuild() {
/* 687 */       boolean doBuild = false;
/* 688 */       String projectName = this.fProjectName.getText();
/* 689 */       String buildConfigName = this.fBuildConfigName.getText();
/*     */       
/* 691 */       if (projectName != null && !projectName.isEmpty() && buildConfigName != null && !buildConfigName.isEmpty()) {
/* 692 */         IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject(projectName);
/* 693 */         if (project != null) {
/* 694 */           IManagedBuildInfo buildInfo = ManagedBuildManager.getBuildInfo((IResource)project);
/* 695 */           IConfiguration config = null;
/* 696 */           if ("Use Active".equals(buildConfigName)) {
/* 697 */             config = buildInfo.getDefaultConfiguration();
/*     */           } else {
/* 699 */             IConfiguration[] configurations = buildInfo.getManagedProject().getConfigurations(); byte b; int i; IConfiguration[] arrayOfIConfiguration1;
/* 700 */             for (i = (arrayOfIConfiguration1 = configurations).length, b = 0; b < i; ) { IConfiguration c = arrayOfIConfiguration1[b];
/* 701 */               if (c.getName().equals(buildConfigName)) {
/* 702 */                 config = c;
/*     */                 break;
/*     */               } 
/*     */               b++; }
/*     */           
/*     */           } 
/* 708 */           if (config != null) {
/* 709 */             String programPath = "";
/*     */             try {
/* 711 */               programPath = ManagedBuildManager.getBuildMacroProvider().resolveValue("${PWD}/${BuildArtifactFilePrefix}${BuildArtifactFileName}", "", " ", 3, config);
/* 712 */               IPath path = Path.fromOSString(programPath);
/* 713 */               path = path.makeRelativeTo(project.getLocation());
/* 714 */               programPath = path.toPortableString();
/* 715 */             } catch (BuildMacroException e1) {
/* 716 */               MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e1, "Failed to resolve program path from build configuration " + config.getName() + " for project " + project.getName());
/*     */             } 
/* 718 */             this.fProgramPath.setText(programPath);
/*     */             
/* 720 */             doBuild = true;
/*     */           } 
/*     */         } 
/*     */       } 
/*     */ 
/*     */       
/* 726 */       this.fPerformBuild.setEnabled(doBuild);
/* 727 */       this.fPerformBuild.setSelection(doBuild);
/*     */     }
/*     */     
/*     */     private Map<String, String> getBuildConfigIdToNameMap() {
/* 731 */       Map<String, String> idToNameMap = new HashMap<>();
/* 732 */       String projectName = this.fProjectName.getText();
/* 733 */       if (projectName != null && !projectName.isEmpty()) {
/* 734 */         IProject project = ResourcesPlugin.getWorkspace().getRoot().getProject(projectName);
/* 735 */         if (project != null) {
/* 736 */           IManagedBuildInfo buildInfo = ManagedBuildManager.getBuildInfo((IResource)project);
/* 737 */           IConfiguration[] configurations = buildInfo.getManagedProject().getConfigurations(); byte b; int i; IConfiguration[] arrayOfIConfiguration1;
/* 738 */           for (i = (arrayOfIConfiguration1 = configurations).length, b = 0; b < i; ) { IConfiguration config = arrayOfIConfiguration1[b];
/* 739 */             idToNameMap.put(config.getId(), config.getName()); b++; }
/*     */         
/*     */         } 
/*     */       } 
/* 743 */       return idToNameMap;
/*     */     }
/*     */ 
/*     */     
/*     */     protected Control createButtonBar(Composite parent) {
/* 748 */       Control control = super.createButtonBar(parent);
/* 749 */       updateButtons();
/* 750 */       return control;
/*     */     }
/*     */ 
/*     */     
/*     */     protected void okPressed() {
/* 755 */       boolean isFromMainTab = false;
/* 756 */       if (this.fEditThis != null) {
/* 757 */         isFromMainTab = this.fEditThis.isFromMainTab().booleanValue();
/*     */       }
/*     */       
/* 760 */       String programPath = getString(this.fProgramPath);
/* 761 */       String downloadAddress = getString(this.fDownloadOffset);
/* 762 */       String symbolAddress = getString(this.fSymbolAddress);
/* 763 */       String projectName = this.fProjectName.getText();
/* 764 */       String buildConfigName = this.fBuildConfigName.getText();
/* 765 */       boolean useActiveBuildConfig = false;
/* 766 */       String buildConfigId = null;
/* 767 */       if ("Use Active".equals(buildConfigName)) {
/* 768 */         useActiveBuildConfig = true;
/*     */       } else {
/* 770 */         for (Map.Entry<String, String> entry : getBuildConfigIdToNameMap().entrySet()) {
/* 771 */           if (((String)entry.getValue()).equals(buildConfigName)) {
/* 772 */             buildConfigId = entry.getKey();
/*     */             
/*     */             break;
/*     */           } 
/*     */         } 
/*     */       } 
/* 778 */       Integer downloadAddressInteger = null;
/* 779 */       if (downloadAddress != null) {
/* 780 */         String downloadAddressShort = downloadAddress.replace("0x", "").replace("x", "");
/*     */         try {
/* 782 */           downloadAddressInteger = Integer.valueOf(Integer.parseInt(downloadAddressShort, 16));
/* 783 */         } catch (NumberFormatException e) {
/* 784 */           MessageDialog.openWarning(getShell(), "Bad download offset", "The download offset '" + downloadAddress + "' is not a valid HEX address. Value is ignored.");
/*     */         } 
/*     */       } 
/*     */       
/* 788 */       Integer symbolAddressInteger = null;
/* 789 */       if (symbolAddress != null) {
/* 790 */         String symbolAddressShort = symbolAddress.replace("0x", "").replace("x", "");
/*     */         try {
/* 792 */           symbolAddressInteger = Integer.valueOf(Integer.parseInt(symbolAddressShort, 16));
/* 793 */         } catch (NumberFormatException e) {
/* 794 */           MessageDialog.openWarning(getShell(), "Bad symbol address", "The symbol address '" + symbolAddress + "' is not a valid HEX address. Value is ignored.");
/*     */         } 
/*     */       } 
/*     */       
/* 798 */       if (programPath != null && programPath.isEmpty()) {
/* 799 */         programPath = null;
/*     */       }
/* 801 */       if (projectName != null && projectName.isEmpty()) {
/* 802 */         projectName = null;
/*     */       }
/* 804 */       if (buildConfigId != null && buildConfigId.isEmpty()) {
/* 805 */         buildConfigId = null;
/*     */       }
/*     */ 
/*     */       
/* 809 */       if (useActiveBuildConfig) {
/* 810 */         this.fResult = new LoadListInfo.LoadListItem(isFromMainTab, 
/* 811 */             programPath, 
/* 812 */             downloadAddressInteger, 
/* 813 */             symbolAddressInteger, 
/* 814 */             projectName, 
/* 815 */             Boolean.valueOf(useActiveBuildConfig), 
/* 816 */             Boolean.valueOf(this.fPerformBuild.getSelection()), 
/* 817 */             Boolean.valueOf(this.fDownload.getSelection()), 
/* 818 */             Boolean.valueOf(this.fLoadSymbols.getSelection()));
/*     */       } else {
/* 820 */         this.fResult = new LoadListInfo.LoadListItem(isFromMainTab, 
/* 821 */             programPath, 
/* 822 */             downloadAddressInteger, 
/* 823 */             symbolAddressInteger, 
/* 824 */             projectName, 
/* 825 */             buildConfigId, 
/* 826 */             Boolean.valueOf(this.fPerformBuild.getSelection()), 
/* 827 */             Boolean.valueOf(this.fDownload.getSelection()), 
/* 828 */             Boolean.valueOf(this.fLoadSymbols.getSelection()));
/*     */       } 
/*     */       
/* 831 */       super.okPressed();
/*     */     }
/*     */     
/*     */     private void updateButtons() {
/* 835 */       boolean enableOk = true;
/*     */       
/* 837 */       List<String> topMsg = new ArrayList<>();
/* 838 */       if (this.fEditThis != null && this.fEditThis.isFromMainTab().booleanValue()) {
/* 839 */         topMsg.add("Some properties of this item can only\nbe changed in the \"Main\" tab.");
/*     */       }
/*     */       
/* 842 */       if (this.fProgramPath.getText().isEmpty()) {
/* 843 */         enableOk = false;
/*     */       }
/*     */       
/* 846 */       if (!isValidHexOrEmpty(this.fDownloadOffset.getText())) {
/* 847 */         enableOk = false;
/*     */       }
/* 849 */       if (!isValidHexOrEmpty(this.fSymbolAddress.getText())) {
/* 850 */         enableOk = false;
/*     */       }
/*     */       
/* 853 */       this.fTopLabel.setText(String.join(" ", (Iterable)topMsg));
/*     */       
/* 855 */       Button okButton = getButton(0);
/* 856 */       if (okButton != null) {
/* 857 */         okButton.setEnabled(enableOk);
/*     */       }
/*     */     }
/*     */     
/*     */     private boolean isValidHexOrEmpty(String address) {
/* 862 */       if (address != null) {
/* 863 */         address = address.replace("0x", "").replace("x", "");
/*     */         try {
/* 865 */           if (!address.isEmpty()) {
/* 866 */             Integer.parseInt(address, 16);
/*     */           }
/* 868 */         } catch (NumberFormatException e) {
/* 869 */           return false;
/*     */         } 
/*     */       } 
/* 872 */       return true;
/*     */     }
/*     */     
/*     */     private String getString(Text textWidget) {
/* 876 */       String tmp = textWidget.getText();
/* 877 */       if (tmp != null) {
/* 878 */         tmp = tmp.trim();
/* 879 */         if (tmp.isEmpty()) {
/* 880 */           return null;
/*     */         }
/*     */       } 
/* 883 */       return tmp;
/*     */     }
/*     */     
/*     */     public Optional<LoadListInfo.LoadListItem> getResult() {
/* 887 */       return Optional.ofNullable(this.fResult);
/*     */     }
/*     */   }
/*     */   
/*     */   public List<LoadListInfo.LoadListItem> getInternalLoadListItems() {
/* 892 */     return this.fLoadListItems;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launc\\ui\LoadListWidget.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */