/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui;
/*     */ 
/*     */ import java.util.ArrayList;
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import java.util.Optional;
/*     */ import org.eclipse.cdt.core.model.IBinary;
/*     */ import org.eclipse.cdt.debug.ui.CDebugUIPlugin;
/*     */ import org.eclipse.core.resources.IContainer;
/*     */ import org.eclipse.core.resources.IFile;
/*     */ import org.eclipse.core.resources.IResource;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.core.runtime.IPath;
/*     */ import org.eclipse.core.runtime.Path;
/*     */ import org.eclipse.core.variables.VariablesPlugin;
/*     */ import org.eclipse.debug.core.DebugPlugin;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationType;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ import org.eclipse.debug.internal.ui.DebugUIPlugin;
/*     */ import org.eclipse.debug.internal.ui.launchConfigurations.LaunchConfigurationPropertiesDialog;
/*     */ import org.eclipse.debug.internal.ui.launchConfigurations.LaunchGroupExtension;
/*     */ import org.eclipse.debug.ui.ILaunchShortcut2;
/*     */ import org.eclipse.jface.viewers.ISelection;
/*     */ import org.eclipse.jface.viewers.IStructuredSelection;
/*     */ import org.eclipse.swt.widgets.Shell;
/*     */ import org.eclipse.ui.IEditorInput;
/*     */ import org.eclipse.ui.IEditorPart;
/*     */ import org.eclipse.ui.IFileEditorInput;
/*     */ import org.eclipse.ui.IWorkbenchWindow;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class MCUDebugLaunchShortcut
/*     */   implements ILaunchShortcut2
/*     */ {
/*     */   protected static Shell getShell() {
/*  53 */     IWorkbenchWindow w = CDebugUIPlugin.getActiveWorkbenchWindow();
/*  54 */     if (w != null) {
/*  55 */       return w.getShell();
/*     */     }
/*  57 */     return null;
/*     */   }
/*     */   
/*     */   protected static ILaunchConfigurationType getLaunchConfigType() {
/*  61 */     return DebugPlugin.getDefault().getLaunchManager().getLaunchConfigurationType("com.st.stm32cube.ide.mcu.debug.launch.launchConfigurationType");
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   protected static boolean createConfiguration(IBinary bin, String mode) {
/*     */     try {
/*     */       LaunchGroupExtension group;
/*  69 */       ILaunchConfigurationType configType = getLaunchConfigType();
/*  70 */       ILaunchConfigurationWorkingCopy wc = configType.newInstance((IContainer)bin.getCProject().getProject(), DebugPlugin.getDefault().getLaunchManager().generateLaunchConfigurationName(bin.getElementName()));
/*  71 */       wc.setAttribute("org.eclipse.cdt.launch.PROGRAM_NAME", bin.getResource().getProjectRelativePath().toString());
/*     */ 
/*     */       
/*  74 */       if ("run".equals(mode)) {
/*  75 */         group = DebugUIPlugin.getDefault().getLaunchConfigurationManager().getLaunchGroup("org.eclipse.debug.ui.launchGroup.run");
/*     */       } else {
/*  77 */         group = DebugUIPlugin.getDefault().getLaunchConfigurationManager().getLaunchGroup("org.eclipse.debug.ui.launchGroup.debug");
/*     */       } 
/*     */       
/*  80 */       LaunchConfigurationPropertiesDialog dialog = new LaunchConfigurationPropertiesDialog(getShell(), (ILaunchConfiguration)wc, group);
/*  81 */       dialog.setDefaultsOnOpen(true);
/*     */ 
/*     */       
/*  84 */       if (dialog.open() == 1) {
/*  85 */         return false;
/*     */       }
/*  87 */       wc.doSave();
/*  88 */       return true;
/*  89 */     } catch (CoreException ce) {
/*  90 */       ce.printStackTrace();
/*  91 */       return false;
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected abstract void searchAndLaunch(Object[] paramArrayOfObject, String paramString);
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void launch(ISelection selection, String mode) {
/* 111 */     if (selection instanceof IStructuredSelection) {
/* 112 */       searchAndLaunch(((IStructuredSelection)selection).toArray(), mode);
/*     */     }
/*     */   }
/*     */ 
/*     */   
/*     */   public void launch(IEditorPart editor, String mode) {
/* 118 */     searchAndLaunch(new Object[] { editor.getEditorInput() }, mode);
/*     */   }
/*     */ 
/*     */   
/*     */   public ILaunchConfiguration[] getLaunchConfigurations(ISelection selection) {
/* 123 */     return null;
/*     */   }
/*     */ 
/*     */   
/*     */   public ILaunchConfiguration[] getLaunchConfigurations(IEditorPart editorpart) {
/* 128 */     return null;
/*     */   }
/*     */ 
/*     */ 
/*     */   
/*     */   public IResource getLaunchableResource(IEditorPart editorpart) {
/* 134 */     IEditorInput editorInput = editorpart.getEditorInput();
/*     */     
/* 136 */     if (editorInput != null && editorInput instanceof IFileEditorInput) {
/* 137 */       IFile file = ((IFileEditorInput)editorInput).getFile();
/*     */       
/* 139 */       if (file != null) {
/* 140 */         return (IResource)file.getProject();
/*     */       }
/*     */     } 
/* 143 */     return null;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private ILaunchConfiguration[] getLaunchConfigurations(ILaunchConfigurationType type) {
/*     */     try {
/* 154 */       return DebugPlugin.getDefault().getLaunchManager().getLaunchConfigurations(type);
/* 155 */     } catch (CoreException e) {
/* 156 */       e.printStackTrace();
/*     */       
/* 158 */       return new ILaunchConfiguration[0];
/*     */     } 
/*     */   }
/*     */   private String getProgramName(ILaunchConfiguration configuration) throws CoreException {
/* 162 */     String programPath = configuration.getAttribute("org.eclipse.cdt.launch.PROGRAM_NAME", null);
/* 163 */     if (programPath != null) {
/* 164 */       programPath = VariablesPlugin.getDefault().getStringVariableManager().performStringSubstitution(programPath, true);
/*     */     }
/* 166 */     return programPath;
/*     */   }
/*     */   
/*     */   private IPath getProgramPath(ILaunchConfiguration config) throws CoreException {
/* 170 */     String path = getProgramName(config);
/* 171 */     if (path == null || path.trim().isEmpty()) {
/* 172 */       return null;
/*     */     }
/* 174 */     return (IPath)new Path(path);
/*     */   }
/*     */   
/*     */   private String getProjectName(ILaunchConfiguration configuration) throws CoreException {
/* 178 */     return configuration.getAttribute("org.eclipse.cdt.launch.PROJECT_ATTR", null);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   protected List<ILaunchConfiguration> findLaunchConfigurations(IBinary bin, String mode) {
/*     */     try {
/* 191 */       ILaunchConfigurationType configType = getLaunchConfigType();
/* 192 */       ILaunchConfiguration[] configs = getLaunchConfigurations(configType);
/* 193 */       List<ILaunchConfiguration> candidateConfigs = new ArrayList<>(configs.length);
/* 194 */       for (int i = 0; i < configs.length; i++) {
/* 195 */         ILaunchConfiguration config = configs[i];
/* 196 */         IPath programPath = getProgramPath(config);
/* 197 */         String projectName = getProjectName(config);
/* 198 */         IPath name = bin.getResource().getProjectRelativePath();
/* 199 */         if (programPath != null && programPath.equals(name) && 
/* 200 */           projectName != null && projectName.equals(bin.getCProject().getProject().getName()))
/*     */         {
/* 202 */           if (((String)Optional.<IFile>ofNullable(config.getFile())
/* 203 */             .map(IResource::getProject)
/* 204 */             .map(IResource::getName)
/* 205 */             .orElse(projectName)).equals(projectName)) {
/* 206 */             candidateConfigs.add(config);
/*     */           }
/*     */         }
/*     */       } 
/*     */       
/* 211 */       return candidateConfigs;
/* 212 */     } catch (CoreException ex) {
/* 213 */       ex.printStackTrace();
/*     */ 
/*     */       
/* 216 */       return Collections.emptyList();
/*     */     } 
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launc\\ui\MCUDebugLaunchShortcut.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */