/*     */ package com.st.stm32cube.ide.mcu.debug.launch.ui;
/*     */ 
/*     */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*     */ import com.st.stm32cube.ide.common.ui.oss.resources.SWTResourceManager;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.Activator;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.GDBServerCommandGroup;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.MCUGdbLaunch;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.RestartListInfo;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.ResetStrategy;
/*     */ import com.st.stm32cube.ide.mcu.debug.launch.device.RestartStrategy;
/*     */ import java.util.ArrayList;
/*     */ import java.util.Arrays;
/*     */ import org.eclipse.core.runtime.CoreException;
/*     */ import org.eclipse.debug.core.ILaunchConfiguration;
/*     */ import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
/*     */ import org.eclipse.jface.dialogs.MessageDialog;
/*     */ import org.eclipse.jface.dialogs.TitleAreaDialog;
/*     */ import org.eclipse.jface.layout.GridDataFactory;
/*     */ import org.eclipse.swt.events.SelectionAdapter;
/*     */ import org.eclipse.swt.events.SelectionEvent;
/*     */ import org.eclipse.swt.events.SelectionListener;
/*     */ import org.eclipse.swt.layout.GridData;
/*     */ import org.eclipse.swt.layout.GridLayout;
/*     */ import org.eclipse.swt.widgets.Button;
/*     */ import org.eclipse.swt.widgets.Combo;
/*     */ import org.eclipse.swt.widgets.Composite;
/*     */ import org.eclipse.swt.widgets.Control;
/*     */ import org.eclipse.swt.widgets.Event;
/*     */ import org.eclipse.swt.widgets.Label;
/*     */ import org.eclipse.swt.widgets.Layout;
/*     */ import org.eclipse.swt.widgets.List;
/*     */ import org.eclipse.swt.widgets.Shell;
/*     */ import org.eclipse.swt.widgets.Text;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class RestartConfigurationsDialog
/*     */   extends TitleAreaDialog
/*     */ {
/*     */   private static final String EMPTY_STRING = "";
/*     */   private static final String DIALOG_TITLE = "Restart configurations";
/*     */   private static final String DIALOG_MESSAGE = "Reset and restart configurations";
/*     */   private static final String SAVE_CHANGE = "Save Changes";
/*     */   private static final String SAVE_MESSAGE_DIALOG = "The restart configuration \"%s\" has unsaved changes. Do you wish to save them?";
/*     */   private MCUGdbLaunch fGdbLaunch;
/*     */   private List fListConf;
/*     */   private Button fAddButton;
/*     */   private Button fDelButton;
/*     */   private Button fDupButton;
/*     */   private Button fApplyButton;
/*  62 */   private String fCurrentRestart = "";
/*     */ 
/*     */   
/*     */   private Text fConfNameText;
/*     */ 
/*     */   
/*     */   private Combo fResetTypeCombo;
/*     */ 
/*     */   
/*     */   private Text fAdditionalCmdText;
/*     */ 
/*     */   
/*     */   private Button fStartApplicationButton;
/*     */ 
/*     */   
/*     */   private ArrayList<RestartStrategy> fRestartStrategies;
/*     */ 
/*     */ 
/*     */   
/*     */   public RestartConfigurationsDialog(Shell parent, MCUGdbLaunch launch) {
/*  82 */     super(parent);
/*  83 */     this.fGdbLaunch = launch;
/*  84 */     doInitialize();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void doInitialize() {
/*  91 */     this.fRestartStrategies = new ArrayList<>();
/*  92 */     ILaunchConfiguration launchConf = this.fGdbLaunch.getLaunchConfiguration();
/*  93 */     if (launchConf != null) {
/*     */       
/*     */       try {
/*  96 */         RestartListInfo restartListInfo = RestartListInfo.parseRestartListInfo(launchConf).orElse(null);
/*  97 */         if (restartListInfo != null) {
/*  98 */           this.fRestartStrategies = restartListInfo.getInternalItems();
/*     */         }
/* 100 */       } catch (CoreException e) {
/* 101 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to parse restart list information from the debug configuration");
/*     */         return;
/*     */       } 
/*     */     }
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public void create() {
/* 115 */     super.create();
/* 116 */     getShell().setText("Restart configurations");
/* 117 */     setTitle("Reset and restart configurations");
/* 118 */     getTitleImageLabel().setImage(SWTResourceManager.getImage(Activator.getDefault().getBundle(), "restartConfiguration/restart_wizban.png"));
/* 119 */     setDefault();
/*     */   }
/*     */ 
/*     */   
/*     */   protected Control createDialogArea(Composite parent) {
/* 124 */     Composite container = (Composite)super.createDialogArea(parent);
/*     */     
/* 126 */     Composite dialogAreaComposite = new Composite(container, 2048);
/* 127 */     dialogAreaComposite.setLayoutData(new GridData(4, 4, true, true));
/* 128 */     dialogAreaComposite.setLayout((Layout)new GridLayout(3, true));
/*     */     
/* 130 */     createLeftDialogArea(dialogAreaComposite);
/* 131 */     createRightDialogArea(dialogAreaComposite);
/* 132 */     createListeners();
/*     */     
/* 134 */     return (Control)dialogAreaComposite;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void createLeftDialogArea(Composite composite) {
/* 148 */     Composite leftComposite = new Composite(composite, 2048);
/* 149 */     GridData leftGd = new GridData(4, 4, true, true);
/* 150 */     leftComposite.setLayoutData(leftGd);
/* 151 */     leftComposite.setLayout((Layout)new GridLayout(3, true));
/*     */ 
/*     */     
/* 154 */     this.fAddButton = new Button(leftComposite, 0);
/* 155 */     this.fAddButton.setImage(SWTResourceManager.getImage(Activator.getDefault().getBundle(), "restartConfiguration/new.png"));
/* 156 */     this.fAddButton.setToolTipText("New restart configuration");
/* 157 */     GridDataFactory.fillDefaults().applyTo((Control)this.fAddButton);
/*     */     
/* 159 */     this.fDupButton = new Button(leftComposite, 0);
/* 160 */     this.fDupButton.setImage(SWTResourceManager.getImage(Activator.getDefault().getBundle(), "restartConfiguration/duplicate.png"));
/* 161 */     this.fDupButton.setToolTipText("Duplicates selected restart configuration");
/* 162 */     GridDataFactory.fillDefaults().applyTo((Control)this.fDupButton);
/*     */     
/* 164 */     this.fDelButton = new Button(leftComposite, 0);
/* 165 */     this.fDelButton.setImage(SWTResourceManager.getImage(Activator.getDefault().getBundle(), "restartConfiguration/delete.png"));
/* 166 */     this.fDelButton.setToolTipText("Delete selected launch configuration");
/* 167 */     GridDataFactory.fillDefaults().applyTo((Control)this.fDelButton);
/*     */ 
/*     */     
/* 170 */     this.fListConf = new List(leftComposite, 2562);
/* 171 */     GridData gd = new GridData(4, 4, true, true);
/* 172 */     gd.horizontalSpan = 3;
/* 173 */     this.fListConf.setLayoutData(gd);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void createRightDialogArea(Composite composite) {
/* 187 */     Composite rightComposite = new Composite(composite, 2048);
/* 188 */     GridData rightGd = new GridData(4, 4, true, true);
/* 189 */     rightGd.horizontalSpan = 2;
/* 190 */     rightComposite.setLayoutData(rightGd);
/* 191 */     rightComposite.setLayout((Layout)new GridLayout(2, false));
/*     */ 
/*     */     
/* 194 */     Label confNameLabel = new Label(rightComposite, 0);
/* 195 */     confNameLabel.setText("Name");
/* 196 */     confNameLabel.setToolTipText("Reset and restart configuration name");
/* 197 */     this.fConfNameText = new Text(rightComposite, 2112);
/* 198 */     GridDataFactory.fillDefaults().applyTo((Control)this.fConfNameText);
/*     */ 
/*     */     
/* 201 */     Label resetTypeLabel = new Label(rightComposite, 0);
/* 202 */     resetTypeLabel.setText("Type:");
/* 203 */     this.fResetTypeCombo = new Combo(rightComposite, 8);
/* 204 */     GridDataFactory.fillDefaults().applyTo((Control)this.fResetTypeCombo);
/*     */ 
/*     */     
/* 207 */     Label additionalCmdLabel = new Label(rightComposite, 0);
/* 208 */     additionalCmdLabel.setText("Additional commands:");
/* 209 */     GridDataFactory.swtDefaults().span(2, 1).applyTo((Control)additionalCmdLabel);
/* 210 */     this.fAdditionalCmdText = new Text(rightComposite, 2626);
/* 211 */     GridData gd = new GridData(4, 4, true, true, 2, 1);
/* 212 */     gd.heightHint = 200;
/* 213 */     this.fAdditionalCmdText.setLayoutData(gd);
/*     */     
/* 215 */     this.fStartApplicationButton = new Button(rightComposite, 32);
/* 216 */     this.fStartApplicationButton.setText("Start application");
/* 217 */     GridDataFactory.swtDefaults().span(2, 1).applyTo((Control)this.fStartApplicationButton);
/*     */ 
/*     */     
/* 220 */     this.fApplyButton = new Button(rightComposite, 0);
/* 221 */     this.fApplyButton.setText("Apply");
/* 222 */     gd = new GridData(16777224, 4, true, false);
/* 223 */     gd.horizontalSpan = 2;
/* 224 */     gd.widthHint = 92;
/* 225 */     this.fApplyButton.setLayoutData(gd);
/* 226 */     this.fApplyButton.setEnabled(false);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void createListeners() {
/* 240 */     this.fAddButton.addListener(13, e -> {
/*     */           if (saveChangesDialog() == 1) {
/*     */             return;
/*     */           }
/*     */           
/*     */           String name = "New";
/*     */           
/*     */           this.fRestartStrategies.add(0, new RestartStrategy(name, true, ((RestartStrategy)this.fRestartStrategies.get(0)).getResetAttribute(), ((RestartStrategy)this.fRestartStrategies.get(0)).getResetStrategies()));
/*     */           this.fListConf.setItems((String[])this.fRestartStrategies.stream().map(()).toArray(()));
/*     */           this.fListConf.setSelection(0);
/*     */           restartConfigurationChanged(name);
/*     */         });
/* 252 */     this.fDupButton.addListener(13, e -> {
/*     */           if (saveChangesDialog() == 1) {
/*     */             return;
/*     */           }
/*     */           
/*     */           RestartStrategy restartStrategy = RestartStrategy.find(this.fListConf.getSelection()[0], this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/*     */           
/*     */           if (restartStrategy != null) {
/*     */             this.fRestartStrategies.add(0, RestartStrategy.duplicate(restartStrategy));
/*     */             this.fListConf.setItems((String[])this.fRestartStrategies.stream().map(()).toArray(()));
/*     */             this.fListConf.setSelection(0);
/*     */             restartConfigurationChanged(this.fListConf.getSelection()[0]);
/*     */           } 
/*     */         });
/* 266 */     this.fDelButton.addListener(13, e -> {
/*     */           RestartStrategy restartStrategy = RestartStrategy.find(this.fListConf.getSelection()[0], this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/*     */           
/*     */           if (restartStrategy == null) {
/*     */             MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "Failed to delete the restart configuration named: " + this.fListConf.getSelection()[0]);
/*     */             
/*     */             return;
/*     */           } 
/*     */           
/*     */           if (restartStrategy.isSuppressible()) {
/*     */             this.fRestartStrategies.remove(restartStrategy);
/*     */             
/*     */             int index = this.fListConf.getSelectionIndex();
/*     */             this.fListConf.remove(index);
/*     */             this.fListConf.setSelection((index == 0) ? index : (index - 1));
/*     */             restartConfigurationChanged(this.fListConf.getSelection()[0]);
/*     */           } 
/*     */         });
/* 284 */     this.fListConf.addListener(13, e -> {
/*     */           if (saveChangesDialog() == 1) {
/*     */             this.fListConf.setSelection(new String[] { this.fCurrentRestart });
/*     */             
/*     */             return;
/*     */           } 
/*     */           
/*     */           restartConfigurationChanged(this.fListConf.getSelection()[0]);
/*     */         });
/*     */     
/* 294 */     this.fConfNameText.addListener(24, e -> updateButtonsList());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 299 */     this.fResetTypeCombo.addListener(13, e -> updateButtonsList());
/*     */ 
/*     */ 
/*     */ 
/*     */     
/* 304 */     this.fAdditionalCmdText.addListener(24, e -> updateButtonsList());
/*     */ 
/*     */ 
/*     */     
/* 308 */     this.fStartApplicationButton.addSelectionListener((SelectionListener)new SelectionAdapter()
/*     */         {
/*     */           public void widgetSelected(SelectionEvent e) {
/* 311 */             RestartConfigurationsDialog.this.updateButtonsList();
/*     */           }
/*     */         });
/*     */ 
/*     */     
/* 316 */     this.fApplyButton.addListener(13, e -> {
/*     */           saveRestartConfiguration();
/*     */           this.fListConf.setItem(this.fListConf.getSelectionIndex(), this.fConfNameText.getText());
/*     */           updateButtonsList();
/*     */         });
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void setDefault() {
/* 333 */     this.fListConf.setItems((String[])this.fRestartStrategies.stream().map(s -> s.getDisplayName()).toArray(paramInt -> new String[paramInt]));
/* 334 */     this.fListConf.setSelection(0);
/* 335 */     restartConfigurationChanged(this.fListConf.getSelection()[0]);
/*     */   }
/*     */   
/*     */   private boolean isEqualToWorkingCopy(RestartStrategy restartStrategy) {
/* 339 */     return (this.fConfNameText.getText().equals(restartStrategy.getDisplayName()) && 
/* 340 */       this.fResetTypeCombo.getText().equals(restartStrategy.getResetAttribute()) && 
/* 341 */       this.fAdditionalCmdText.getText().trim().equals(String.join("", restartStrategy.getGdbCommandGroup().getCommands()).trim()) && 
/* 342 */       this.fStartApplicationButton.getSelection() == restartStrategy.getStartApplication());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private int saveChangesDialog() {
/* 350 */     int returnCode = 0;
/* 351 */     RestartStrategy restartStrategy = RestartStrategy.find(this.fCurrentRestart, this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/* 352 */     if (restartStrategy != null && !isEqualToWorkingCopy(restartStrategy)) {
/*     */       
/* 354 */       MessageDialog dialog = new MessageDialog(getShell(), "Save Changes", null, 
/* 355 */           String.format("The restart configuration \"%s\" has unsaved changes. Do you wish to save them?", new Object[] { this.fCurrentRestart
/* 356 */             }), 2, new String[] { "Save", 
/* 357 */             "Don't save", "Cancel" }, 0);
/* 358 */       switch (dialog.open()) {
/*     */         
/*     */         case 0:
/* 361 */           saveRestartConfiguration();
/*     */           break;
/*     */         
/*     */         case 2:
/* 365 */           returnCode = 1;
/*     */           break;
/*     */       } 
/*     */ 
/*     */     
/*     */     } 
/* 371 */     return returnCode;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void updateButtonsList() {
/* 378 */     RestartStrategy restartStrategy = RestartStrategy.find(this.fListConf.getSelection()[0], this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/* 379 */     if (restartStrategy != null) {
/* 380 */       boolean isValid = true;
/* 381 */       if (this.fConfNameText.getText().trim().isEmpty()) {
/* 382 */         setErrorMessage("Name cannot be empty.");
/* 383 */         isValid = false;
/* 384 */       } else if (this.fRestartStrategies.stream().filter(item -> (item != paramRestartStrategy1)).anyMatch(item -> item.getDisplayName().equals(this.fConfNameText.getText().trim()))) {
/* 385 */         setErrorMessage("Name already exists.");
/* 386 */         isValid = false;
/* 387 */       } else if (this.fResetTypeCombo.getText().isEmpty()) {
/* 388 */         setErrorMessage("Type must be selected.");
/* 389 */         isValid = false;
/*     */       } else {
/* 391 */         setErrorMessage(null);
/* 392 */         isValid = true;
/*     */       } 
/*     */       
/* 395 */       this.fDelButton.setEnabled(restartStrategy.isSuppressible());
/* 396 */       this.fApplyButton.setEnabled((isValid && !isEqualToWorkingCopy(restartStrategy)));
/*     */       
/* 398 */       Button okButton = getButton(0);
/* 399 */       okButton.setEnabled(isValid);
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void restartConfigurationChanged(String confName) {
/* 408 */     RestartStrategy restartStrategy = RestartStrategy.find(confName, this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/* 409 */     if (restartStrategy != null) {
/* 410 */       this.fConfNameText.setText(restartStrategy.getDisplayName());
/* 411 */       this.fResetTypeCombo.setItems((String[])restartStrategy.getResetStrategies().stream().map(s -> s.getDisplayName()).toArray(paramInt -> new String[paramInt]));
/* 412 */       this.fResetTypeCombo.select(restartStrategy.getResetStrategies().indexOf(
/* 413 */             ResetStrategy.find(restartStrategy.getResetAttribute(), restartStrategy.getResetStrategies(), ResetStrategy.ResetStrategySearchKey.NAME)));
/* 414 */       this.fAdditionalCmdText.setText(String.join("", restartStrategy.getGdbCommandGroup().getCommands()));
/* 415 */       this.fStartApplicationButton.setSelection(restartStrategy.getStartApplication());
/*     */     } 
/* 417 */     updateCurrentRestartSelected(confName);
/* 418 */     updateButtonsList();
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void updateCurrentRestartSelected(String name) {
/* 426 */     this.fCurrentRestart = name;
/*     */   }
/*     */ 
/*     */   
/*     */   protected boolean isResizable() {
/* 431 */     return true;
/*     */   }
/*     */ 
/*     */   
/*     */   protected void buttonPressed(int buttonId) {
/* 436 */     if (buttonId == 0) {
/* 437 */       saveRestartConfiguration();
/*     */     }
/* 439 */     super.buttonPressed(buttonId);
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void saveRestartConfiguration() {
/* 446 */     RestartStrategy restartStrategy = RestartStrategy.find(this.fCurrentRestart, this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/* 447 */     if (restartStrategy != null) {
/* 448 */       restartStrategy.setDisplayName(this.fConfNameText.getText());
/* 449 */       restartStrategy.setResetAttribute(this.fResetTypeCombo.getText());
/* 450 */       restartStrategy.setStartApplication(this.fStartApplicationButton.getSelection());
/*     */       
/* 452 */       GDBServerCommandGroup gdbServerCommandGroup = new GDBServerCommandGroup("Additional Commands");
/* 453 */       ArrayList<String> cmds = new ArrayList<>(Arrays.asList(this.fAdditionalCmdText.getText().split(System.lineSeparator())));
/* 454 */       cmds.forEach(s -> paramGDBServerCommandGroup.addCommand(s));
/* 455 */       restartStrategy.setGdbCommandGroup(gdbServerCommandGroup);
/* 456 */       updateCurrentRestartSelected(this.fConfNameText.getText());
/*     */ 
/*     */       
/* 459 */       updateHistory();
/* 460 */       storeRestartListInLaunchConfiguration();
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void updateHistory() {
/* 468 */     if (this.fListConf.getSelectionIndex() > 0) {
/*     */       
/* 470 */       String confName = this.fListConf.getItem(this.fListConf.getSelectionIndex());
/* 471 */       RestartStrategy restartStrategy = RestartStrategy.find(confName, this.fRestartStrategies, RestartStrategy.RestartStrategySearchKey.NAME);
/* 472 */       if (restartStrategy != null) {
/* 473 */         this.fRestartStrategies.remove(restartStrategy);
/* 474 */         this.fRestartStrategies.add(0, restartStrategy);
/*     */       } 
/*     */     } 
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   private void storeRestartListInLaunchConfiguration() {
/* 483 */     ILaunchConfiguration launchConf = this.fGdbLaunch.getLaunchConfiguration();
/* 484 */     if (launchConf != null)
/*     */       try {
/* 486 */         ILaunchConfigurationWorkingCopy workingCopy = launchConf.getWorkingCopy();
/* 487 */         RestartListInfo restartListInfo = new RestartListInfo(this.fRestartStrategies);
/* 488 */         workingCopy.setAttribute(RestartListInfo.getRestartConfsAttributeName((ILaunchConfiguration)workingCopy), restartListInfo.asJSON());
/* 489 */         workingCopy.doSave();
/* 490 */       } catch (CoreException e) {
/* 491 */         MCULoggerPlugin.logException("com.st.stm32cube.ide.mcu.debug.launch", (Throwable)e, "Failed to update debug configuration with the new restart configuraitons list");
/*     */       }  
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launc\\ui\RestartConfigurationsDialog.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */