package com.st.stm32cube.ide.mcu.debug.launch;

import com.st.stm32cube.ide.mcu.debug.launch.ui.IDebuggerTab;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import org.eclipse.cdt.dsf.concurrent.RequestMonitor;
import org.eclipse.cdt.dsf.gdb.service.command.IGDBControl;
import org.eclipse.cdt.dsf.service.DsfSession;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.ILaunch;
import org.eclipse.debug.core.ILaunchConfiguration;
import org.eclipse.debug.core.ILaunchConfigurationWorkingCopy;
import org.eclipse.debug.core.model.IProcess;
import org.eclipse.swt.widgets.Composite;

public interface IMxUGDBServer {
  void createControl(Composite paramComposite, IDebuggerTab paramIDebuggerTab);
  
  void initializeFrom(ILaunchConfiguration paramILaunchConfiguration);
  
  void performApply(ILaunchConfigurationWorkingCopy paramILaunchConfigurationWorkingCopy);
  
  void doOnApply(ILaunchConfigurationWorkingCopy paramILaunchConfigurationWorkingCopy);
  
  void setDefaults(ILaunchConfigurationWorkingCopy paramILaunchConfigurationWorkingCopy);
  
  Composite getControl();
  
  String getDefaultIpAddress();
  
  String getDefaultPortNumber();
  
  boolean getAutoStartDefault();
  
  void connectionModeChanged(boolean paramBoolean);
  
  Optional<String> getConfigurationErrorMsg(ILaunchConfiguration paramILaunchConfiguration);
  
  void dispose();
  
  boolean generateServerStartFiles(ILaunchConfiguration paramILaunchConfiguration);
  
  List<String> getServerStartArguments(ILaunchConfiguration paramILaunchConfiguration) throws CoreException;
  
  void doReset(ILaunchConfiguration paramILaunchConfiguration, Collection<String> paramCollection) throws CoreException;
  
  void doRestartInit(ILaunchConfiguration paramILaunchConfiguration) throws CoreException;
  
  void doSetInitCommands(ILaunchConfiguration paramILaunchConfiguration, List<GDBServerCommandGroup> paramList) throws CoreException;
  
  void doSetDebugCommands(ILaunchConfiguration paramILaunchConfiguration, List<GDBServerCommandGroup> paramList) throws CoreException;
  
  boolean isDebugTargetSupported(String paramString1, String paramString2);
  
  boolean isDebugFeatureSupported(DebugFeatureEnum paramDebugFeatureEnum);
  
  void createSWVsession(ILaunchConfiguration paramILaunchConfiguration, IGDBControl paramIGDBControl, DsfSession paramDsfSession, RequestMonitor paramRequestMonitor) throws CoreException;
  
  String getDefaultGdbClient();
  
  String getServerInstallLocation(ILaunchConfiguration paramILaunchConfiguration) throws CoreException;
  
  Map<String, String> getServerStartEnvironment();
  
  String getServerWorkingDir(ILaunchConfiguration paramILaunchConfiguration) throws CoreException;
  
  String getServerPersistentArg();
  
  default void checkSTLinkServer(ILaunch launch) throws CoreException {}
  
  boolean preLaunchCheck(ILaunchConfiguration paramILaunchConfiguration) throws CoreException;
  
  void verifyServer(ILaunchConfiguration paramILaunchConfiguration, IProcess paramIProcess) throws CoreException;
  
  void doSystemResetAndHalt(Collection<String> paramCollection);
  
  void logAnalytics(ILaunchConfiguration paramILaunchConfiguration);
  
  String getRestartConfigurationsAttributName();
}


/* Location:              C:\ST\test\mod\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513\!\com\st\stm32cube\ide\mcu\debug\launch\IMxUGDBServer.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */