/*    */ package com.st.stm32cube.ide.mcu.debug.launch;
/*    */ 
/*    */ import com.st.stm32cube.common.logger.MCULoggerPlugin;
/*    */ import java.util.ArrayList;
/*    */ import java.util.Arrays;
/*    */ import java.util.Collections;
/*    */ import java.util.List;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class LaunchSequenceStepList
/*    */ {
/* 18 */   private final List<String> fSteps = new ArrayList<>();
/*    */   
/*    */   public LaunchSequenceStepList(String[] steps) {
/* 21 */     this.fSteps.addAll(arrayToList(steps));
/*    */   }
/*    */   
/*    */   public boolean addFirst(String... newSteps) {
/* 25 */     return this.fSteps.addAll(0, arrayToList(newSteps));
/*    */   }
/*    */   
/*    */   public boolean addBefore(String existingStep, String... newSteps) {
/* 29 */     return this.fSteps.addAll(indexOf(existingStep), arrayToList(newSteps));
/*    */   }
/*    */   
/*    */   public boolean addAfter(String existingStep, String... newSteps) {
/* 33 */     return this.fSteps.addAll(indexOf(existingStep) + 1, arrayToList(newSteps));
/*    */   }
/*    */   
/*    */   public boolean addLast(String... newSteps) {
/* 37 */     return this.fSteps.addAll(arrayToList(newSteps));
/*    */   }
/*    */   
/*    */   public boolean remove(String existingStep) {
/* 41 */     return this.fSteps.remove(existingStep);
/*    */   }
/*    */   
/*    */   public boolean replace(String existingStep, String newStep) {
/* 45 */     return (addAfter(existingStep, new String[] { newStep }) && this.fSteps.remove(existingStep));
/*    */   }
/*    */ 
/*    */   
/*    */   public void truncateAfter(String existingStep) {
/* 50 */     this.fSteps.subList(indexOf(existingStep) + 1, this.fSteps.size()).clear();
/*    */   }
/*    */   
/*    */   public String[] toArray() {
/* 54 */     return this.fSteps.<String>toArray(new String[this.fSteps.size()]);
/*    */   }
/*    */   
/*    */   private int indexOf(String name) {
/* 58 */     int index = this.fSteps.indexOf(name);
/* 59 */     if (index < 0) {
/* 60 */       MCULoggerPlugin.logErrorMessage("com.st.stm32cube.ide.mcu.debug.launch", "Unable to find " + name);
/* 61 */       index = this.fSteps.size();
/*    */     } 
/* 63 */     return index;
/*    */   }
/*    */   
/*    */   private List<String> arrayToList(String[] array) {
/* 67 */     if (array != null) {
/* 68 */       return Arrays.asList(array);
/*    */     }
/* 70 */     return Collections.emptyList();
/*    */   }
/*    */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\LaunchSequenceStepList.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */