/*    */ package com.st.stm32cube.ide.mcu.debug.launch.device;
/*    */ 
/*    */ import com.st.stm32cube.common.preferences.MCUPreferencesPlugin;
/*    */ import java.util.ArrayList;
/*    */ import java.util.List;
/*    */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.GDBJtagDeviceContribution;
/*    */ import org.eclipse.cdt.debug.gdbjtag.core.jtagdevice.GDBJtagDeviceContributionFactory;
/*    */ import org.eclipse.jface.preference.IPreferenceStore;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class GDBServerContributionFactory
/*    */ {
/*    */   private static final String STLINK_GDB_SERVER_DEVICE_NAME = "ST-LINK (ST-LINK GDB server)";
/*    */   
/*    */   public static List<GDBJtagDeviceContribution> getGDBServerContributions() {
/* 36 */     GDBJtagDeviceContribution[] contributions = GDBJtagDeviceContributionFactory.getInstance().getGDBJtagDeviceContribution();
/* 37 */     List<GDBJtagDeviceContribution> filtered = new ArrayList<>(); byte b; int i; GDBJtagDeviceContribution[] arrayOfGDBJtagDeviceContribution1;
/* 38 */     for (i = (arrayOfGDBJtagDeviceContribution1 = contributions).length, b = 0; b < i; ) { GDBJtagDeviceContribution contribution = arrayOfGDBJtagDeviceContribution1[b];
/* 39 */       if (contribution.getDevice() instanceof com.st.stm32cube.ide.mcu.debug.launch.IMxUGDBServer) {
/* 40 */         filtered.add(contribution);
/*    */       }
/*    */       b++; }
/*    */     
/* 44 */     IPreferenceStore store = null;
/* 45 */     MCUPreferencesPlugin prefPlugin = MCUPreferencesPlugin.getDefault();
/* 46 */     if (prefPlugin != null) {
/* 47 */       store = prefPlugin.getPreferenceStore();
/*    */     }
/* 49 */     String deviceId = (store == null) ? "com.st.stm32cube.ide.mcu.debug.stlink" : store.getString("DebugConf.defaultGdbServer");
/* 50 */     String gdbServer = filtered.stream().filter(contribution -> contribution.getDeviceId().equals(paramString))
/* 51 */       .map(GDBJtagDeviceContribution::getDeviceName)
/* 52 */       .findFirst()
/* 53 */       .orElse("ST-LINK (ST-LINK GDB server)");
/*    */     
/* 55 */     filtered.sort((a, b) -> {
/*    */           String aName = a.getDeviceName();
/*    */           
/*    */           String bName = b.getDeviceName();
/* 59 */           return (aName != null && bName != null) ? (aName.equals(paramString) ? -1 : (bName.equals(paramString) ? 1 : aName.compareTo(bName))) : 0;
/*    */         });
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */     
/* 71 */     return filtered;
/*    */   }
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */   
/*    */   public static GDBJtagDeviceContribution findByName(String deviceName) {
/* 81 */     for (GDBJtagDeviceContribution contribution : getGDBServerContributions()) {
/* 82 */       if (contribution.getDeviceName().equals(deviceName)) {
/* 83 */         return contribution;
/*    */       }
/*    */     } 
/*    */ 
/*    */     
/* 88 */     return null;
/*    */   }
/*    */   
/*    */   public static GDBJtagDeviceContribution findById(String deviceId) {
/* 92 */     for (GDBJtagDeviceContribution contribution : getGDBServerContributions()) {
/* 93 */       if (contribution.getDeviceId().equals(deviceId)) {
/* 94 */         return contribution;
/*    */       }
/*    */     } 
/*    */ 
/*    */     
/* 99 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\device\GDBServerContributionFactory.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */