/*     */ package com.st.stm32cube.ide.mcu.debug.launch.device;
/*     */ 
/*     */ import java.util.Collections;
/*     */ import java.util.List;
/*     */ import java.util.Objects;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ResetStrategy
/*     */ {
/*     */   private String fDisplayName;
/*     */   private String fLaunchAttribute;
/*     */   private List<String> fGdbCommands;
/*     */   private List<String> fCmdOptions;
/*     */   
/*     */   public enum ResetStrategySearchKey
/*     */   {
/*  35 */     NAME,
/*  36 */     ATTRIBUTE;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ResetStrategy(String displayName, String launchAttribute) {
/*  44 */     this(displayName, launchAttribute, Collections.emptyList());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ResetStrategy(String displayName, String launchAttribute, List<String> gdbCommands) {
/*  53 */     this(displayName, launchAttribute, gdbCommands, Collections.emptyList());
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public ResetStrategy(String displayName, String launchAttribute, List<String> gdbCommands, List<String> cmdOptions) {
/*  64 */     Objects.requireNonNull(displayName);
/*  65 */     Objects.requireNonNull(launchAttribute);
/*  66 */     Objects.requireNonNull(gdbCommands);
/*  67 */     Objects.requireNonNull(cmdOptions);
/*     */     
/*  69 */     this.fDisplayName = displayName;
/*  70 */     this.fLaunchAttribute = launchAttribute;
/*  71 */     this.fGdbCommands = gdbCommands;
/*  72 */     this.fCmdOptions = cmdOptions;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getDisplayName() {
/*  81 */     return this.fDisplayName;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public String getLaunchAttribute() {
/*  90 */     return this.fLaunchAttribute;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List<String> getGDBCommands() {
/*  99 */     return this.fGdbCommands;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public List<String> getCmdOptions() {
/* 108 */     return this.fCmdOptions;
/*     */   }
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   
/*     */   public static ResetStrategy find(String key, List<ResetStrategy> strategies, ResetStrategySearchKey keyType) {
/* 120 */     for (ResetStrategy strategy : strategies) {
/* 121 */       switch (keyType) {
/*     */         case null:
/* 123 */           if (strategy.getLaunchAttribute().equals(key)) {
/* 124 */             return strategy;
/*     */           }
/*     */ 
/*     */         
/*     */         case NAME:
/* 129 */           if (strategy.getDisplayName().equals(key)) {
/* 130 */             return strategy;
/*     */           }
/*     */       } 
/*     */ 
/*     */     
/*     */     } 
/* 136 */     return null;
/*     */   }
/*     */ }


/* Location:              C:\ST\test\ori\com.st.stm32cube.ide.mcu.debug.launch_3.0.200.202210191513.jar!\com\st\stm32cube\ide\mcu\debug\launch\device\ResetStrategy.class
 * Java compiler version: 8 (52.0)
 * JD-Core Version:       1.1.3
 */